/* DMListEntry.c generated by valac 0.56.13, the Vala compiler
 * generated from DMListEntry.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include "CbTwitterItem.h"
#include <glib-object.h>
#include <glib.h>
#include "cawbird.h"
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include "CbMedia.h"
#include "CbTypes.h"
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include "CbBundle.h"
#include "CbTextTransform.h"
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>

#define PROFILE_PAGE_KEY_USER_ID 1
#define PROFILE_PAGE_KEY_SCREEN_NAME 0

#define TYPE_DM_LIST_ENTRY (dm_list_entry_get_type ())
#define DM_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DM_LIST_ENTRY, DMListEntry))
#define DM_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DM_LIST_ENTRY, DMListEntryClass))
#define IS_DM_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DM_LIST_ENTRY))
#define IS_DM_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DM_LIST_ENTRY))
#define DM_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DM_LIST_ENTRY, DMListEntryClass))

typedef struct _DMListEntry DMListEntry;
typedef struct _DMListEntryClass DMListEntryClass;
typedef struct _DMListEntryPrivate DMListEntryPrivate;

#define TYPE_MEDIA_BUTTON (media_button_get_type ())
#define MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_BUTTON, MediaButton))
#define MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_BUTTON, MediaButtonClass))
#define IS_MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_BUTTON))
#define IS_MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_BUTTON))
#define MEDIA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_BUTTON, MediaButtonClass))

typedef struct _MediaButton MediaButton;
typedef struct _MediaButtonClass MediaButtonClass;
enum  {
	DM_LIST_ENTRY_0_PROPERTY,
	DM_LIST_ENTRY_IS_CHECKED_PROPERTY,
	DM_LIST_ENTRY_TEXT_PROPERTY,
	DM_LIST_ENTRY_SCREEN_NAME_PROPERTY,
	DM_LIST_ENTRY_NAME_PROPERTY,
	DM_LIST_ENTRY_MEDIA_PROPERTY,
	DM_LIST_ENTRY_MESSAGE_DATA_PROPERTY,
	DM_LIST_ENTRY_AVATAR_PROPERTY,
	DM_LIST_ENTRY_SEEN_PROPERTY,
	DM_LIST_ENTRY_NUM_PROPERTIES
};
static GParamSpec* dm_list_entry_properties[DM_LIST_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
typedef enum  {
	PAGE_STREAM = 0,
	PAGE_MENTIONS,
	PAGE_FAVORITES,
	PAGE_DM_THREADS,
	PAGE_LISTS,
	PAGE_FILTERS,
	PAGE_SEARCH,
	PAGE_PROFILE,
	PAGE_TWEET_INFO,
	PAGE_DM,
	PAGE_LIST_STATUSES,
	PAGE_PREVIOUS = 1024,
	PAGE_NEXT = 2048
} Page;

#define TYPE_PAGE (page_get_type ())
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	DM_LIST_ENTRY_AVATAR_CLICKED_SIGNAL,
	DM_LIST_ENTRY_NUM_SIGNALS
};
static guint dm_list_entry_signals[DM_LIST_ENTRY_NUM_SIGNALS] = {0};

struct _DMListEntry {
	GtkListBoxRow parent_instance;
	DMListEntryPrivate * priv;
	gint64 timestamp;
	gint64 id;
	gint64 user_id;
	MainWindow* main_window;
};

struct _DMListEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _DMListEntryPrivate {
	GtkGrid* grid;
	AvatarWidget* avatar_image;
	GtkCheckButton* delete_checkbutton;
	GtkLabel* text_label;
	GtkLabel* screen_name_label;
	TextButton* name_button;
	GtkLabel* time_delta_label;
	MediaButton* media_button;
	gchar* _text;
	JsonObject* _message_data;
	CbMedia* _media;
	CbTextEntity* _entities;
	gint _entities_length1;
	gint __entities_size_;
	GTimeSpan last_timediff;
};

static gint DMListEntry_private_offset;
static gpointer dm_list_entry_parent_class = NULL;
static CbTwitterItemInterface * dm_list_entry_cb_twitter_item_parent_iface = NULL;

VALA_EXTERN GType dm_list_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType media_button_get_type (void) G_GNUC_CONST ;
static void dm_list_entry_set_dm_text (DMListEntry* self);
static void _dm_list_entry_set_dm_text_g_settings_changed (GSettings* _sender,
                                                    const gchar* key,
                                                    gpointer self);
static void _vala_CbTextEntity_array_free (CbTextEntity * array,
                                    gssize array_length);
VALA_EXTERN void dm_list_entry_set_entities (DMListEntry* self,
                                 CbTextEntity* value,
                                 gint value_length1);
static CbTextEntity* _vala_array_dup10 (CbTextEntity* self,
                                 gssize length);
VALA_EXTERN DMListEntry* dm_list_entry_new (void);
VALA_EXTERN DMListEntry* dm_list_entry_construct (GType object_type);
static gboolean dm_list_entry_avatar_button_release_cb (DMListEntry* self,
                                                 GtkWidget* widget,
                                                 GdkEventButton* event);
static gboolean _dm_list_entry_avatar_button_release_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                  GdkEventButton* event,
                                                                                  gpointer self);
static gboolean _utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                        GdkEventCrossing* event,
                                                                        gpointer self);
static gboolean _utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                        GdkEventCrossing* event,
                                                                        gpointer self);
static gboolean __lambda122_ (DMListEntry* self,
                       const gchar* uri);
VALA_EXTERN gboolean tweet_utils_activate_link (const gchar* uri,
                                    MainWindow* window);
static gboolean ___lambda122__gtk_label_activate_link (GtkLabel* _sender,
                                                const gchar* uri,
                                                gpointer self);
static void __lambda123_ (DMListEntry* self);
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
static void ___lambda123__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static gboolean dm_list_entry_key_released_cb (DMListEntry* self,
                                        GdkEventKey* evt);
static gboolean _dm_list_entry_key_released_cb_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void dm_list_entry_set_dm_text_scale (DMListEntry* self);
static void _dm_list_entry_set_dm_text_scale_g_settings_changed (GSettings* _sender,
                                                          const gchar* key,
                                                          gpointer self);
static void dm_list_entry_set_checked (DMListEntry* self,
                                gboolean checked);
VALA_EXTERN gboolean dm_list_entry_get_is_checked (DMListEntry* self);
VALA_EXTERN void dm_list_entry_load_avatar (DMListEntry* self,
                                const gchar* avatar_url);
static gint dm_list_entry_real_update_time_delta (CbTwitterItem* base,
                                           GDateTime* now);
static gint64 dm_list_entry_real_get_sort_factor (CbTwitterItem* base);
static gint64 dm_list_entry_real_get_timestamp (CbTwitterItem* base);
static GTimeSpan dm_list_entry_real_get_last_set_timediff (CbTwitterItem* base);
static void dm_list_entry_real_set_last_set_timediff (CbTwitterItem* base,
                                               GTimeSpan span);
static void dm_list_entry_media_clicked_cb (DMListEntry* self,
                                     MediaButton* button,
                                     gdouble px,
                                     gdouble py);
VALA_EXTERN CbMedia* dm_list_entry_get_media (DMListEntry* self);
VALA_EXTERN void dm_list_entry_set_is_checked (DMListEntry* self,
                                   gboolean value);
VALA_EXTERN void dm_list_entry_set_text (DMListEntry* self,
                             const gchar* value);
VALA_EXTERN void dm_list_entry_set_screen_name (DMListEntry* self,
                                    const gchar* value);
VALA_EXTERN void dm_list_entry_set_name (DMListEntry* self,
                             const gchar* value);
VALA_EXTERN void dm_list_entry_set_media (DMListEntry* self,
                              CbMedia* value);
VALA_EXTERN MediaButton* media_button_new (CbMedia* media,
                               gboolean restrict_height);
VALA_EXTERN MediaButton* media_button_construct (GType object_type,
                                     CbMedia* media,
                                     gboolean restrict_height);
static void _dm_list_entry_media_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                           MediaButton* source,
                                                           gdouble px,
                                                           gdouble py,
                                                           gpointer self);
VALA_EXTERN void media_button_set_media (MediaButton* self,
                             CbMedia* value);
VALA_EXTERN JsonObject* dm_list_entry_get_message_data (DMListEntry* self);
VALA_EXTERN void dm_list_entry_set_message_data (DMListEntry* self,
                                     JsonObject* value);
VALA_EXTERN void dm_list_entry_set_avatar (DMListEntry* self,
                               cairo_surface_t* value);
VALA_EXTERN gboolean dm_list_entry_get_seen (DMListEntry* self);
VALA_EXTERN void dm_list_entry_set_seen (DMListEntry* self,
                             gboolean value);
static void dm_list_entry_finalize (GObject * obj);
static GType dm_list_entry_get_type_once (void);
static void _vala_dm_list_entry_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_dm_list_entry_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
dm_list_entry_get_instance_private (DMListEntry* self)
{
	return G_STRUCT_MEMBER_P (self, DMListEntry_private_offset);
}

static void
_dm_list_entry_set_dm_text_g_settings_changed (GSettings* _sender,
                                               const gchar* key,
                                               gpointer self)
{
#line 206 "../src/list/DMListEntry.vala"
	dm_list_entry_set_dm_text ((DMListEntry*) self);
#line 268 "DMListEntry.c"
}

static void
_vala_CbTextEntity_array_free (CbTextEntity * array,
                               gssize array_length)
{
#line 30 "../src/list/DMListEntry.vala"
	if (array != NULL) {
#line 277 "DMListEntry.c"
		gssize i;
#line 30 "../src/list/DMListEntry.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 30 "../src/list/DMListEntry.vala"
			cb_text_entity_free (&array[i]);
#line 283 "DMListEntry.c"
		}
	}
#line 30 "../src/list/DMListEntry.vala"
	g_free (array);
#line 288 "DMListEntry.c"
}

static CbTextEntity*
_vala_array_dup10 (CbTextEntity* self,
                   gssize length)
{
#line 87 "../src/list/DMListEntry.vala"
	if (length > 0) {
#line 297 "DMListEntry.c"
		CbTextEntity* result;
		gssize i;
#line 87 "../src/list/DMListEntry.vala"
		result = g_new0 (CbTextEntity, length);
#line 87 "../src/list/DMListEntry.vala"
		for (i = 0; i < length; i++) {
#line 304 "DMListEntry.c"
			CbTextEntity _tmp0_;
			CbTextEntity _tmp1_ = {0};
#line 87 "../src/list/DMListEntry.vala"
			_tmp0_ = self[i];
#line 87 "../src/list/DMListEntry.vala"
			cb_text_entity_copy (&_tmp0_, &_tmp1_);
#line 87 "../src/list/DMListEntry.vala"
			result[i] = _tmp1_;
#line 313 "DMListEntry.c"
		}
#line 87 "../src/list/DMListEntry.vala"
		return result;
#line 317 "DMListEntry.c"
	}
#line 87 "../src/list/DMListEntry.vala"
	return NULL;
#line 321 "DMListEntry.c"
}

void
dm_list_entry_set_entities (DMListEntry* self,
                            CbTextEntity* value,
                            gint value_length1)
{
	CbTextEntity* _tmp0_;
	gint _tmp0__length1;
#line 86 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/list/DMListEntry.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup10 (value, value_length1) : value;
#line 87 "../src/list/DMListEntry.vala"
	_tmp0__length1 = value_length1;
#line 87 "../src/list/DMListEntry.vala"
	self->priv->_entities = (_vala_CbTextEntity_array_free (self->priv->_entities, self->priv->_entities_length1), NULL);
#line 87 "../src/list/DMListEntry.vala"
	self->priv->_entities = _tmp0_;
#line 87 "../src/list/DMListEntry.vala"
	self->priv->_entities_length1 = _tmp0__length1;
#line 87 "../src/list/DMListEntry.vala"
	self->priv->__entities_size_ = self->priv->_entities_length1;
#line 88 "../src/list/DMListEntry.vala"
	dm_list_entry_set_dm_text (self);
#line 347 "DMListEntry.c"
}

static gboolean
_dm_list_entry_avatar_button_release_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self)
{
	gboolean result;
	result = dm_list_entry_avatar_button_release_cb ((DMListEntry*) self, _sender, event);
#line 130 "../src/list/DMListEntry.vala"
	return result;
#line 359 "DMListEntry.c"
}

static gboolean
_utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self)
{
	gboolean result;
	result = utils_set_pointer_on_mouseover (event);
#line 131 "../src/list/DMListEntry.vala"
	return result;
#line 371 "DMListEntry.c"
}

static gboolean
_utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self)
{
	gboolean result;
	result = utils_set_pointer_on_mouseover (event);
#line 132 "../src/list/DMListEntry.vala"
	return result;
#line 383 "DMListEntry.c"
}

static gboolean
__lambda122_ (DMListEntry* self,
              const gchar* uri)
{
	MainWindow* _tmp0_;
	gboolean result;
#line 182 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 183 "../src/list/DMListEntry.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 184 "../src/list/DMListEntry.vala"
	_tmp0_ = self->main_window;
#line 184 "../src/list/DMListEntry.vala"
	result = tweet_utils_activate_link (uri, _tmp0_);
#line 184 "../src/list/DMListEntry.vala"
	return result;
#line 402 "DMListEntry.c"
}

static gboolean
___lambda122__gtk_label_activate_link (GtkLabel* _sender,
                                       const gchar* uri,
                                       gpointer self)
{
	gboolean result;
	result = __lambda122_ ((DMListEntry*) self, uri);
#line 182 "../src/list/DMListEntry.vala"
	return result;
#line 414 "DMListEntry.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 437 "DMListEntry.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 446 "DMListEntry.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 465 "DMListEntry.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 469 "DMListEntry.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 475 "DMListEntry.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 485 "DMListEntry.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 493 "DMListEntry.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 497 "DMListEntry.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 503 "DMListEntry.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 513 "DMListEntry.c"
}

static void
__lambda123_ (DMListEntry* self)
{
	CbBundle* bundle = NULL;
	CbBundle* _tmp0_;
	GtkLabel* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	MainWindow* _tmp6_;
	MainWidget* _tmp7_;
#line 189 "../src/list/DMListEntry.vala"
	_tmp0_ = cb_bundle_new ();
#line 189 "../src/list/DMListEntry.vala"
	bundle = _tmp0_;
#line 190 "../src/list/DMListEntry.vala"
	cb_bundle_put_int64 (bundle, PROFILE_PAGE_KEY_USER_ID, self->user_id);
#line 191 "../src/list/DMListEntry.vala"
	_tmp1_ = self->priv->screen_name_label;
#line 191 "../src/list/DMListEntry.vala"
	_tmp2_ = gtk_label_get_label (_tmp1_);
#line 191 "../src/list/DMListEntry.vala"
	_tmp3_ = _tmp2_;
#line 191 "../src/list/DMListEntry.vala"
	_tmp4_ = string_substring (_tmp3_, (glong) 1, (glong) -1);
#line 191 "../src/list/DMListEntry.vala"
	_tmp5_ = _tmp4_;
#line 191 "../src/list/DMListEntry.vala"
	cb_bundle_put_string (bundle, PROFILE_PAGE_KEY_SCREEN_NAME, _tmp5_);
#line 191 "../src/list/DMListEntry.vala"
	_g_free0 (_tmp5_);
#line 192 "../src/list/DMListEntry.vala"
	_tmp6_ = self->main_window;
#line 192 "../src/list/DMListEntry.vala"
	_tmp7_ = _tmp6_->main_widget;
#line 192 "../src/list/DMListEntry.vala"
	main_widget_switch_page (_tmp7_, (gint) PAGE_PROFILE, bundle);
#line 188 "../src/list/DMListEntry.vala"
	_g_object_unref0 (bundle);
#line 556 "DMListEntry.c"
}

static void
___lambda123__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 188 "../src/list/DMListEntry.vala"
	__lambda123_ ((DMListEntry*) self);
#line 565 "DMListEntry.c"
}

static gboolean
_dm_list_entry_key_released_cb_gtk_widget_key_release_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = dm_list_entry_key_released_cb ((DMListEntry*) self, event);
#line 197 "../src/list/DMListEntry.vala"
	return result;
#line 577 "DMListEntry.c"
}

static void
_dm_list_entry_set_dm_text_scale_g_settings_changed (GSettings* _sender,
                                                     const gchar* key,
                                                     gpointer self)
{
#line 199 "../src/list/DMListEntry.vala"
	dm_list_entry_set_dm_text_scale ((DMListEntry*) self);
#line 587 "DMListEntry.c"
}

DMListEntry*
dm_list_entry_construct (GType object_type)
{
	DMListEntry * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	AvatarWidget* _tmp5_;
	AvatarWidget* _tmp6_;
	AvatarWidget* _tmp7_;
	AvatarWidget* _tmp8_;
	GtkCheckButton* _tmp9_;
	GtkCheckButton* _tmp10_;
	GtkCheckButton* _tmp11_;
	GtkCheckButton* _tmp12_;
	GtkCheckButton* _tmp13_;
	GtkCheckButton* _tmp14_;
	GtkOverlay* avatar_overlay = NULL;
	GtkOverlay* _tmp15_;
	AvatarWidget* _tmp16_;
	GtkCheckButton* _tmp17_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp18_;
	GtkGrid* _tmp19_;
	TextButton* _tmp20_;
	TextButton* _tmp21_;
	TextButton* _tmp22_;
	GtkGrid* _tmp23_;
	TextButton* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkStyleContext* _tmp30_;
	GtkLabel* _tmp31_;
	GtkGrid* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkStyleContext* _tmp40_;
	GtkGrid* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLabel* _tmp43_;
	GtkLabel* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkLabel* _tmp58_;
	TextButton* _tmp59_;
	CbTextEntity* _tmp60_;
	GSettings* _tmp61_;
	GSettings* _tmp62_;
	GSettings* _tmp63_;
	GSettings* _tmp64_;
#line 114 "../src/list/DMListEntry.vala"
	self = (DMListEntry*) g_object_new (object_type, NULL);
#line 115 "../src/list/DMListEntry.vala"
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, FALSE);
#line 116 "../src/list/DMListEntry.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 116 "../src/list/DMListEntry.vala"
	gtk_style_context_add_class (_tmp0_, "tweet");
#line 118 "../src/list/DMListEntry.vala"
	_tmp1_ = (GtkGrid*) gtk_grid_new ();
#line 118 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp1_);
#line 118 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->grid);
#line 118 "../src/list/DMListEntry.vala"
	self->priv->grid = _tmp1_;
#line 119 "../src/list/DMListEntry.vala"
	_tmp2_ = self->priv->grid;
#line 119 "../src/list/DMListEntry.vala"
	g_object_set ((GtkWidget*) _tmp2_, "margin", 6, NULL);
#line 120 "../src/list/DMListEntry.vala"
	_tmp3_ = self->priv->grid;
#line 120 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) _tmp3_);
#line 121 "../src/list/DMListEntry.vala"
	_tmp4_ = self->priv->grid;
#line 121 "../src/list/DMListEntry.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
#line 123 "../src/list/DMListEntry.vala"
	_tmp5_ = avatar_widget_new ();
#line 123 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp5_);
#line 123 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->avatar_image);
#line 123 "../src/list/DMListEntry.vala"
	self->priv->avatar_image = _tmp5_;
#line 124 "../src/list/DMListEntry.vala"
	_tmp6_ = self->priv->avatar_image;
#line 124 "../src/list/DMListEntry.vala"
	avatar_widget_set_size (_tmp6_, 48);
#line 125 "../src/list/DMListEntry.vala"
	_tmp7_ = self->priv->avatar_image;
#line 125 "../src/list/DMListEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 126 "../src/list/DMListEntry.vala"
	_tmp8_ = self->priv->avatar_image;
#line 126 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) _tmp8_);
#line 127 "../src/list/DMListEntry.vala"
	_tmp9_ = (GtkCheckButton*) gtk_check_button_new ();
#line 127 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp9_);
#line 127 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->delete_checkbutton);
#line 127 "../src/list/DMListEntry.vala"
	self->priv->delete_checkbutton = _tmp9_;
#line 128 "../src/list/DMListEntry.vala"
	_tmp10_ = self->priv->delete_checkbutton;
#line 128 "../src/list/DMListEntry.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 129 "../src/list/DMListEntry.vala"
	_tmp11_ = self->priv->delete_checkbutton;
#line 129 "../src/list/DMListEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 130 "../src/list/DMListEntry.vala"
	_tmp12_ = self->priv->delete_checkbutton;
#line 130 "../src/list/DMListEntry.vala"
	g_signal_connect_object ((GtkWidget*) _tmp12_, "button-release-event", (GCallback) _dm_list_entry_avatar_button_release_cb_gtk_widget_button_release_event, self, 0);
#line 131 "../src/list/DMListEntry.vala"
	_tmp13_ = self->priv->delete_checkbutton;
#line 131 "../src/list/DMListEntry.vala"
	g_signal_connect ((GtkWidget*) _tmp13_, "enter-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event, NULL);
#line 132 "../src/list/DMListEntry.vala"
	_tmp14_ = self->priv->delete_checkbutton;
#line 132 "../src/list/DMListEntry.vala"
	g_signal_connect ((GtkWidget*) _tmp14_, "leave-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event, NULL);
#line 133 "../src/list/DMListEntry.vala"
	_tmp15_ = (GtkOverlay*) gtk_overlay_new ();
#line 133 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp15_);
#line 133 "../src/list/DMListEntry.vala"
	avatar_overlay = _tmp15_;
#line 134 "../src/list/DMListEntry.vala"
	_tmp16_ = self->priv->avatar_image;
#line 134 "../src/list/DMListEntry.vala"
	gtk_container_add ((GtkContainer*) avatar_overlay, (GtkWidget*) _tmp16_);
#line 135 "../src/list/DMListEntry.vala"
	_tmp17_ = self->priv->delete_checkbutton;
#line 135 "../src/list/DMListEntry.vala"
	gtk_overlay_add_overlay (avatar_overlay, (GtkWidget*) _tmp17_);
#line 136 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) avatar_overlay);
#line 137 "../src/list/DMListEntry.vala"
	_tmp18_ = (GtkEventBox*) gtk_event_box_new ();
#line 137 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp18_);
#line 137 "../src/list/DMListEntry.vala"
	event_box = _tmp18_;
#line 138 "../src/list/DMListEntry.vala"
	g_object_set ((GtkWidget*) event_box, "margin", 4, NULL);
#line 139 "../src/list/DMListEntry.vala"
	gtk_widget_set_margin_end ((GtkWidget*) event_box, 12);
#line 140 "../src/list/DMListEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) event_box, GTK_ALIGN_START);
#line 141 "../src/list/DMListEntry.vala"
	gtk_container_add ((GtkContainer*) event_box, (GtkWidget*) avatar_overlay);
#line 142 "../src/list/DMListEntry.vala"
	g_signal_connect_object ((GtkWidget*) event_box, "button-release-event", (GCallback) _dm_list_entry_avatar_button_release_cb_gtk_widget_button_release_event, self, 0);
#line 143 "../src/list/DMListEntry.vala"
	g_signal_connect ((GtkWidget*) event_box, "enter-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event, NULL);
#line 144 "../src/list/DMListEntry.vala"
	g_signal_connect ((GtkWidget*) event_box, "leave-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event, NULL);
#line 145 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) event_box);
#line 146 "../src/list/DMListEntry.vala"
	_tmp19_ = self->priv->grid;
#line 146 "../src/list/DMListEntry.vala"
	gtk_grid_attach (_tmp19_, (GtkWidget*) event_box, 0, 0, 1, 3);
#line 148 "../src/list/DMListEntry.vala"
	_tmp20_ = text_button_new ();
#line 148 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp20_);
#line 148 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->name_button);
#line 148 "../src/list/DMListEntry.vala"
	self->priv->name_button = _tmp20_;
#line 149 "../src/list/DMListEntry.vala"
	_tmp21_ = self->priv->name_button;
#line 149 "../src/list/DMListEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp21_, GTK_ALIGN_BASELINE);
#line 150 "../src/list/DMListEntry.vala"
	_tmp22_ = self->priv->name_button;
#line 150 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) _tmp22_);
#line 151 "../src/list/DMListEntry.vala"
	_tmp23_ = self->priv->grid;
#line 151 "../src/list/DMListEntry.vala"
	_tmp24_ = self->priv->name_button;
#line 151 "../src/list/DMListEntry.vala"
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 1, 0, 1, 1);
#line 153 "../src/list/DMListEntry.vala"
	_tmp25_ = (GtkLabel*) gtk_label_new (NULL);
#line 153 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp25_);
#line 153 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->screen_name_label);
#line 153 "../src/list/DMListEntry.vala"
	self->priv->screen_name_label = _tmp25_;
#line 154 "../src/list/DMListEntry.vala"
	_tmp26_ = self->priv->screen_name_label;
#line 154 "../src/list/DMListEntry.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp26_, 6);
#line 155 "../src/list/DMListEntry.vala"
	_tmp27_ = self->priv->screen_name_label;
#line 155 "../src/list/DMListEntry.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp27_, 6);
#line 156 "../src/list/DMListEntry.vala"
	_tmp28_ = self->priv->screen_name_label;
#line 156 "../src/list/DMListEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_BASELINE);
#line 157 "../src/list/DMListEntry.vala"
	_tmp29_ = self->priv->screen_name_label;
#line 157 "../src/list/DMListEntry.vala"
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) _tmp29_);
#line 157 "../src/list/DMListEntry.vala"
	gtk_style_context_add_class (_tmp30_, "dim-label");
#line 158 "../src/list/DMListEntry.vala"
	_tmp31_ = self->priv->screen_name_label;
#line 158 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 159 "../src/list/DMListEntry.vala"
	_tmp32_ = self->priv->grid;
#line 159 "../src/list/DMListEntry.vala"
	_tmp33_ = self->priv->screen_name_label;
#line 159 "../src/list/DMListEntry.vala"
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 2, 0, 1, 1);
#line 161 "../src/list/DMListEntry.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new (NULL);
#line 161 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp34_);
#line 161 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->time_delta_label);
#line 161 "../src/list/DMListEntry.vala"
	self->priv->time_delta_label = _tmp34_;
#line 162 "../src/list/DMListEntry.vala"
	_tmp35_ = self->priv->time_delta_label;
#line 162 "../src/list/DMListEntry.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp35_, GTK_ALIGN_END);
#line 163 "../src/list/DMListEntry.vala"
	_tmp36_ = self->priv->time_delta_label;
#line 163 "../src/list/DMListEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp36_, GTK_ALIGN_BASELINE);
#line 164 "../src/list/DMListEntry.vala"
	_tmp37_ = self->priv->time_delta_label;
#line 164 "../src/list/DMListEntry.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp37_, TRUE);
#line 165 "../src/list/DMListEntry.vala"
	_tmp38_ = self->priv->time_delta_label;
#line 165 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) _tmp38_);
#line 166 "../src/list/DMListEntry.vala"
	_tmp39_ = self->priv->time_delta_label;
#line 166 "../src/list/DMListEntry.vala"
	_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) _tmp39_);
#line 166 "../src/list/DMListEntry.vala"
	gtk_style_context_add_class (_tmp40_, "dim-label");
#line 167 "../src/list/DMListEntry.vala"
	_tmp41_ = self->priv->grid;
#line 167 "../src/list/DMListEntry.vala"
	_tmp42_ = self->priv->time_delta_label;
#line 167 "../src/list/DMListEntry.vala"
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp42_, 3, 0, 1, 1);
#line 169 "../src/list/DMListEntry.vala"
	_tmp43_ = (GtkLabel*) gtk_label_new (NULL);
#line 169 "../src/list/DMListEntry.vala"
	g_object_ref_sink (_tmp43_);
#line 169 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->text_label);
#line 169 "../src/list/DMListEntry.vala"
	self->priv->text_label = _tmp43_;
#line 170 "../src/list/DMListEntry.vala"
	_tmp44_ = self->priv->text_label;
#line 170 "../src/list/DMListEntry.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp44_, 6);
#line 171 "../src/list/DMListEntry.vala"
	_tmp45_ = self->priv->text_label;
#line 171 "../src/list/DMListEntry.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp45_, 6);
#line 172 "../src/list/DMListEntry.vala"
	_tmp46_ = self->priv->text_label;
#line 172 "../src/list/DMListEntry.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp46_, 6);
#line 173 "../src/list/DMListEntry.vala"
	_tmp47_ = self->priv->text_label;
#line 173 "../src/list/DMListEntry.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp47_, TRUE);
#line 174 "../src/list/DMListEntry.vala"
	_tmp48_ = self->priv->text_label;
#line 174 "../src/list/DMListEntry.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp48_, TRUE);
#line 175 "../src/list/DMListEntry.vala"
	_tmp49_ = self->priv->text_label;
#line 175 "../src/list/DMListEntry.vala"
	gtk_label_set_xalign (_tmp49_, 0.0f);
#line 176 "../src/list/DMListEntry.vala"
	_tmp50_ = self->priv->text_label;
#line 176 "../src/list/DMListEntry.vala"
	gtk_label_set_line_wrap (_tmp50_, TRUE);
#line 177 "../src/list/DMListEntry.vala"
	_tmp51_ = self->priv->text_label;
#line 177 "../src/list/DMListEntry.vala"
	gtk_label_set_line_wrap_mode (_tmp51_, PANGO_WRAP_WORD_CHAR);
#line 178 "../src/list/DMListEntry.vala"
	_tmp52_ = self->priv->text_label;
#line 178 "../src/list/DMListEntry.vala"
	gtk_label_set_use_markup (_tmp52_, TRUE);
#line 179 "../src/list/DMListEntry.vala"
	_tmp53_ = self->priv->text_label;
#line 179 "../src/list/DMListEntry.vala"
	gtk_label_set_use_markup (_tmp53_, TRUE);
#line 180 "../src/list/DMListEntry.vala"
	_tmp54_ = self->priv->text_label;
#line 180 "../src/list/DMListEntry.vala"
	gtk_label_set_selectable (_tmp54_, TRUE);
#line 181 "../src/list/DMListEntry.vala"
	_tmp55_ = self->priv->text_label;
#line 181 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) _tmp55_);
#line 182 "../src/list/DMListEntry.vala"
	_tmp56_ = self->priv->text_label;
#line 182 "../src/list/DMListEntry.vala"
	g_signal_connect_object (_tmp56_, "activate-link", (GCallback) ___lambda122__gtk_label_activate_link, self, 0);
#line 186 "../src/list/DMListEntry.vala"
	_tmp57_ = self->priv->grid;
#line 186 "../src/list/DMListEntry.vala"
	_tmp58_ = self->priv->text_label;
#line 186 "../src/list/DMListEntry.vala"
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 1, 1, 3, 1);
#line 188 "../src/list/DMListEntry.vala"
	_tmp59_ = self->priv->name_button;
#line 188 "../src/list/DMListEntry.vala"
	g_signal_connect_object ((GtkButton*) _tmp59_, "clicked", (GCallback) ___lambda123__gtk_button_clicked, self, 0);
#line 195 "../src/list/DMListEntry.vala"
	_tmp60_ = g_new0 (CbTextEntity, 0);
#line 195 "../src/list/DMListEntry.vala"
	self->priv->_entities = (_vala_CbTextEntity_array_free (self->priv->_entities, self->priv->_entities_length1), NULL);
#line 195 "../src/list/DMListEntry.vala"
	self->priv->_entities = _tmp60_;
#line 195 "../src/list/DMListEntry.vala"
	self->priv->_entities_length1 = 0;
#line 195 "../src/list/DMListEntry.vala"
	self->priv->__entities_size_ = self->priv->_entities_length1;
#line 197 "../src/list/DMListEntry.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _dm_list_entry_key_released_cb_gtk_widget_key_release_event, self, 0);
#line 198 "../src/list/DMListEntry.vala"
	_tmp61_ = settings_get ();
#line 198 "../src/list/DMListEntry.vala"
	_tmp62_ = _tmp61_;
#line 198 "../src/list/DMListEntry.vala"
	g_signal_connect_object (_tmp62_, "changed::text-transform-flags", (GCallback) _dm_list_entry_set_dm_text_g_settings_changed, self, 0);
#line 198 "../src/list/DMListEntry.vala"
	_g_object_unref0 (_tmp62_);
#line 199 "../src/list/DMListEntry.vala"
	_tmp63_ = settings_get ();
#line 199 "../src/list/DMListEntry.vala"
	_tmp64_ = _tmp63_;
#line 199 "../src/list/DMListEntry.vala"
	g_signal_connect_object (_tmp64_, "changed::tweet-scale", (GCallback) _dm_list_entry_set_dm_text_scale_g_settings_changed, self, 0);
#line 199 "../src/list/DMListEntry.vala"
	_g_object_unref0 (_tmp64_);
#line 201 "../src/list/DMListEntry.vala"
	dm_list_entry_set_dm_text_scale (self);
#line 202 "../src/list/DMListEntry.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 114 "../src/list/DMListEntry.vala"
	_g_object_unref0 (event_box);
#line 114 "../src/list/DMListEntry.vala"
	_g_object_unref0 (avatar_overlay);
#line 114 "../src/list/DMListEntry.vala"
	return self;
#line 981 "DMListEntry.c"
}

DMListEntry*
dm_list_entry_new (void)
{
#line 114 "../src/list/DMListEntry.vala"
	return dm_list_entry_construct (TYPE_DM_LIST_ENTRY);
#line 989 "DMListEntry.c"
}

static gboolean
dm_list_entry_key_released_cb (DMListEntry* self,
                               GdkEventKey* evt)
{
	gboolean result;
#line 210 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 210 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 229 "../src/list/DMListEntry.vala"
	result = GDK_EVENT_PROPAGATE;
#line 229 "../src/list/DMListEntry.vala"
	return result;
#line 1005 "DMListEntry.c"
}

static gboolean
dm_list_entry_avatar_button_release_cb (DMListEntry* self,
                                        GtkWidget* widget,
                                        GdkEventButton* event)
{
	gboolean result;
#line 232 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 232 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 233 "../src/list/DMListEntry.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1022 "DMListEntry.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 234 "../src/list/DMListEntry.vala"
		_tmp0_ = dm_list_entry_get_is_checked (self);
#line 234 "../src/list/DMListEntry.vala"
		_tmp1_ = _tmp0_;
#line 234 "../src/list/DMListEntry.vala"
		dm_list_entry_set_checked (self, !_tmp1_);
#line 235 "../src/list/DMListEntry.vala"
		g_signal_emit (self, dm_list_entry_signals[DM_LIST_ENTRY_AVATAR_CLICKED_SIGNAL], 0);
#line 236 "../src/list/DMListEntry.vala"
		result = GDK_EVENT_STOP;
#line 236 "../src/list/DMListEntry.vala"
		return result;
#line 1037 "DMListEntry.c"
	}
#line 238 "../src/list/DMListEntry.vala"
	result = GDK_EVENT_PROPAGATE;
#line 238 "../src/list/DMListEntry.vala"
	return result;
#line 1043 "DMListEntry.c"
}

static void
dm_list_entry_set_dm_text (DMListEntry* self)
{
	JsonObject* _tmp0_;
#line 242 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/list/DMListEntry.vala"
	_tmp0_ = self->priv->_message_data;
#line 243 "../src/list/DMListEntry.vala"
	if (_tmp0_ != NULL) {
#line 1056 "DMListEntry.c"
		gchar* msg = NULL;
		JsonObject* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		CbTransformFlags flags = 0;
		const gchar* _tmp4_;
		CbTextEntity* _tmp5_;
		gint _tmp5__length1;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
		const gchar* _tmp8_;
		GtkLabel* _tmp9_;
		const gchar* _tmp10_;
#line 244 "../src/list/DMListEntry.vala"
		_tmp1_ = self->priv->_message_data;
#line 244 "../src/list/DMListEntry.vala"
		_tmp2_ = json_object_get_string_member (_tmp1_, "text");
#line 244 "../src/list/DMListEntry.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 244 "../src/list/DMListEntry.vala"
		msg = _tmp3_;
#line 246 "../src/list/DMListEntry.vala"
		flags = settings_get_text_transform_flags () | CB_TEXT_TRANSFORM_REMOVE_MEDIA_LINKS;
#line 247 "../src/list/DMListEntry.vala"
		_tmp4_ = msg;
#line 247 "../src/list/DMListEntry.vala"
		_tmp5_ = self->priv->_entities;
#line 247 "../src/list/DMListEntry.vala"
		_tmp5__length1 = self->priv->_entities_length1;
#line 247 "../src/list/DMListEntry.vala"
		_tmp6_ = cb_text_transform_text (_tmp4_, _tmp5_, (gint) _tmp5__length1, (guint) flags, (gsize) 0, (gint64) 0, (guint) 0);
#line 247 "../src/list/DMListEntry.vala"
		_g_free0 (msg);
#line 247 "../src/list/DMListEntry.vala"
		msg = _tmp6_;
#line 248 "../src/list/DMListEntry.vala"
		_tmp7_ = self->priv->text_label;
#line 248 "../src/list/DMListEntry.vala"
		_tmp8_ = msg;
#line 248 "../src/list/DMListEntry.vala"
		gtk_label_set_label (_tmp7_, _tmp8_);
#line 249 "../src/list/DMListEntry.vala"
		_tmp9_ = self->priv->text_label;
#line 249 "../src/list/DMListEntry.vala"
		_tmp10_ = msg;
#line 249 "../src/list/DMListEntry.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp9_, g_strcmp0 (_tmp10_, "") != 0);
#line 243 "../src/list/DMListEntry.vala"
		_g_free0 (msg);
#line 1106 "DMListEntry.c"
	}
}

static void
dm_list_entry_set_dm_text_scale (DMListEntry* self)
{
	gdouble scale = 0.0;
	PangoAttrList* new_attribs = NULL;
	PangoAttrList* _tmp0_;
	PangoAttribute* scale_attr = NULL;
	PangoAttribute* _tmp1_;
	PangoAttribute* _tmp2_;
	GtkLabel* _tmp3_;
#line 253 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/list/DMListEntry.vala"
	scale = settings_get_tweet_scale ();
#line 255 "../src/list/DMListEntry.vala"
	_tmp0_ = pango_attr_list_new ();
#line 255 "../src/list/DMListEntry.vala"
	new_attribs = _tmp0_;
#line 256 "../src/list/DMListEntry.vala"
	_tmp1_ = pango_attr_scale_new (scale);
#line 256 "../src/list/DMListEntry.vala"
	scale_attr = _tmp1_;
#line 257 "../src/list/DMListEntry.vala"
	_tmp2_ = scale_attr;
#line 257 "../src/list/DMListEntry.vala"
	scale_attr = NULL;
#line 257 "../src/list/DMListEntry.vala"
	pango_attr_list_insert (new_attribs, _tmp2_);
#line 258 "../src/list/DMListEntry.vala"
	_tmp3_ = self->priv->text_label;
#line 258 "../src/list/DMListEntry.vala"
	gtk_label_set_attributes (_tmp3_, new_attribs);
#line 253 "../src/list/DMListEntry.vala"
	_pango_attribute_destroy0 (scale_attr);
#line 253 "../src/list/DMListEntry.vala"
	_pango_attr_list_unref0 (new_attribs);
#line 1146 "DMListEntry.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1168 "DMListEntry.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1172 "DMListEntry.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1178 "DMListEntry.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1182 "DMListEntry.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1186 "DMListEntry.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1194 "DMListEntry.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1222 "DMListEntry.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1231 "DMListEntry.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1245 "DMListEntry.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1254 "DMListEntry.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1268 "DMListEntry.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1277 "DMListEntry.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1286 "DMListEntry.c"
}

void
dm_list_entry_load_avatar (DMListEntry* self,
                           const gchar* avatar_url)
{
	gchar* url = NULL;
	gchar* _tmp0_;
	Twitter* _tmp3_;
	Twitter* _tmp4_;
	const gchar* _tmp5_;
	AvatarWidget* _tmp6_;
#line 261 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/list/DMListEntry.vala"
	g_return_if_fail (avatar_url != NULL);
#line 262 "../src/list/DMListEntry.vala"
	_tmp0_ = g_strdup (avatar_url);
#line 262 "../src/list/DMListEntry.vala"
	url = _tmp0_;
#line 263 "../src/list/DMListEntry.vala"
	if (gtk_widget_get_scale_factor ((GtkWidget*) self) >= 2) {
#line 1309 "DMListEntry.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 264 "../src/list/DMListEntry.vala"
		_tmp1_ = url;
#line 264 "../src/list/DMListEntry.vala"
		_tmp2_ = string_replace (_tmp1_, "_normal", "_bigger");
#line 264 "../src/list/DMListEntry.vala"
		_g_free0 (url);
#line 264 "../src/list/DMListEntry.vala"
		url = _tmp2_;
#line 1320 "DMListEntry.c"
	}
#line 266 "../src/list/DMListEntry.vala"
	_tmp3_ = twitter_get ();
#line 266 "../src/list/DMListEntry.vala"
	_tmp4_ = _tmp3_;
#line 266 "../src/list/DMListEntry.vala"
	_tmp5_ = url;
#line 266 "../src/list/DMListEntry.vala"
	_tmp6_ = self->priv->avatar_image;
#line 266 "../src/list/DMListEntry.vala"
	twitter_get_avatar (_tmp4_, self->user_id, _tmp5_, _tmp6_, 48 * gtk_widget_get_scale_factor ((GtkWidget*) self), FALSE, NULL, NULL);
#line 266 "../src/list/DMListEntry.vala"
	_g_object_unref0 (_tmp4_);
#line 261 "../src/list/DMListEntry.vala"
	_g_free0 (url);
#line 1336 "DMListEntry.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 274 "../src/list/DMListEntry.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 1344 "DMListEntry.c"
}

static gint
dm_list_entry_real_update_time_delta (CbTwitterItem* base,
                                      GDateTime* now)
{
	DMListEntry * self;
	GDateTime* cur_time = NULL;
	GDateTime* then = NULL;
	GDateTime* _tmp2_;
	GtkLabel* _tmp3_;
	GDateTime* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GDateTime* _tmp7_;
	gint result;
#line 269 "../src/list/DMListEntry.vala"
	self = (DMListEntry*) base;
#line 271 "../src/list/DMListEntry.vala"
	if (now == NULL) {
#line 1365 "DMListEntry.c"
		GDateTime* _tmp0_;
#line 272 "../src/list/DMListEntry.vala"
		_tmp0_ = g_date_time_new_now_local ();
#line 272 "../src/list/DMListEntry.vala"
		_g_date_time_unref0 (cur_time);
#line 272 "../src/list/DMListEntry.vala"
		cur_time = _tmp0_;
#line 1373 "DMListEntry.c"
	} else {
		GDateTime* _tmp1_;
#line 274 "../src/list/DMListEntry.vala"
		_tmp1_ = _g_date_time_ref0 (now);
#line 274 "../src/list/DMListEntry.vala"
		_g_date_time_unref0 (cur_time);
#line 274 "../src/list/DMListEntry.vala"
		cur_time = _tmp1_;
#line 1382 "DMListEntry.c"
	}
#line 276 "../src/list/DMListEntry.vala"
	_tmp2_ = g_date_time_new_from_unix_local (self->timestamp);
#line 276 "../src/list/DMListEntry.vala"
	then = _tmp2_;
#line 277 "../src/list/DMListEntry.vala"
	_tmp3_ = self->priv->time_delta_label;
#line 277 "../src/list/DMListEntry.vala"
	_tmp4_ = cur_time;
#line 277 "../src/list/DMListEntry.vala"
	_tmp5_ = utils_get_time_delta (then, _tmp4_, FALSE);
#line 277 "../src/list/DMListEntry.vala"
	_tmp6_ = _tmp5_;
#line 277 "../src/list/DMListEntry.vala"
	gtk_label_set_label (_tmp3_, _tmp6_);
#line 277 "../src/list/DMListEntry.vala"
	_g_free0 (_tmp6_);
#line 278 "../src/list/DMListEntry.vala"
	_tmp7_ = cur_time;
#line 278 "../src/list/DMListEntry.vala"
	result = (gint) ((g_date_time_difference (_tmp7_, then) / 1000.0) / 1000.0);
#line 278 "../src/list/DMListEntry.vala"
	_g_date_time_unref0 (then);
#line 278 "../src/list/DMListEntry.vala"
	_g_date_time_unref0 (cur_time);
#line 278 "../src/list/DMListEntry.vala"
	return result;
#line 1410 "DMListEntry.c"
}

static gint64
dm_list_entry_real_get_sort_factor (CbTwitterItem* base)
{
	DMListEntry * self;
	gint64 result;
#line 281 "../src/list/DMListEntry.vala"
	self = (DMListEntry*) base;
#line 282 "../src/list/DMListEntry.vala"
	result = self->timestamp;
#line 282 "../src/list/DMListEntry.vala"
	return result;
#line 1424 "DMListEntry.c"
}

static gint64
dm_list_entry_real_get_timestamp (CbTwitterItem* base)
{
	DMListEntry * self;
	gint64 result;
#line 285 "../src/list/DMListEntry.vala"
	self = (DMListEntry*) base;
#line 286 "../src/list/DMListEntry.vala"
	result = self->timestamp;
#line 286 "../src/list/DMListEntry.vala"
	return result;
#line 1438 "DMListEntry.c"
}

static GTimeSpan
dm_list_entry_real_get_last_set_timediff (CbTwitterItem* base)
{
	DMListEntry * self;
	GTimeSpan result;
#line 289 "../src/list/DMListEntry.vala"
	self = (DMListEntry*) base;
#line 290 "../src/list/DMListEntry.vala"
	result = self->priv->last_timediff;
#line 290 "../src/list/DMListEntry.vala"
	return result;
#line 1452 "DMListEntry.c"
}

static void
dm_list_entry_real_set_last_set_timediff (CbTwitterItem* base,
                                          GTimeSpan span)
{
	DMListEntry * self;
#line 293 "../src/list/DMListEntry.vala"
	self = (DMListEntry*) base;
#line 294 "../src/list/DMListEntry.vala"
	self->priv->last_timediff = span;
#line 1464 "DMListEntry.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 298 "../src/list/DMListEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 1472 "DMListEntry.c"
}

static void
dm_list_entry_media_clicked_cb (DMListEntry* self,
                                MediaButton* button,
                                gdouble px,
                                gdouble py)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
	CbMedia** _tmp3_;
	CbMedia** _tmp4_;
	gint _tmp4__length1;
	MainWindow* _tmp5_;
#line 297 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/list/DMListEntry.vala"
	g_return_if_fail (button != NULL);
#line 298 "../src/list/DMListEntry.vala"
	_tmp0_ = dm_list_entry_get_media (self);
#line 298 "../src/list/DMListEntry.vala"
	_tmp1_ = _tmp0_;
#line 298 "../src/list/DMListEntry.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 298 "../src/list/DMListEntry.vala"
	_tmp3_ = g_new0 (CbMedia*, 1 + 1);
#line 298 "../src/list/DMListEntry.vala"
	_tmp3_[0] = _tmp2_;
#line 298 "../src/list/DMListEntry.vala"
	_tmp4_ = _tmp3_;
#line 298 "../src/list/DMListEntry.vala"
	_tmp4__length1 = 1;
#line 298 "../src/list/DMListEntry.vala"
	_tmp5_ = self->main_window;
#line 298 "../src/list/DMListEntry.vala"
	tweet_utils_handle_media_click (_tmp4_, (gint) 1, _tmp5_, 0);
#line 298 "../src/list/DMListEntry.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_object_unref), NULL);
#line 1512 "DMListEntry.c"
}

static void
dm_list_entry_set_checked (DMListEntry* self,
                           gboolean checked)
{
#line 301 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/list/DMListEntry.vala"
	if (checked) {
#line 1523 "DMListEntry.c"
		AvatarWidget* _tmp0_;
		GtkCheckButton* _tmp1_;
		GtkCheckButton* _tmp2_;
#line 303 "../src/list/DMListEntry.vala"
		_tmp0_ = self->priv->avatar_image;
#line 303 "../src/list/DMListEntry.vala"
		gtk_widget_set_opacity ((GtkWidget*) _tmp0_, 0.5);
#line 304 "../src/list/DMListEntry.vala"
		_tmp1_ = self->priv->delete_checkbutton;
#line 304 "../src/list/DMListEntry.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
#line 305 "../src/list/DMListEntry.vala"
		_tmp2_ = self->priv->delete_checkbutton;
#line 305 "../src/list/DMListEntry.vala"
		gtk_widget_show ((GtkWidget*) _tmp2_);
#line 1539 "DMListEntry.c"
	} else {
		AvatarWidget* _tmp3_;
		GtkCheckButton* _tmp4_;
		GtkCheckButton* _tmp5_;
#line 308 "../src/list/DMListEntry.vala"
		_tmp3_ = self->priv->avatar_image;
#line 308 "../src/list/DMListEntry.vala"
		gtk_widget_set_opacity ((GtkWidget*) _tmp3_, (gdouble) 1);
#line 309 "../src/list/DMListEntry.vala"
		_tmp4_ = self->priv->delete_checkbutton;
#line 309 "../src/list/DMListEntry.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, FALSE);
#line 310 "../src/list/DMListEntry.vala"
		_tmp5_ = self->priv->delete_checkbutton;
#line 310 "../src/list/DMListEntry.vala"
		gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 1556 "DMListEntry.c"
	}
}

gboolean
dm_list_entry_get_is_checked (DMListEntry* self)
{
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 33 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/list/DMListEntry.vala"
	_tmp0_ = self->priv->delete_checkbutton;
#line 34 "../src/list/DMListEntry.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 34 "../src/list/DMListEntry.vala"
	_tmp2_ = _tmp1_;
#line 34 "../src/list/DMListEntry.vala"
	result = _tmp2_;
#line 34 "../src/list/DMListEntry.vala"
	return result;
#line 1579 "DMListEntry.c"
}

void
dm_list_entry_set_is_checked (DMListEntry* self,
                              gboolean value)
{
#line 36 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/list/DMListEntry.vala"
	dm_list_entry_set_checked (self, value);
#line 36 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_IS_CHECKED_PROPERTY]);
#line 1592 "DMListEntry.c"
}

void
dm_list_entry_set_text (DMListEntry* self,
                        const gchar* value)
{
	gchar* _tmp0_;
	JsonObject* _tmp1_;
#line 44 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/list/DMListEntry.vala"
	_tmp0_ = g_strdup (value);
#line 45 "../src/list/DMListEntry.vala"
	_g_free0 (self->priv->_text);
#line 45 "../src/list/DMListEntry.vala"
	self->priv->_text = _tmp0_;
#line 46 "../src/list/DMListEntry.vala"
	_tmp1_ = self->priv->_message_data;
#line 46 "../src/list/DMListEntry.vala"
	if (_tmp1_ == NULL) {
#line 1613 "DMListEntry.c"
		GtkLabel* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GtkLabel* _tmp4_;
#line 47 "../src/list/DMListEntry.vala"
		_tmp2_ = self->priv->text_label;
#line 47 "../src/list/DMListEntry.vala"
		gtk_label_set_label (_tmp2_, value);
#line 48 "../src/list/DMListEntry.vala"
		if (value != NULL) {
#line 48 "../src/list/DMListEntry.vala"
			_tmp3_ = g_strcmp0 (value, "") != 0;
#line 1625 "DMListEntry.c"
		} else {
#line 48 "../src/list/DMListEntry.vala"
			_tmp3_ = FALSE;
#line 1629 "DMListEntry.c"
		}
#line 48 "../src/list/DMListEntry.vala"
		_tmp4_ = self->priv->text_label;
#line 48 "../src/list/DMListEntry.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, _tmp3_);
#line 1635 "DMListEntry.c"
	}
#line 44 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_TEXT_PROPERTY]);
#line 1639 "DMListEntry.c"
}

void
dm_list_entry_set_screen_name (DMListEntry* self,
                               const gchar* value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 54 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/list/DMListEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 55 "../src/list/DMListEntry.vala"
	_tmp1_ = g_strconcat ("@", value, NULL);
#line 55 "../src/list/DMListEntry.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/list/DMListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 55 "../src/list/DMListEntry.vala"
	_g_free0 (_tmp2_);
#line 56 "../src/list/DMListEntry.vala"
	_tmp3_ = self->priv->screen_name_label;
#line 56 "../src/list/DMListEntry.vala"
	_tmp4_ = g_strconcat ("@", value, NULL);
#line 56 "../src/list/DMListEntry.vala"
	_tmp5_ = _tmp4_;
#line 56 "../src/list/DMListEntry.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp5_);
#line 56 "../src/list/DMListEntry.vala"
	_g_free0 (_tmp5_);
#line 54 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_SCREEN_NAME_PROPERTY]);
#line 1676 "DMListEntry.c"
}

void
dm_list_entry_set_name (DMListEntry* self,
                        const gchar* value)
{
	TextButton* _tmp0_;
	TextButton* _tmp1_;
#line 61 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/list/DMListEntry.vala"
	_tmp0_ = self->priv->name_button;
#line 62 "../src/list/DMListEntry.vala"
	text_button_set_text (_tmp0_, value);
#line 63 "../src/list/DMListEntry.vala"
	_tmp1_ = self->priv->name_button;
#line 63 "../src/list/DMListEntry.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, value);
#line 61 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_NAME_PROPERTY]);
#line 1697 "DMListEntry.c"
}

CbMedia*
dm_list_entry_get_media (DMListEntry* self)
{
	CbMedia* result;
	CbMedia* _tmp0_;
#line 68 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/list/DMListEntry.vala"
	_tmp0_ = self->priv->_media;
#line 68 "../src/list/DMListEntry.vala"
	result = _tmp0_;
#line 68 "../src/list/DMListEntry.vala"
	return result;
#line 1713 "DMListEntry.c"
}

static void
_dm_list_entry_media_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                      MediaButton* source,
                                                      gdouble px,
                                                      gdouble py,
                                                      gpointer self)
{
#line 75 "../src/list/DMListEntry.vala"
	dm_list_entry_media_clicked_cb ((DMListEntry*) self, source, px, py);
#line 1725 "DMListEntry.c"
}

void
dm_list_entry_set_media (DMListEntry* self,
                         CbMedia* value)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp1_;
#line 69 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/list/DMListEntry.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 70 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->_media);
#line 70 "../src/list/DMListEntry.vala"
	self->priv->_media = _tmp0_;
#line 71 "../src/list/DMListEntry.vala"
	_tmp1_ = self->priv->_media;
#line 71 "../src/list/DMListEntry.vala"
	if (_tmp1_ != NULL) {
#line 1746 "DMListEntry.c"
		MediaButton* _tmp2_;
#line 72 "../src/list/DMListEntry.vala"
		_tmp2_ = self->priv->media_button;
#line 72 "../src/list/DMListEntry.vala"
		if (_tmp2_ == NULL) {
#line 1752 "DMListEntry.c"
			CbMedia* _tmp3_;
			CbMedia* _tmp4_;
			MediaButton* _tmp5_;
			GtkGrid* _tmp6_;
			MediaButton* _tmp7_;
			MediaButton* _tmp8_;
			MediaButton* _tmp9_;
#line 73 "../src/list/DMListEntry.vala"
			_tmp3_ = dm_list_entry_get_media (self);
#line 73 "../src/list/DMListEntry.vala"
			_tmp4_ = _tmp3_;
#line 73 "../src/list/DMListEntry.vala"
			_tmp5_ = media_button_new (_tmp4_, FALSE);
#line 73 "../src/list/DMListEntry.vala"
			g_object_ref_sink (_tmp5_);
#line 73 "../src/list/DMListEntry.vala"
			_g_object_unref0 (self->priv->media_button);
#line 73 "../src/list/DMListEntry.vala"
			self->priv->media_button = _tmp5_;
#line 74 "../src/list/DMListEntry.vala"
			_tmp6_ = self->priv->grid;
#line 74 "../src/list/DMListEntry.vala"
			_tmp7_ = self->priv->media_button;
#line 74 "../src/list/DMListEntry.vala"
			gtk_grid_attach (_tmp6_, (GtkWidget*) _tmp7_, 1, 2, 3, 1);
#line 75 "../src/list/DMListEntry.vala"
			_tmp8_ = self->priv->media_button;
#line 75 "../src/list/DMListEntry.vala"
			g_signal_connect_object (_tmp8_, "clicked", (GCallback) _dm_list_entry_media_clicked_cb_media_button_clicked, self, 0);
#line 76 "../src/list/DMListEntry.vala"
			_tmp9_ = self->priv->media_button;
#line 76 "../src/list/DMListEntry.vala"
			gtk_widget_show ((GtkWidget*) _tmp9_);
#line 1786 "DMListEntry.c"
		} else {
			MediaButton* _tmp10_;
			CbMedia* _tmp11_;
#line 79 "../src/list/DMListEntry.vala"
			_tmp10_ = self->priv->media_button;
#line 79 "../src/list/DMListEntry.vala"
			_tmp11_ = self->priv->_media;
#line 79 "../src/list/DMListEntry.vala"
			media_button_set_media (_tmp10_, _tmp11_);
#line 1796 "DMListEntry.c"
		}
	}
#line 69 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_MEDIA_PROPERTY]);
#line 1801 "DMListEntry.c"
}

JsonObject*
dm_list_entry_get_message_data (DMListEntry* self)
{
	JsonObject* result;
	JsonObject* _tmp0_;
#line 92 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "../src/list/DMListEntry.vala"
	_tmp0_ = self->priv->_message_data;
#line 92 "../src/list/DMListEntry.vala"
	result = _tmp0_;
#line 92 "../src/list/DMListEntry.vala"
	return result;
#line 1817 "DMListEntry.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 94 "../src/list/DMListEntry.vala"
	return self ? json_object_ref (self) : NULL;
#line 1825 "DMListEntry.c"
}

void
dm_list_entry_set_message_data (DMListEntry* self,
                                JsonObject* value)
{
	JsonObject* _tmp0_;
#line 93 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/list/DMListEntry.vala"
	_tmp0_ = _json_object_ref0 (value);
#line 94 "../src/list/DMListEntry.vala"
	_json_object_unref0 (self->priv->_message_data);
#line 94 "../src/list/DMListEntry.vala"
	self->priv->_message_data = _tmp0_;
#line 95 "../src/list/DMListEntry.vala"
	dm_list_entry_set_dm_text (self);
#line 93 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_MESSAGE_DATA_PROPERTY]);
#line 1845 "DMListEntry.c"
}

void
dm_list_entry_set_avatar (DMListEntry* self,
                          cairo_surface_t* value)
{
	AvatarWidget* _tmp0_;
#line 100 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/list/DMListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 100 "../src/list/DMListEntry.vala"
	avatar_widget_set_surface (_tmp0_, value);
#line 100 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_AVATAR_PROPERTY]);
#line 1861 "DMListEntry.c"
}

gboolean
dm_list_entry_get_seen (DMListEntry* self)
{
	gboolean result;
#line 104 "../src/list/DMListEntry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 104 "../src/list/DMListEntry.vala"
	result = TRUE;
#line 104 "../src/list/DMListEntry.vala"
	return result;
#line 1874 "DMListEntry.c"
}

void
dm_list_entry_set_seen (DMListEntry* self,
                        gboolean value)
{
#line 105 "../src/list/DMListEntry.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/list/DMListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, dm_list_entry_properties[DM_LIST_ENTRY_SEEN_PROPERTY]);
#line 1885 "DMListEntry.c"
}

static void
dm_list_entry_class_init (DMListEntryClass * klass,
                          gpointer klass_data)
{
#line 18 "../src/list/DMListEntry.vala"
	dm_list_entry_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/list/DMListEntry.vala"
	g_type_class_adjust_private_offset (klass, &DMListEntry_private_offset);
#line 18 "../src/list/DMListEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dm_list_entry_get_property;
#line 18 "../src/list/DMListEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dm_list_entry_set_property;
#line 18 "../src/list/DMListEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = dm_list_entry_finalize;
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_IS_CHECKED_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_IS_CHECKED_PROPERTY] = g_param_spec_boolean ("is-checked", "is-checked", "is-checked", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_TEXT_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_SCREEN_NAME_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_SCREEN_NAME_PROPERTY] = g_param_spec_string ("screen-name", "screen-name", "screen-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_NAME_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_MEDIA_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_MEDIA_PROPERTY] = g_param_spec_object ("media", "media", "media", CB_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_MESSAGE_DATA_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_MESSAGE_DATA_PROPERTY] = g_param_spec_boxed ("message-data", "message-data", "message-data", json_object_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_AVATAR_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_AVATAR_PROPERTY] = g_param_spec_boxed ("avatar", "avatar", "avatar", cairo_gobject_surface_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_SEEN_PROPERTY, dm_list_entry_properties[DM_LIST_ENTRY_SEEN_PROPERTY] = g_param_spec_boolean ("seen", "seen", "seen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/list/DMListEntry.vala"
	dm_list_entry_signals[DM_LIST_ENTRY_AVATAR_CLICKED_SIGNAL] = g_signal_new ("avatar-clicked", TYPE_DM_LIST_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1920 "DMListEntry.c"
}

static void
dm_list_entry_cb_twitter_item_interface_init (CbTwitterItemInterface * iface,
                                              gpointer iface_data)
{
#line 18 "../src/list/DMListEntry.vala"
	dm_list_entry_cb_twitter_item_parent_iface = g_type_interface_peek_parent (iface);
#line 18 "../src/list/DMListEntry.vala"
	iface->update_time_delta = (gint (*) (CbTwitterItem*, GDateTime*)) dm_list_entry_real_update_time_delta;
#line 18 "../src/list/DMListEntry.vala"
	iface->get_sort_factor = (gint64 (*) (CbTwitterItem*)) dm_list_entry_real_get_sort_factor;
#line 18 "../src/list/DMListEntry.vala"
	iface->get_timestamp = (gint64 (*) (CbTwitterItem*)) dm_list_entry_real_get_timestamp;
#line 18 "../src/list/DMListEntry.vala"
	iface->get_last_set_timediff = (GTimeSpan (*) (CbTwitterItem*)) dm_list_entry_real_get_last_set_timediff;
#line 18 "../src/list/DMListEntry.vala"
	iface->set_last_set_timediff = (void (*) (CbTwitterItem*, GTimeSpan)) dm_list_entry_real_set_last_set_timediff;
#line 1939 "DMListEntry.c"
}

static void
dm_list_entry_instance_init (DMListEntry * self,
                             gpointer klass)
{
#line 18 "../src/list/DMListEntry.vala"
	self->priv = dm_list_entry_get_instance_private (self);
#line 1948 "DMListEntry.c"
}

static void
dm_list_entry_finalize (GObject * obj)
{
	DMListEntry * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	guint _tmp2_;
	GQuark _tmp3_;
#line 18 "../src/list/DMListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 206 "../src/list/DMListEntry.vala"
	_tmp0_ = settings_get ();
#line 206 "../src/list/DMListEntry.vala"
	_tmp1_ = _tmp0_;
#line 206 "../src/list/DMListEntry.vala"
	g_signal_parse_name ("changed::text-transform-flags", g_settings_get_type (), &_tmp2_, &_tmp3_, TRUE);
#line 206 "../src/list/DMListEntry.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _dm_list_entry_set_dm_text_g_settings_changed, self);
#line 206 "../src/list/DMListEntry.vala"
	_g_object_unref0 (_tmp1_);
#line 19 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->grid);
#line 20 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->avatar_image);
#line 21 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->delete_checkbutton);
#line 22 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->text_label);
#line 23 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->screen_name_label);
#line 24 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->name_button);
#line 25 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->time_delta_label);
#line 26 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->media_button);
#line 27 "../src/list/DMListEntry.vala"
	_g_free0 (self->priv->_text);
#line 28 "../src/list/DMListEntry.vala"
	_json_object_unref0 (self->priv->_message_data);
#line 29 "../src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->_media);
#line 30 "../src/list/DMListEntry.vala"
	self->priv->_entities = (_vala_CbTextEntity_array_free (self->priv->_entities, self->priv->_entities_length1), NULL);
#line 18 "../src/list/DMListEntry.vala"
	G_OBJECT_CLASS (dm_list_entry_parent_class)->finalize (obj);
#line 1997 "DMListEntry.c"
}

static GType
dm_list_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DMListEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dm_list_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DMListEntry), 0, (GInstanceInitFunc) dm_list_entry_instance_init, NULL };
	static const GInterfaceInfo cb_twitter_item_info = { (GInterfaceInitFunc) dm_list_entry_cb_twitter_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dm_list_entry_type_id;
	dm_list_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DMListEntry", &g_define_type_info, 0);
	g_type_add_interface_static (dm_list_entry_type_id, CB_TYPE_TWITTER_ITEM, &cb_twitter_item_info);
	DMListEntry_private_offset = g_type_add_instance_private (dm_list_entry_type_id, sizeof (DMListEntryPrivate));
	return dm_list_entry_type_id;
}

GType
dm_list_entry_get_type (void)
{
	static volatile gsize dm_list_entry_type_id__once = 0;
	if (g_once_init_enter (&dm_list_entry_type_id__once)) {
		GType dm_list_entry_type_id;
		dm_list_entry_type_id = dm_list_entry_get_type_once ();
		g_once_init_leave (&dm_list_entry_type_id__once, dm_list_entry_type_id);
	}
	return dm_list_entry_type_id__once;
}

static void
_vala_dm_list_entry_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	DMListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 18 "../src/list/DMListEntry.vala"
	switch (property_id) {
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_IS_CHECKED_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		g_value_set_boolean (value, dm_list_entry_get_is_checked (self));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_MEDIA_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		g_value_set_object (value, dm_list_entry_get_media (self));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_MESSAGE_DATA_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		g_value_set_boxed (value, dm_list_entry_get_message_data (self));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_SEEN_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		g_value_set_boolean (value, dm_list_entry_get_seen (self));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 2058 "DMListEntry.c"
		default:
#line 18 "../src/list/DMListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 2064 "DMListEntry.c"
	}
}

static void
_vala_dm_list_entry_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	DMListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 18 "../src/list/DMListEntry.vala"
	switch (property_id) {
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_IS_CHECKED_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_is_checked (self, g_value_get_boolean (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_TEXT_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_text (self, g_value_get_string (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_SCREEN_NAME_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_screen_name (self, g_value_get_string (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_NAME_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_name (self, g_value_get_string (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_MEDIA_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_media (self, g_value_get_object (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_MESSAGE_DATA_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_message_data (self, g_value_get_boxed (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_AVATAR_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_avatar (self, g_value_get_boxed (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 18 "../src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_SEEN_PROPERTY:
#line 18 "../src/list/DMListEntry.vala"
		dm_list_entry_set_seen (self, g_value_get_boolean (value));
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 2126 "DMListEntry.c"
		default:
#line 18 "../src/list/DMListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/list/DMListEntry.vala"
		break;
#line 2132 "DMListEntry.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

