/* BadgeRadioButton.c generated by valac 0.56.13, the Vala compiler
 * generated from BadgeRadioButton.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <atk/atk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define BADGE_RADIO_BUTTON_BADGE_SIZE 10

enum  {
	BADGE_RADIO_BUTTON_0_PROPERTY,
	BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY,
	BADGE_RADIO_BUTTON_NUM_PROPERTIES
};
static GParamSpec* badge_radio_button_properties[BADGE_RADIO_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BadgeRadioButtonPrivate {
	gboolean _show_badge;
};

static gint BadgeRadioButton_private_offset;
static gpointer badge_radio_button_parent_class = NULL;

static gboolean badge_radio_button_real_draw (GtkWidget* base,
                                       cairo_t* ct);
static void badge_radio_button_finalize (GObject * obj);
static GType badge_radio_button_get_type_once (void);
static void _vala_badge_radio_button_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_badge_radio_button_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
badge_radio_button_get_instance_private (BadgeRadioButton* self)
{
	return G_STRUCT_MEMBER_P (self, BadgeRadioButton_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/widgets/BadgeRadioButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 77 "BadgeRadioButton.c"
}

BadgeRadioButton*
badge_radio_button_construct (GType object_type,
                              GtkRadioButton* group,
                              const gchar* icon_name,
                              const gchar* text)
{
	BadgeRadioButton * self = NULL;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkImage* i = NULL;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
#line 34 "../src/widgets/BadgeRadioButton.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 34 "../src/widgets/BadgeRadioButton.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 34 "../src/widgets/BadgeRadioButton.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 35 "../src/widgets/BadgeRadioButton.vala"
	self = (BadgeRadioButton*) g_object_new (object_type, "group", group, NULL);
#line 36 "../src/widgets/BadgeRadioButton.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 36 "../src/widgets/BadgeRadioButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 36 "../src/widgets/BadgeRadioButton.vala"
	ctx = _tmp1_;
#line 37 "../src/widgets/BadgeRadioButton.vala"
	_tmp2_ = ctx;
#line 37 "../src/widgets/BadgeRadioButton.vala"
	gtk_style_context_add_class (_tmp2_, "image-button");
#line 38 "../src/widgets/BadgeRadioButton.vala"
	_tmp3_ = ctx;
#line 38 "../src/widgets/BadgeRadioButton.vala"
	gtk_style_context_add_class (_tmp3_, "flat");
#line 39 "../src/widgets/BadgeRadioButton.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 39 "../src/widgets/BadgeRadioButton.vala"
	g_object_ref_sink (_tmp4_);
#line 39 "../src/widgets/BadgeRadioButton.vala"
	i = _tmp4_;
#line 40 "../src/widgets/BadgeRadioButton.vala"
	_tmp5_ = i;
#line 40 "../src/widgets/BadgeRadioButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 41 "../src/widgets/BadgeRadioButton.vala"
	gtk_toggle_button_set_mode ((GtkToggleButton*) self, FALSE);
#line 42 "../src/widgets/BadgeRadioButton.vala"
	gtk_widget_set_focus_on_click ((GtkWidget*) self, FALSE);
#line 43 "../src/widgets/BadgeRadioButton.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 45 "../src/widgets/BadgeRadioButton.vala"
	if (g_strcmp0 (text, "") != 0) {
#line 135 "BadgeRadioButton.c"
		AtkObject* accessible = NULL;
		AtkObject* _tmp6_;
		AtkObject* _tmp7_;
		AtkObject* _tmp8_;
#line 46 "../src/widgets/BadgeRadioButton.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, text);
#line 47 "../src/widgets/BadgeRadioButton.vala"
		_tmp6_ = gtk_widget_get_accessible ((GtkWidget*) self);
#line 47 "../src/widgets/BadgeRadioButton.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 47 "../src/widgets/BadgeRadioButton.vala"
		accessible = _tmp7_;
#line 48 "../src/widgets/BadgeRadioButton.vala"
		_tmp8_ = accessible;
#line 48 "../src/widgets/BadgeRadioButton.vala"
		atk_object_set_name (_tmp8_, text);
#line 45 "../src/widgets/BadgeRadioButton.vala"
		_g_object_unref0 (accessible);
#line 154 "BadgeRadioButton.c"
	}
#line 34 "../src/widgets/BadgeRadioButton.vala"
	_g_object_unref0 (i);
#line 34 "../src/widgets/BadgeRadioButton.vala"
	_g_object_unref0 (ctx);
#line 34 "../src/widgets/BadgeRadioButton.vala"
	return self;
#line 162 "BadgeRadioButton.c"
}

BadgeRadioButton*
badge_radio_button_new (GtkRadioButton* group,
                        const gchar* icon_name,
                        const gchar* text)
{
#line 34 "../src/widgets/BadgeRadioButton.vala"
	return badge_radio_button_construct (TYPE_BADGE_RADIO_BUTTON, group, icon_name, text);
#line 172 "BadgeRadioButton.c"
}

static gboolean
badge_radio_button_real_draw (GtkWidget* base,
                              cairo_t* ct)
{
	BadgeRadioButton * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkAllocation child_allocation = {0};
	GtkAllocation allocation = {0};
	GtkWidget* _tmp4_;
	GtkAllocation _tmp5_ = {0};
	GtkAllocation _tmp6_ = {0};
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	gint x = 0;
	GtkAllocation _tmp9_;
	GtkAllocation _tmp10_;
	GtkAllocation _tmp11_;
	gint y = 0;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkStyleContext* _tmp16_;
	gboolean result;
#line 52 "../src/widgets/BadgeRadioButton.vala"
	self = (BadgeRadioButton*) base;
#line 52 "../src/widgets/BadgeRadioButton.vala"
	g_return_val_if_fail (ct != NULL, FALSE);
#line 53 "../src/widgets/BadgeRadioButton.vala"
	GTK_WIDGET_CLASS (badge_radio_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_radio_button_get_type (), GtkRadioButton), ct);
#line 54 "../src/widgets/BadgeRadioButton.vala"
	_tmp1_ = badge_radio_button_get_show_badge (self);
#line 54 "../src/widgets/BadgeRadioButton.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/widgets/BadgeRadioButton.vala"
	if (!_tmp2_) {
#line 54 "../src/widgets/BadgeRadioButton.vala"
		_tmp0_ = TRUE;
#line 216 "BadgeRadioButton.c"
	} else {
		GtkWidget* _tmp3_;
#line 54 "../src/widgets/BadgeRadioButton.vala"
		_tmp3_ = gtk_bin_get_child ((GtkBin*) self);
#line 54 "../src/widgets/BadgeRadioButton.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 223 "BadgeRadioButton.c"
	}
#line 54 "../src/widgets/BadgeRadioButton.vala"
	if (_tmp0_) {
#line 55 "../src/widgets/BadgeRadioButton.vala"
		result = GDK_EVENT_PROPAGATE;
#line 55 "../src/widgets/BadgeRadioButton.vala"
		return result;
#line 231 "BadgeRadioButton.c"
	}
#line 60 "../src/widgets/BadgeRadioButton.vala"
	_tmp4_ = gtk_bin_get_child ((GtkBin*) self);
#line 60 "../src/widgets/BadgeRadioButton.vala"
	gtk_widget_get_allocation (_tmp4_, &_tmp5_);
#line 60 "../src/widgets/BadgeRadioButton.vala"
	child_allocation = _tmp5_;
#line 61 "../src/widgets/BadgeRadioButton.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp6_);
#line 61 "../src/widgets/BadgeRadioButton.vala"
	allocation = _tmp6_;
#line 63 "../src/widgets/BadgeRadioButton.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 63 "../src/widgets/BadgeRadioButton.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 63 "../src/widgets/BadgeRadioButton.vala"
	context = _tmp8_;
#line 64 "../src/widgets/BadgeRadioButton.vala"
	_tmp9_ = allocation;
#line 64 "../src/widgets/BadgeRadioButton.vala"
	_tmp10_ = child_allocation;
#line 64 "../src/widgets/BadgeRadioButton.vala"
	_tmp11_ = child_allocation;
#line 64 "../src/widgets/BadgeRadioButton.vala"
	x = ((_tmp9_.x - _tmp10_.x) + _tmp11_.width) - BADGE_RADIO_BUTTON_BADGE_SIZE;
#line 65 "../src/widgets/BadgeRadioButton.vala"
	y = 5;
#line 67 "../src/widgets/BadgeRadioButton.vala"
	_tmp12_ = context;
#line 67 "../src/widgets/BadgeRadioButton.vala"
	gtk_style_context_save (_tmp12_);
#line 68 "../src/widgets/BadgeRadioButton.vala"
	_tmp13_ = context;
#line 68 "../src/widgets/BadgeRadioButton.vala"
	gtk_style_context_add_class (_tmp13_, "badge");
#line 69 "../src/widgets/BadgeRadioButton.vala"
	_tmp14_ = context;
#line 69 "../src/widgets/BadgeRadioButton.vala"
	gtk_render_background (_tmp14_, ct, (gdouble) x, (gdouble) y, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE);
#line 70 "../src/widgets/BadgeRadioButton.vala"
	_tmp15_ = context;
#line 70 "../src/widgets/BadgeRadioButton.vala"
	gtk_render_frame (_tmp15_, ct, (gdouble) x, (gdouble) y, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE);
#line 71 "../src/widgets/BadgeRadioButton.vala"
	_tmp16_ = context;
#line 71 "../src/widgets/BadgeRadioButton.vala"
	gtk_style_context_restore (_tmp16_);
#line 73 "../src/widgets/BadgeRadioButton.vala"
	result = GDK_EVENT_PROPAGATE;
#line 73 "../src/widgets/BadgeRadioButton.vala"
	_g_object_unref0 (context);
#line 73 "../src/widgets/BadgeRadioButton.vala"
	return result;
#line 285 "BadgeRadioButton.c"
}

gboolean
badge_radio_button_get_show_badge (BadgeRadioButton* self)
{
	gboolean result;
#line 29 "../src/widgets/BadgeRadioButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/widgets/BadgeRadioButton.vala"
	result = self->priv->_show_badge;
#line 30 "../src/widgets/BadgeRadioButton.vala"
	return result;
#line 298 "BadgeRadioButton.c"
}

void
badge_radio_button_set_show_badge (BadgeRadioButton* self,
                                   gboolean value)
{
	const gchar* _tmp0_ = NULL;
#line 22 "../src/widgets/BadgeRadioButton.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/widgets/BadgeRadioButton.vala"
	if (value) {
#line 23 "../src/widgets/BadgeRadioButton.vala"
		_tmp0_ = "true";
#line 312 "BadgeRadioButton.c"
	} else {
#line 23 "../src/widgets/BadgeRadioButton.vala"
		_tmp0_ = "false";
#line 316 "BadgeRadioButton.c"
	}
#line 23 "../src/widgets/BadgeRadioButton.vala"
	g_debug ("BadgeRadioButton.vala:23: New show_badge value: %s", _tmp0_);
#line 24 "../src/widgets/BadgeRadioButton.vala"
	if (value != self->priv->_show_badge) {
#line 25 "../src/widgets/BadgeRadioButton.vala"
		self->priv->_show_badge = value;
#line 26 "../src/widgets/BadgeRadioButton.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 326 "BadgeRadioButton.c"
	}
#line 22 "../src/widgets/BadgeRadioButton.vala"
	g_object_notify_by_pspec ((GObject *) self, badge_radio_button_properties[BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY]);
#line 330 "BadgeRadioButton.c"
}

static void
badge_radio_button_class_init (BadgeRadioButtonClass * klass,
                               gpointer klass_data)
{
#line 18 "../src/widgets/BadgeRadioButton.vala"
	badge_radio_button_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/BadgeRadioButton.vala"
	g_type_class_adjust_private_offset (klass, &BadgeRadioButton_private_offset);
#line 18 "../src/widgets/BadgeRadioButton.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) badge_radio_button_real_draw;
#line 18 "../src/widgets/BadgeRadioButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_badge_radio_button_get_property;
#line 18 "../src/widgets/BadgeRadioButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_badge_radio_button_set_property;
#line 18 "../src/widgets/BadgeRadioButton.vala"
	G_OBJECT_CLASS (klass)->finalize = badge_radio_button_finalize;
#line 18 "../src/widgets/BadgeRadioButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY, badge_radio_button_properties[BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY] = g_param_spec_boolean ("show-badge", "show-badge", "show-badge", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 351 "BadgeRadioButton.c"
}

static void
badge_radio_button_instance_init (BadgeRadioButton * self,
                                  gpointer klass)
{
#line 18 "../src/widgets/BadgeRadioButton.vala"
	self->priv = badge_radio_button_get_instance_private (self);
#line 20 "../src/widgets/BadgeRadioButton.vala"
	self->priv->_show_badge = FALSE;
#line 362 "BadgeRadioButton.c"
}

static void
badge_radio_button_finalize (GObject * obj)
{
	BadgeRadioButton * self;
#line 18 "../src/widgets/BadgeRadioButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BADGE_RADIO_BUTTON, BadgeRadioButton);
#line 18 "../src/widgets/BadgeRadioButton.vala"
	G_OBJECT_CLASS (badge_radio_button_parent_class)->finalize (obj);
#line 373 "BadgeRadioButton.c"
}

static GType
badge_radio_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BadgeRadioButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) badge_radio_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BadgeRadioButton), 0, (GInstanceInitFunc) badge_radio_button_instance_init, NULL };
	GType badge_radio_button_type_id;
	badge_radio_button_type_id = g_type_register_static (gtk_radio_button_get_type (), "BadgeRadioButton", &g_define_type_info, 0);
	BadgeRadioButton_private_offset = g_type_add_instance_private (badge_radio_button_type_id, sizeof (BadgeRadioButtonPrivate));
	return badge_radio_button_type_id;
}

GType
badge_radio_button_get_type (void)
{
	static volatile gsize badge_radio_button_type_id__once = 0;
	if (g_once_init_enter (&badge_radio_button_type_id__once)) {
		GType badge_radio_button_type_id;
		badge_radio_button_type_id = badge_radio_button_get_type_once ();
		g_once_init_leave (&badge_radio_button_type_id__once, badge_radio_button_type_id);
	}
	return badge_radio_button_type_id__once;
}

static void
_vala_badge_radio_button_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	BadgeRadioButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BADGE_RADIO_BUTTON, BadgeRadioButton);
#line 18 "../src/widgets/BadgeRadioButton.vala"
	switch (property_id) {
#line 18 "../src/widgets/BadgeRadioButton.vala"
		case BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY:
#line 18 "../src/widgets/BadgeRadioButton.vala"
		g_value_set_boolean (value, badge_radio_button_get_show_badge (self));
#line 18 "../src/widgets/BadgeRadioButton.vala"
		break;
#line 414 "BadgeRadioButton.c"
		default:
#line 18 "../src/widgets/BadgeRadioButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/BadgeRadioButton.vala"
		break;
#line 420 "BadgeRadioButton.c"
	}
}

static void
_vala_badge_radio_button_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	BadgeRadioButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BADGE_RADIO_BUTTON, BadgeRadioButton);
#line 18 "../src/widgets/BadgeRadioButton.vala"
	switch (property_id) {
#line 18 "../src/widgets/BadgeRadioButton.vala"
		case BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY:
#line 18 "../src/widgets/BadgeRadioButton.vala"
		badge_radio_button_set_show_badge (self, g_value_get_boolean (value));
#line 18 "../src/widgets/BadgeRadioButton.vala"
		break;
#line 440 "BadgeRadioButton.c"
		default:
#line 18 "../src/widgets/BadgeRadioButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/BadgeRadioButton.vala"
		break;
#line 446 "BadgeRadioButton.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

