/* MediaButton.c generated by valac 0.56.13, the Vala compiler
 * generated from MediaButton.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include "CbMedia.h"
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>
#include "cawbird.h"
#include "CbMediaDownloader.h"
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <atk/atk.h>

#define MEDIA_BUTTON_PLAY_ICON_SIZE 32
#define MEDIA_BUTTON_MAX_HEIGHT 200
#define MEDIA_BUTTON_MIN_HEIGHT 40
#define MEDIA_BUTTON_MIN_WIDTH 40
#define TRANSITION_DURATION (200 * 1000)

#define TYPE_MEDIA_BUTTON (media_button_get_type ())
#define MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_BUTTON, MediaButton))
#define MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_BUTTON, MediaButtonClass))
#define IS_MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_BUTTON))
#define IS_MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_BUTTON))
#define MEDIA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_BUTTON, MediaButtonClass))

typedef struct _MediaButton MediaButton;
typedef struct _MediaButtonClass MediaButtonClass;
typedef struct _MediaButtonPrivate MediaButtonPrivate;
enum  {
	MEDIA_BUTTON_0_PROPERTY,
	MEDIA_BUTTON_MEDIA_PROPERTY,
	MEDIA_BUTTON_NUM_PROPERTIES
};
static GParamSpec* media_button_properties[MEDIA_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block84Data Block84Data;
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
enum  {
	MEDIA_BUTTON_CLICKED_SIGNAL,
	MEDIA_BUTTON_NUM_SIGNALS
};
static guint media_button_signals[MEDIA_BUTTON_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MediaButton {
	GtkBin parent_instance;
	MediaButtonPrivate * priv;
	GtkWindow* window;
};

struct _MediaButtonClass {
	GtkBinClass parent_class;
};

struct _MediaButtonPrivate {
	GdkWindow* event_window;
	CbMedia* _media;
	GMenu* menu_model;
	GtkMenu* menu;
	GSimpleActionGroup* actions;
	PangoLayout* layout;
	GtkGestureMultiPress* press_gesture;
	gboolean restrict_height;
	gint64 fade_start_time;
	gdouble media_alpha;
};

struct _Block84Data {
	int _ref_count_;
	MediaButton* self;
	gchar* url;
};

static gint MediaButton_private_offset;
static gpointer media_button_parent_class = NULL;
static cairo_surface_t** media_button_play_icons;
static gint media_button_play_icons_length1;
static cairo_surface_t** media_button_play_icons = NULL;
static gint media_button_play_icons_length1 = 0;
static gint _media_button_play_icons_size_ = 0;

VALA_EXTERN GType media_button_get_type (void) G_GNUC_CONST ;
static void media_button_media_progress_cb (MediaButton* self);
static void _media_button_media_progress_cb_cb_media_progress (CbMedia* _sender,
                                                        gpointer self);
static void media_button_copy_url_activated (MediaButton* self,
                                      GSimpleAction* a,
                                      GVariant* v);
static void _media_button_copy_url_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void media_button_open_in_browser_activated (MediaButton* self,
                                             GSimpleAction* a,
                                             GVariant* v);
static void _media_button_open_in_browser_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void media_button_save_as_activated (MediaButton* self,
                                     GSimpleAction* a,
                                     GVariant* v);
static void _media_button_save_as_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN MediaButton* media_button_new (CbMedia* media,
                               gboolean restrict_height);
VALA_EXTERN MediaButton* media_button_construct (GType object_type,
                                     CbMedia* media,
                                     gboolean restrict_height);
VALA_EXTERN void media_button_set_media (MediaButton* self,
                             CbMedia* value);
static void media_button_gesture_released_cb (MediaButton* self,
                                       gint n_press,
                                       gdouble x,
                                       gdouble y);
static void _media_button_gesture_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                         gint n_press,
                                                                         gdouble x,
                                                                         gdouble y,
                                                                         gpointer self);
static void media_button_gesture_pressed_cb (MediaButton* self,
                                      gint n_press,
                                      gdouble x,
                                      gdouble y);
static void _media_button_gesture_pressed_cb_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                       gint n_press,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self);
static gboolean _utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                        GdkEventCrossing* event,
                                                                        gpointer self);
static gboolean _utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                        GdkEventCrossing* event,
                                                                        gpointer self);
static void media_button_set_image_description (MediaButton* self);
static void media_button_reload_image (MediaButton* self);
VALA_EXTERN CbMedia* media_button_get_media (MediaButton* self);
static void media_button_start_fade (MediaButton* self);
static void media_button_set_save_as_sensitivity (MediaButton* self);
static gboolean media_button_fade_in_cb (MediaButton* self,
                                  GtkWidget* widget,
                                  GdkFrameClock* frame_clock);
VALA_EXTERN gdouble ease_out_cubic (gdouble t);
static gboolean _media_button_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                                     GdkFrameClock* frame_clock,
                                                     gpointer self);
static gboolean media_button_real_draw (GtkWidget* base,
                                 cairo_t* ct);
static Block84Data* block84_data_ref (Block84Data* _data84_);
static void block84_data_unref (void * _userdata_);
VALA_EXTERN void utils_show_error_dialog (GError* e,
                              GtkWindow* transient_for,
                              const gchar* file,
                              gint line);
static void ____lambda14_ (Block84Data* _data84_);
static void _____lambda14__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static GtkSizeRequestMode media_button_real_get_request_mode (GtkWidget* base);
static void media_button_real_get_preferred_height (GtkWidget* base,
                                             gint* minimum,
                                             gint* natural);
static void media_button_real_get_preferred_height_for_width (GtkWidget* base,
                                                       gint width,
                                                       gint* minimum,
                                                       gint* natural);
static void media_button_real_get_preferred_width_for_height (GtkWidget* base,
                                                       gint height,
                                                       gint* minimum,
                                                       gint* natural);
static void media_button_real_get_preferred_width (GtkWidget* base,
                                            gint* minimum,
                                            gint* natural);
static void media_button_real_realize (GtkWidget* base);
static void media_button_real_unrealize (GtkWidget* base);
static void media_button_real_map (GtkWidget* base);
static void media_button_real_unmap (GtkWidget* base);
static void media_button_real_size_allocate (GtkWidget* base,
                                      GtkAllocation* alloc);
static gboolean media_button_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* evt);
static gboolean media_button_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* evt);
static GdkEvent* _vala_GdkEvent_copy (GdkEvent* self);
static void _vala_GdkEvent_free (GdkEvent* self);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static gboolean media_button_real_key_press_event (GtkWidget* base,
                                            GdkEventKey* event);
static gboolean media_button_get_is_m3u8 (MediaButton* self);
static void g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static GObject * media_button_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void media_button_finalize (GObject * obj);
static GType media_button_get_type_once (void);
static void _vala_media_button_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_media_button_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry MEDIA_BUTTON_action_entries[3] = {{"copy-url", _media_button_copy_url_activated_gsimple_action_activate_callback}, {"open-in-browser", _media_button_open_in_browser_activated_gsimple_action_activate_callback}, {"save-as", _media_button_save_as_activated_gsimple_action_activate_callback}};

static inline gpointer
media_button_get_instance_private (MediaButton* self)
{
	return G_STRUCT_MEMBER_P (self, MediaButton_private_offset);
}

static void
_media_button_media_progress_cb_cb_media_progress (CbMedia* _sender,
                                                   gpointer self)
{
#line 94 "../src/widgets/MediaButton.vala"
	media_button_media_progress_cb ((MediaButton*) self);
#line 267 "MediaButton.c"
}

static void
_media_button_copy_url_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 60 "../src/widgets/MediaButton.vala"
	media_button_copy_url_activated ((MediaButton*) self, action, parameter);
#line 277 "MediaButton.c"
}

static void
_media_button_open_in_browser_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 60 "../src/widgets/MediaButton.vala"
	media_button_open_in_browser_activated ((MediaButton*) self, action, parameter);
#line 287 "MediaButton.c"
}

static void
_media_button_save_as_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 60 "../src/widgets/MediaButton.vala"
	media_button_save_as_activated ((MediaButton*) self, action, parameter);
#line 297 "MediaButton.c"
}

static void
_media_button_gesture_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self)
{
#line 122 "../src/widgets/MediaButton.vala"
	media_button_gesture_released_cb ((MediaButton*) self, n_press, x, y);
#line 309 "MediaButton.c"
}

static void
_media_button_gesture_pressed_cb_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self)
{
#line 123 "../src/widgets/MediaButton.vala"
	media_button_gesture_pressed_cb ((MediaButton*) self, n_press, x, y);
#line 321 "MediaButton.c"
}

static gboolean
_utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self)
{
	gboolean result;
	result = utils_set_pointer_on_mouseover (event);
#line 124 "../src/widgets/MediaButton.vala"
	return result;
#line 333 "MediaButton.c"
}

static gboolean
_utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self)
{
	gboolean result;
	result = utils_set_pointer_on_mouseover (event);
#line 125 "../src/widgets/MediaButton.vala"
	return result;
#line 345 "MediaButton.c"
}

MediaButton*
media_button_construct (GType object_type,
                        CbMedia* media,
                        gboolean restrict_height)
{
	MediaButton * self = NULL;
	GtkButton* reload_button = NULL;
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GMenu* _tmp5_;
	GMenu* _tmp6_;
	GMenu* _tmp7_;
	PangoLayout* _tmp8_;
	GtkGestureMultiPress* _tmp9_;
	GtkGestureMultiPress* _tmp10_;
	GtkGestureMultiPress* _tmp11_;
	GtkGestureMultiPress* _tmp12_;
	GtkGestureMultiPress* _tmp13_;
	GtkGestureMultiPress* _tmp14_;
#line 98 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) g_object_new (object_type, NULL);
#line 99 "../src/widgets/MediaButton.vala"
	self->priv->restrict_height = restrict_height;
#line 100 "../src/widgets/MediaButton.vala"
	_tmp0_ = (GtkButton*) gtk_button_new ();
#line 100 "../src/widgets/MediaButton.vala"
	g_object_ref_sink (_tmp0_);
#line 100 "../src/widgets/MediaButton.vala"
	reload_button = _tmp0_;
#line 101 "../src/widgets/MediaButton.vala"
	gtk_button_set_label (reload_button, _ ("Reload image"));
#line 102 "../src/widgets/MediaButton.vala"
	gtk_widget_set_halign ((GtkWidget*) reload_button, GTK_ALIGN_CENTER);
#line 103 "../src/widgets/MediaButton.vala"
	gtk_widget_set_valign ((GtkWidget*) reload_button, GTK_ALIGN_CENTER);
#line 104 "../src/widgets/MediaButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) reload_button);
#line 105 "../src/widgets/MediaButton.vala"
	gtk_widget_show ((GtkWidget*) reload_button);
#line 106 "../src/widgets/MediaButton.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 106 "../src/widgets/MediaButton.vala"
	gtk_style_context_add_class (_tmp1_, "inline-media");
#line 107 "../src/widgets/MediaButton.vala"
	_tmp2_ = g_simple_action_group_new ();
#line 107 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->actions);
#line 107 "../src/widgets/MediaButton.vala"
	self->priv->actions = _tmp2_;
#line 108 "../src/widgets/MediaButton.vala"
	_tmp3_ = self->priv->actions;
#line 108 "../src/widgets/MediaButton.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp3_, MEDIA_BUTTON_action_entries, (gint) G_N_ELEMENTS (MEDIA_BUTTON_action_entries), self);
#line 109 "../src/widgets/MediaButton.vala"
	_tmp4_ = self->priv->actions;
#line 109 "../src/widgets/MediaButton.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "media", (GActionGroup*) _tmp4_);
#line 111 "../src/widgets/MediaButton.vala"
	_tmp5_ = g_menu_new ();
#line 111 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->menu_model);
#line 111 "../src/widgets/MediaButton.vala"
	self->priv->menu_model = _tmp5_;
#line 112 "../src/widgets/MediaButton.vala"
	_tmp6_ = self->priv->menu_model;
#line 112 "../src/widgets/MediaButton.vala"
	g_menu_append (_tmp6_, _ ("Open in Browser"), "media.open-in-browser");
#line 113 "../src/widgets/MediaButton.vala"
	_tmp7_ = self->priv->menu_model;
#line 113 "../src/widgets/MediaButton.vala"
	g_menu_append (_tmp7_, _ ("Save as…"), "media.save-as");
#line 115 "../src/widgets/MediaButton.vala"
	media_button_set_media (self, media);
#line 117 "../src/widgets/MediaButton.vala"
	_tmp8_ = gtk_widget_create_pango_layout ((GtkWidget*) self, "0%");
#line 117 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->layout);
#line 117 "../src/widgets/MediaButton.vala"
	self->priv->layout = _tmp8_;
#line 118 "../src/widgets/MediaButton.vala"
	_tmp9_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 118 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 118 "../src/widgets/MediaButton.vala"
	self->priv->press_gesture = _tmp9_;
#line 119 "../src/widgets/MediaButton.vala"
	_tmp10_ = self->priv->press_gesture;
#line 119 "../src/widgets/MediaButton.vala"
	gtk_gesture_single_set_exclusive ((GtkGestureSingle*) _tmp10_, TRUE);
#line 120 "../src/widgets/MediaButton.vala"
	_tmp11_ = self->priv->press_gesture;
#line 120 "../src/widgets/MediaButton.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp11_, (guint) 0);
#line 121 "../src/widgets/MediaButton.vala"
	_tmp12_ = self->priv->press_gesture;
#line 121 "../src/widgets/MediaButton.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp12_, GTK_PHASE_CAPTURE);
#line 122 "../src/widgets/MediaButton.vala"
	_tmp13_ = self->priv->press_gesture;
#line 122 "../src/widgets/MediaButton.vala"
	g_signal_connect_object (_tmp13_, "released", (GCallback) _media_button_gesture_released_cb_gtk_gesture_multi_press_released, self, 0);
#line 123 "../src/widgets/MediaButton.vala"
	_tmp14_ = self->priv->press_gesture;
#line 123 "../src/widgets/MediaButton.vala"
	g_signal_connect_object (_tmp14_, "pressed", (GCallback) _media_button_gesture_pressed_cb_gtk_gesture_multi_press_pressed, self, 0);
#line 124 "../src/widgets/MediaButton.vala"
	g_signal_connect ((GtkWidget*) self, "enter-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event, NULL);
#line 125 "../src/widgets/MediaButton.vala"
	g_signal_connect ((GtkWidget*) self, "leave-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event, NULL);
#line 126 "../src/widgets/MediaButton.vala"
	media_button_set_image_description (self);
#line 98 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (reload_button);
#line 98 "../src/widgets/MediaButton.vala"
	return self;
#line 466 "MediaButton.c"
}

MediaButton*
media_button_new (CbMedia* media,
                  gboolean restrict_height)
{
#line 98 "../src/widgets/MediaButton.vala"
	return media_button_construct (TYPE_MEDIA_BUTTON, media, restrict_height);
#line 475 "MediaButton.c"
}

static void
media_button_reload_image (MediaButton* self)
{
	CbMediaDownloader* _tmp0_;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
#line 129 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/widgets/MediaButton.vala"
	_tmp0_ = cb_media_downloader_get_default ();
#line 130 "../src/widgets/MediaButton.vala"
	_tmp1_ = media_button_get_media (self);
#line 130 "../src/widgets/MediaButton.vala"
	_tmp2_ = _tmp1_;
#line 130 "../src/widgets/MediaButton.vala"
	cb_media_downloader_reload_async (_tmp0_, _tmp2_, NULL, NULL);
#line 494 "MediaButton.c"
}

static void
media_button_media_progress_cb (MediaButton* self)
{
	CbMedia* _tmp0_;
#line 133 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/widgets/MediaButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 136 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->_media;
#line 136 "../src/widgets/MediaButton.vala"
	if (_tmp0_->loaded) {
#line 509 "MediaButton.c"
		gboolean _tmp1_ = FALSE;
		CbMedia* _tmp2_;
#line 137 "../src/widgets/MediaButton.vala"
		_tmp2_ = self->priv->_media;
#line 137 "../src/widgets/MediaButton.vala"
		if (!_tmp2_->invalid) {
#line 516 "MediaButton.c"
			CbMedia* _tmp3_;
			cairo_surface_t* _tmp4_;
#line 137 "../src/widgets/MediaButton.vala"
			_tmp3_ = self->priv->_media;
#line 137 "../src/widgets/MediaButton.vala"
			_tmp4_ = _tmp3_->surface;
#line 137 "../src/widgets/MediaButton.vala"
			_tmp1_ = _tmp4_ != NULL;
#line 525 "MediaButton.c"
		} else {
#line 137 "../src/widgets/MediaButton.vala"
			_tmp1_ = FALSE;
#line 529 "MediaButton.c"
		}
#line 137 "../src/widgets/MediaButton.vala"
		if (_tmp1_) {
#line 138 "../src/widgets/MediaButton.vala"
			media_button_start_fade (self);
#line 535 "MediaButton.c"
		}
#line 141 "../src/widgets/MediaButton.vala"
		media_button_set_save_as_sensitivity (self);
#line 142 "../src/widgets/MediaButton.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 541 "MediaButton.c"
	}
}

static gboolean
media_button_fade_in_cb (MediaButton* self,
                         GtkWidget* widget,
                         GdkFrameClock* frame_clock)
{
	gint64 now = 0LL;
	gdouble t = 0.0;
	gboolean result;
#line 146 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 146 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 146 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (frame_clock != NULL, FALSE);
#line 147 "../src/widgets/MediaButton.vala"
	if (!gtk_widget_get_mapped ((GtkWidget*) self)) {
#line 148 "../src/widgets/MediaButton.vala"
		self->priv->media_alpha = 1.0;
#line 149 "../src/widgets/MediaButton.vala"
		result = G_SOURCE_REMOVE;
#line 149 "../src/widgets/MediaButton.vala"
		return result;
#line 567 "MediaButton.c"
	}
#line 152 "../src/widgets/MediaButton.vala"
	now = gdk_frame_clock_get_frame_time (frame_clock);
#line 153 "../src/widgets/MediaButton.vala"
	t = 1.0;
#line 154 "../src/widgets/MediaButton.vala"
	if (now < (self->priv->fade_start_time + TRANSITION_DURATION)) {
#line 155 "../src/widgets/MediaButton.vala"
		t = (now - self->priv->fade_start_time) / ((gdouble) TRANSITION_DURATION);
#line 577 "MediaButton.c"
	}
#line 157 "../src/widgets/MediaButton.vala"
	t = ease_out_cubic (t);
#line 159 "../src/widgets/MediaButton.vala"
	self->priv->media_alpha = t;
#line 160 "../src/widgets/MediaButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 161 "../src/widgets/MediaButton.vala"
	if (t >= 1.0) {
#line 162 "../src/widgets/MediaButton.vala"
		self->priv->media_alpha = 1.0;
#line 163 "../src/widgets/MediaButton.vala"
		result = G_SOURCE_REMOVE;
#line 163 "../src/widgets/MediaButton.vala"
		return result;
#line 593 "MediaButton.c"
	}
#line 166 "../src/widgets/MediaButton.vala"
	result = G_SOURCE_CONTINUE;
#line 166 "../src/widgets/MediaButton.vala"
	return result;
#line 599 "MediaButton.c"
}

static gboolean
_media_button_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                            GdkFrameClock* frame_clock,
                                            gpointer self)
{
	gboolean result;
	result = media_button_fade_in_cb ((MediaButton*) self, widget, frame_clock);
#line 180 "../src/widgets/MediaButton.vala"
	return result;
#line 611 "MediaButton.c"
}

static void
media_button_start_fade (MediaButton* self)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
	CbMedia* _tmp3_;
	cairo_surface_t* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	GdkFrameClock* _tmp10_;
#line 169 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/widgets/MediaButton.vala"
	_tmp0_ = media_button_get_media (self);
#line 170 "../src/widgets/MediaButton.vala"
	_tmp1_ = _tmp0_;
#line 170 "../src/widgets/MediaButton.vala"
	_vala_assert (_tmp1_ != NULL, "this.media != null");
#line 171 "../src/widgets/MediaButton.vala"
	_tmp2_ = media_button_get_media (self);
#line 171 "../src/widgets/MediaButton.vala"
	_tmp3_ = _tmp2_;
#line 171 "../src/widgets/MediaButton.vala"
	_tmp4_ = _tmp3_->surface;
#line 171 "../src/widgets/MediaButton.vala"
	_vala_assert (_tmp4_ != NULL, "this.media.surface != null");
#line 173 "../src/widgets/MediaButton.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 173 "../src/widgets/MediaButton.vala"
		_tmp6_ = TRUE;
#line 645 "MediaButton.c"
	} else {
#line 173 "../src/widgets/MediaButton.vala"
		_tmp6_ = !gtk_widget_get_mapped ((GtkWidget*) self);
#line 649 "MediaButton.c"
	}
#line 173 "../src/widgets/MediaButton.vala"
	if (_tmp6_) {
#line 173 "../src/widgets/MediaButton.vala"
		_tmp5_ = TRUE;
#line 655 "MediaButton.c"
	} else {
		GtkSettings* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 174 "../src/widgets/MediaButton.vala"
		_tmp7_ = gtk_settings_get_default ();
#line 174 "../src/widgets/MediaButton.vala"
		g_object_get (_tmp7_, "gtk-enable-animations", &_tmp8_, NULL);
#line 174 "../src/widgets/MediaButton.vala"
		_tmp9_ = _tmp8_;
#line 174 "../src/widgets/MediaButton.vala"
		_tmp5_ = !_tmp9_;
#line 668 "MediaButton.c"
	}
#line 173 "../src/widgets/MediaButton.vala"
	if (_tmp5_) {
#line 175 "../src/widgets/MediaButton.vala"
		self->priv->media_alpha = 1.0;
#line 176 "../src/widgets/MediaButton.vala"
		return;
#line 676 "MediaButton.c"
	}
#line 179 "../src/widgets/MediaButton.vala"
	_tmp10_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
#line 179 "../src/widgets/MediaButton.vala"
	self->priv->fade_start_time = gdk_frame_clock_get_frame_time (_tmp10_);
#line 180 "../src/widgets/MediaButton.vala"
	gtk_widget_add_tick_callback ((GtkWidget*) self, _media_button_fade_in_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 684 "MediaButton.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 238 "../src/widgets/MediaButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 692 "MediaButton.c"
}

static gboolean
media_button_real_draw (GtkWidget* base,
                        cairo_t* ct)
{
	MediaButton * self;
	gint widget_width = 0;
	gint widget_height = 0;
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 183 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 183 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (ct != NULL, FALSE);
#line 184 "../src/widgets/MediaButton.vala"
	widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 185 "../src/widgets/MediaButton.vala"
	widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 187 "../src/widgets/MediaButton.vala"
	_tmp1_ = self->priv->_media;
#line 187 "../src/widgets/MediaButton.vala"
	if (_tmp1_ != NULL) {
#line 718 "MediaButton.c"
		CbMedia* _tmp2_;
#line 187 "../src/widgets/MediaButton.vala"
		_tmp2_ = self->priv->_media;
#line 187 "../src/widgets/MediaButton.vala"
		_tmp0_ = _tmp2_->invalid;
#line 724 "MediaButton.c"
	} else {
#line 187 "../src/widgets/MediaButton.vala"
		_tmp0_ = FALSE;
#line 728 "MediaButton.c"
	}
#line 187 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 188 "../src/widgets/MediaButton.vala"
		GTK_WIDGET_CLASS (media_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), ct);
#line 734 "MediaButton.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		CbMedia* _tmp5_;
#line 190 "../src/widgets/MediaButton.vala"
		_tmp5_ = self->priv->_media;
#line 190 "../src/widgets/MediaButton.vala"
		if (_tmp5_ != NULL) {
#line 743 "MediaButton.c"
			CbMedia* _tmp6_;
			cairo_surface_t* _tmp7_;
#line 190 "../src/widgets/MediaButton.vala"
			_tmp6_ = self->priv->_media;
#line 190 "../src/widgets/MediaButton.vala"
			_tmp7_ = _tmp6_->surface;
#line 190 "../src/widgets/MediaButton.vala"
			_tmp4_ = _tmp7_ != NULL;
#line 752 "MediaButton.c"
		} else {
#line 190 "../src/widgets/MediaButton.vala"
			_tmp4_ = FALSE;
#line 756 "MediaButton.c"
		}
#line 190 "../src/widgets/MediaButton.vala"
		if (_tmp4_) {
#line 760 "MediaButton.c"
			CbMedia* _tmp8_;
#line 190 "../src/widgets/MediaButton.vala"
			_tmp8_ = self->priv->_media;
#line 190 "../src/widgets/MediaButton.vala"
			_tmp3_ = _tmp8_->loaded;
#line 766 "MediaButton.c"
		} else {
#line 190 "../src/widgets/MediaButton.vala"
			_tmp3_ = FALSE;
#line 770 "MediaButton.c"
		}
#line 190 "../src/widgets/MediaButton.vala"
		if (_tmp3_) {
#line 774 "MediaButton.c"
			gint draw_x = 0;
			gint draw_y = 0;
			gdouble scale = 0.0;
			CbMedia* _tmp9_;
			CbMedia* _tmp10_;
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gdouble _tmp13_ = 0.0;
			gint draw_width = 0;
			gint draw_height = 0;
			CbMedia* _tmp14_;
			CbMedia* _tmp15_;
			cairo_surface_t* _tmp16_;
			CbMedia* _tmp23_;
			gboolean _tmp27_ = FALSE;
			CbMedia* _tmp28_;
			CbMedia* _tmp29_;
			const gchar* _tmp30_;
			GtkStyleContext* sc = NULL;
			GtkStyleContext* _tmp44_;
			GtkStyleContext* _tmp45_;
			GtkStyleContext* _tmp46_;
			GtkStyleContext* _tmp47_;
#line 194 "../src/widgets/MediaButton.vala"
			_tmp9_ = self->priv->_media;
#line 194 "../src/widgets/MediaButton.vala"
			_tmp10_ = self->priv->_media;
#line 194 "../src/widgets/MediaButton.vala"
			utils_calculate_draw_offset (_tmp9_->thumb_width, _tmp10_->thumb_height, gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self), &_tmp11_, &_tmp12_, &_tmp13_);
#line 194 "../src/widgets/MediaButton.vala"
			draw_x = _tmp11_;
#line 194 "../src/widgets/MediaButton.vala"
			draw_y = _tmp12_;
#line 194 "../src/widgets/MediaButton.vala"
			scale = _tmp13_;
#line 198 "../src/widgets/MediaButton.vala"
			draw_width = gtk_widget_get_allocated_width ((GtkWidget*) self) - draw_x;
#line 199 "../src/widgets/MediaButton.vala"
			draw_height = gtk_widget_get_allocated_height ((GtkWidget*) self) - draw_y;
#line 201 "../src/widgets/MediaButton.vala"
			cairo_save (ct);
#line 202 "../src/widgets/MediaButton.vala"
			cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
#line 203 "../src/widgets/MediaButton.vala"
			cairo_scale (ct, scale, scale);
#line 204 "../src/widgets/MediaButton.vala"
			_tmp14_ = media_button_get_media (self);
#line 204 "../src/widgets/MediaButton.vala"
			_tmp15_ = _tmp14_;
#line 204 "../src/widgets/MediaButton.vala"
			_tmp16_ = _tmp15_->surface;
#line 204 "../src/widgets/MediaButton.vala"
			cairo_set_source_surface (ct, _tmp16_, draw_x / scale, draw_y / scale);
#line 205 "../src/widgets/MediaButton.vala"
			cairo_paint_with_alpha (ct, self->priv->media_alpha);
#line 206 "../src/widgets/MediaButton.vala"
			cairo_restore (ct);
#line 207 "../src/widgets/MediaButton.vala"
			cairo_new_path (ct);
#line 213 "../src/widgets/MediaButton.vala"
			if (draw_y < 0) {
#line 836 "MediaButton.c"
				cairo_pattern_t* pattern = NULL;
				cairo_pattern_t* _tmp17_;
				cairo_pattern_t* _tmp18_;
				cairo_pattern_t* _tmp19_;
				cairo_pattern_t* _tmp20_;
				cairo_pattern_t* _tmp21_;
				cairo_pattern_t* _tmp22_;
#line 214 "../src/widgets/MediaButton.vala"
				_tmp17_ = cairo_pattern_create_linear (0.0, 0.0, (gdouble) 0, (gdouble) widget_height);
#line 214 "../src/widgets/MediaButton.vala"
				pattern = _tmp17_;
#line 215 "../src/widgets/MediaButton.vala"
				_tmp18_ = pattern;
#line 215 "../src/widgets/MediaButton.vala"
				cairo_pattern_add_color_stop_rgba (_tmp18_, 0.01, 0.3, 0.3, 0.3, (gdouble) 1);
#line 216 "../src/widgets/MediaButton.vala"
				_tmp19_ = pattern;
#line 216 "../src/widgets/MediaButton.vala"
				cairo_pattern_add_color_stop_rgba (_tmp19_, 0.1, 0.7, 0.7, 0.7, (gdouble) 0);
#line 217 "../src/widgets/MediaButton.vala"
				_tmp20_ = pattern;
#line 217 "../src/widgets/MediaButton.vala"
				cairo_pattern_add_color_stop_rgba (_tmp20_, 0.9, 0.7, 0.7, 0.7, (gdouble) 0);
#line 218 "../src/widgets/MediaButton.vala"
				_tmp21_ = pattern;
#line 218 "../src/widgets/MediaButton.vala"
				cairo_pattern_add_color_stop_rgba (_tmp21_, 0.99, 0.3, 0.3, 0.3, (gdouble) 1);
#line 219 "../src/widgets/MediaButton.vala"
				cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
#line 220 "../src/widgets/MediaButton.vala"
				_tmp22_ = pattern;
#line 220 "../src/widgets/MediaButton.vala"
				cairo_set_source (ct, _tmp22_);
#line 221 "../src/widgets/MediaButton.vala"
				cairo_fill (ct);
#line 213 "../src/widgets/MediaButton.vala"
				_cairo_pattern_destroy0 (pattern);
#line 874 "MediaButton.c"
			}
#line 225 "../src/widgets/MediaButton.vala"
			_tmp23_ = self->priv->_media;
#line 225 "../src/widgets/MediaButton.vala"
			if (cb_media_is_video (_tmp23_)) {
#line 880 "MediaButton.c"
				gint x = 0;
				gint y = 0;
				gint _tmp24_ = 0;
				cairo_surface_t** _tmp25_;
				gint _tmp25__length1;
				cairo_surface_t* _tmp26_;
#line 226 "../src/widgets/MediaButton.vala"
				x = (widget_width / 2) - (MEDIA_BUTTON_PLAY_ICON_SIZE / 2);
#line 227 "../src/widgets/MediaButton.vala"
				y = (widget_height / 2) - (MEDIA_BUTTON_PLAY_ICON_SIZE / 2);
#line 229 "../src/widgets/MediaButton.vala"
				cairo_save (ct);
#line 230 "../src/widgets/MediaButton.vala"
				cairo_rectangle (ct, (gdouble) x, (gdouble) y, (gdouble) MEDIA_BUTTON_PLAY_ICON_SIZE, (gdouble) MEDIA_BUTTON_PLAY_ICON_SIZE);
#line 231 "../src/widgets/MediaButton.vala"
				if (gtk_widget_get_scale_factor ((GtkWidget*) self) == 1) {
#line 231 "../src/widgets/MediaButton.vala"
					_tmp24_ = 0;
#line 899 "MediaButton.c"
				} else {
#line 231 "../src/widgets/MediaButton.vala"
					_tmp24_ = 1;
#line 903 "MediaButton.c"
				}
#line 231 "../src/widgets/MediaButton.vala"
				_tmp25_ = media_button_play_icons;
#line 231 "../src/widgets/MediaButton.vala"
				_tmp25__length1 = media_button_play_icons_length1;
#line 231 "../src/widgets/MediaButton.vala"
				_tmp26_ = _tmp25_[_tmp24_];
#line 231 "../src/widgets/MediaButton.vala"
				cairo_set_source_surface (ct, _tmp26_, (gdouble) x, (gdouble) y);
#line 232 "../src/widgets/MediaButton.vala"
				cairo_paint_with_alpha (ct, self->priv->media_alpha);
#line 233 "../src/widgets/MediaButton.vala"
				cairo_restore (ct);
#line 234 "../src/widgets/MediaButton.vala"
				cairo_new_path (ct);
#line 919 "MediaButton.c"
			}
#line 237 "../src/widgets/MediaButton.vala"
			_tmp28_ = media_button_get_media (self);
#line 237 "../src/widgets/MediaButton.vala"
			_tmp29_ = _tmp28_;
#line 237 "../src/widgets/MediaButton.vala"
			_tmp30_ = _tmp29_->alt_text;
#line 237 "../src/widgets/MediaButton.vala"
			if (_tmp30_ != NULL) {
#line 929 "MediaButton.c"
				CbMedia* _tmp31_;
				CbMedia* _tmp32_;
				const gchar* _tmp33_;
#line 237 "../src/widgets/MediaButton.vala"
				_tmp31_ = media_button_get_media (self);
#line 237 "../src/widgets/MediaButton.vala"
				_tmp32_ = _tmp31_;
#line 237 "../src/widgets/MediaButton.vala"
				_tmp33_ = _tmp32_->alt_text;
#line 237 "../src/widgets/MediaButton.vala"
				_tmp27_ = g_strcmp0 (_tmp33_, "") != 0;
#line 941 "MediaButton.c"
			} else {
#line 237 "../src/widgets/MediaButton.vala"
				_tmp27_ = FALSE;
#line 945 "MediaButton.c"
			}
#line 237 "../src/widgets/MediaButton.vala"
			if (_tmp27_) {
#line 949 "MediaButton.c"
				GtkIconTheme* icon_theme = NULL;
				GtkIconTheme* _tmp34_;
				GtkIconTheme* _tmp35_;
				gint icon_size = 0;
#line 238 "../src/widgets/MediaButton.vala"
				_tmp34_ = gtk_icon_theme_get_default ();
#line 238 "../src/widgets/MediaButton.vala"
				_tmp35_ = _g_object_ref0 (_tmp34_);
#line 238 "../src/widgets/MediaButton.vala"
				icon_theme = _tmp35_;
#line 239 "../src/widgets/MediaButton.vala"
				icon_size = 24;
#line 962 "MediaButton.c"
				{
					GdkPixbuf* pixbuf = NULL;
					GtkIconTheme* _tmp36_;
					GdkPixbuf* _tmp37_;
					cairo_surface_t* icon = NULL;
					GdkPixbuf* _tmp38_;
					cairo_surface_t* _tmp39_;
					cairo_surface_t* _tmp40_;
#line 241 "../src/widgets/MediaButton.vala"
					_tmp36_ = icon_theme;
#line 241 "../src/widgets/MediaButton.vala"
					_tmp37_ = gtk_icon_theme_load_icon_for_scale (_tmp36_, "dialog-information", icon_size, gtk_widget_get_scale_factor ((GtkWidget*) self), GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error0_);
#line 241 "../src/widgets/MediaButton.vala"
					pixbuf = _tmp37_;
#line 241 "../src/widgets/MediaButton.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 979 "MediaButton.c"
						goto __catch0_g_error;
					}
#line 242 "../src/widgets/MediaButton.vala"
					_tmp38_ = pixbuf;
#line 242 "../src/widgets/MediaButton.vala"
					_tmp39_ = gdk_cairo_surface_create_from_pixbuf (_tmp38_, gtk_widget_get_scale_factor ((GtkWidget*) self), NULL);
#line 242 "../src/widgets/MediaButton.vala"
					icon = _tmp39_;
#line 243 "../src/widgets/MediaButton.vala"
					_tmp40_ = icon;
#line 243 "../src/widgets/MediaButton.vala"
					cairo_set_source_surface (ct, _tmp40_, draw_x / scale, (gdouble) (widget_height - (icon_size * gtk_widget_get_scale_factor ((GtkWidget*) self))));
#line 244 "../src/widgets/MediaButton.vala"
					cairo_paint (ct);
#line 240 "../src/widgets/MediaButton.vala"
					_cairo_surface_destroy0 (icon);
#line 240 "../src/widgets/MediaButton.vala"
					_g_object_unref0 (pixbuf);
#line 998 "MediaButton.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp41_;
					const gchar* _tmp42_;
#line 240 "../src/widgets/MediaButton.vala"
					e = _inner_error0_;
#line 240 "../src/widgets/MediaButton.vala"
					_inner_error0_ = NULL;
#line 246 "../src/widgets/MediaButton.vala"
					_tmp41_ = e;
#line 246 "../src/widgets/MediaButton.vala"
					_tmp42_ = _tmp41_->message;
#line 246 "../src/widgets/MediaButton.vala"
					g_warning ("MediaButton.vala:246: %s", _tmp42_);
#line 240 "../src/widgets/MediaButton.vala"
					_g_error_free0 (e);
#line 1018 "MediaButton.c"
				}
				__finally0:
#line 240 "../src/widgets/MediaButton.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1023 "MediaButton.c"
					gboolean _tmp43_ = FALSE;
#line 240 "../src/widgets/MediaButton.vala"
					_g_object_unref0 (icon_theme);
#line 240 "../src/widgets/MediaButton.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 240 "../src/widgets/MediaButton.vala"
					g_clear_error (&_inner_error0_);
#line 240 "../src/widgets/MediaButton.vala"
					return _tmp43_;
#line 1033 "MediaButton.c"
				}
#line 237 "../src/widgets/MediaButton.vala"
				_g_object_unref0 (icon_theme);
#line 1037 "MediaButton.c"
			}
#line 250 "../src/widgets/MediaButton.vala"
			_tmp44_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 250 "../src/widgets/MediaButton.vala"
			_tmp45_ = _g_object_ref0 (_tmp44_);
#line 250 "../src/widgets/MediaButton.vala"
			sc = _tmp45_;
#line 251 "../src/widgets/MediaButton.vala"
			_tmp46_ = sc;
#line 251 "../src/widgets/MediaButton.vala"
			gtk_render_background (_tmp46_, ct, (gdouble) draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
#line 252 "../src/widgets/MediaButton.vala"
			_tmp47_ = sc;
#line 252 "../src/widgets/MediaButton.vala"
			gtk_render_frame (_tmp47_, ct, (gdouble) draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
#line 254 "../src/widgets/MediaButton.vala"
			if (gtk_widget_has_visible_focus ((GtkWidget*) self)) {
#line 1055 "MediaButton.c"
				GtkStyleContext* _tmp48_;
#line 255 "../src/widgets/MediaButton.vala"
				_tmp48_ = sc;
#line 255 "../src/widgets/MediaButton.vala"
				gtk_render_focus (_tmp48_, ct, (gdouble) (draw_x + 2), (gdouble) 2, (gdouble) (draw_width - 4), (gdouble) (draw_height - 4));
#line 1061 "MediaButton.c"
			}
#line 190 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (sc);
#line 1065 "MediaButton.c"
		} else {
			GtkStyleContext* sc = NULL;
			GtkStyleContext* _tmp49_;
			GtkStyleContext* _tmp50_;
			gdouble layout_x = 0.0;
			gdouble layout_y = 0.0;
			gint layout_w = 0;
			gint layout_h = 0;
			PangoLayout* _tmp51_;
			CbMedia* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			PangoLayout* _tmp55_;
			gint _tmp56_ = 0;
			gint _tmp57_ = 0;
			GtkStyleContext* _tmp58_;
			PangoLayout* _tmp59_;
#line 258 "../src/widgets/MediaButton.vala"
			_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 258 "../src/widgets/MediaButton.vala"
			_tmp50_ = _g_object_ref0 (_tmp49_);
#line 258 "../src/widgets/MediaButton.vala"
			sc = _tmp50_;
#line 261 "../src/widgets/MediaButton.vala"
			_tmp51_ = self->priv->layout;
#line 261 "../src/widgets/MediaButton.vala"
			_tmp52_ = self->priv->_media;
#line 261 "../src/widgets/MediaButton.vala"
			_tmp53_ = g_strdup_printf ("%d%%", (gint) (_tmp52_->percent_loaded * 100));
#line 261 "../src/widgets/MediaButton.vala"
			_tmp54_ = _tmp53_;
#line 261 "../src/widgets/MediaButton.vala"
			pango_layout_set_text (_tmp51_, _tmp54_, -1);
#line 261 "../src/widgets/MediaButton.vala"
			_g_free0 (_tmp54_);
#line 262 "../src/widgets/MediaButton.vala"
			_tmp55_ = self->priv->layout;
#line 262 "../src/widgets/MediaButton.vala"
			pango_layout_get_size (_tmp55_, &_tmp56_, &_tmp57_);
#line 262 "../src/widgets/MediaButton.vala"
			layout_w = _tmp56_;
#line 262 "../src/widgets/MediaButton.vala"
			layout_h = _tmp57_;
#line 263 "../src/widgets/MediaButton.vala"
			layout_x = (widget_width / 2.0) - ((layout_w / PANGO_SCALE) / 2.0);
#line 264 "../src/widgets/MediaButton.vala"
			layout_y = (widget_height / 2.0) - ((layout_h / PANGO_SCALE) / 2.0);
#line 265 "../src/widgets/MediaButton.vala"
			_tmp58_ = sc;
#line 265 "../src/widgets/MediaButton.vala"
			_tmp59_ = self->priv->layout;
#line 265 "../src/widgets/MediaButton.vala"
			gtk_render_layout (_tmp58_, ct, layout_x, layout_y, _tmp59_);
#line 190 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (sc);
#line 1121 "MediaButton.c"
		}
	}
#line 268 "../src/widgets/MediaButton.vala"
	result = GDK_EVENT_PROPAGATE;
#line 268 "../src/widgets/MediaButton.vala"
	return result;
#line 1128 "MediaButton.c"
}

static void
media_button_copy_url_activated (MediaButton* self,
                                 GSimpleAction* a,
                                 GVariant* v)
{
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	GtkClipboard* _tmp2_;
	CbMedia* _tmp3_;
	CbMedia* _tmp4_;
	const gchar* _tmp5_;
#line 271 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/widgets/MediaButton.vala"
	g_return_if_fail (a != NULL);
#line 272 "../src/widgets/MediaButton.vala"
	_tmp0_ = gdk_display_get_default ();
#line 272 "../src/widgets/MediaButton.vala"
	_tmp1_ = gtk_clipboard_get_for_display (_tmp0_, GDK_SELECTION_CLIPBOARD);
#line 272 "../src/widgets/MediaButton.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 272 "../src/widgets/MediaButton.vala"
	clipboard = _tmp2_;
#line 274 "../src/widgets/MediaButton.vala"
	_tmp3_ = media_button_get_media (self);
#line 274 "../src/widgets/MediaButton.vala"
	_tmp4_ = _tmp3_;
#line 274 "../src/widgets/MediaButton.vala"
	_tmp5_ = _tmp4_->url;
#line 274 "../src/widgets/MediaButton.vala"
	gtk_clipboard_set_text (clipboard, _tmp5_, -1);
#line 271 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (clipboard);
#line 1165 "MediaButton.c"
}

static void
media_button_open_in_browser_activated (MediaButton* self,
                                        GSimpleAction* a,
                                        GVariant* v)
{
	GError* _inner_error0_ = NULL;
#line 277 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 277 "../src/widgets/MediaButton.vala"
	g_return_if_fail (a != NULL);
#line 1178 "MediaButton.c"
	{
		const gchar* _tmp0_ = NULL;
		CbMedia* _tmp1_;
		CbMedia* _tmp2_;
		const gchar* _tmp3_;
		GtkWidget* _tmp7_;
#line 279 "../src/widgets/MediaButton.vala"
		_tmp1_ = media_button_get_media (self);
#line 279 "../src/widgets/MediaButton.vala"
		_tmp2_ = _tmp1_;
#line 279 "../src/widgets/MediaButton.vala"
		_tmp3_ = _tmp2_->target_url;
#line 279 "../src/widgets/MediaButton.vala"
		_tmp0_ = _tmp3_;
#line 279 "../src/widgets/MediaButton.vala"
		if (_tmp0_ == NULL) {
#line 1195 "MediaButton.c"
			CbMedia* _tmp4_;
			CbMedia* _tmp5_;
			const gchar* _tmp6_;
#line 279 "../src/widgets/MediaButton.vala"
			_tmp4_ = media_button_get_media (self);
#line 279 "../src/widgets/MediaButton.vala"
			_tmp5_ = _tmp4_;
#line 279 "../src/widgets/MediaButton.vala"
			_tmp6_ = _tmp5_->url;
#line 279 "../src/widgets/MediaButton.vala"
			_tmp0_ = _tmp6_;
#line 1207 "MediaButton.c"
		}
#line 279 "../src/widgets/MediaButton.vala"
		_tmp7_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 279 "../src/widgets/MediaButton.vala"
		gtk_show_uri_on_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_window_get_type (), GtkWindow), _tmp0_, gtk_get_current_event_time (), &_inner_error0_);
#line 279 "../src/widgets/MediaButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1215 "MediaButton.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 278 "../src/widgets/MediaButton.vala"
		e = _inner_error0_;
#line 278 "../src/widgets/MediaButton.vala"
		_inner_error0_ = NULL;
#line 281 "../src/widgets/MediaButton.vala"
		_tmp8_ = e;
#line 281 "../src/widgets/MediaButton.vala"
		_tmp9_ = _tmp8_->message;
#line 281 "../src/widgets/MediaButton.vala"
		g_critical ("MediaButton.vala:281: %s", _tmp9_);
#line 278 "../src/widgets/MediaButton.vala"
		_g_error_free0 (e);
#line 1237 "MediaButton.c"
	}
	__finally0:
#line 278 "../src/widgets/MediaButton.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/widgets/MediaButton.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/widgets/MediaButton.vala"
		g_clear_error (&_inner_error0_);
#line 278 "../src/widgets/MediaButton.vala"
		return;
#line 1248 "MediaButton.c"
	}
}

static Block84Data*
block84_data_ref (Block84Data* _data84_)
{
#line 299 "../src/widgets/MediaButton.vala"
	g_atomic_int_inc (&_data84_->_ref_count_);
#line 299 "../src/widgets/MediaButton.vala"
	return _data84_;
#line 1259 "MediaButton.c"
}

static void
block84_data_unref (void * _userdata_)
{
	Block84Data* _data84_;
	_data84_ = (Block84Data*) _userdata_;
#line 299 "../src/widgets/MediaButton.vala"
	if (g_atomic_int_dec_and_test (&_data84_->_ref_count_)) {
#line 1269 "MediaButton.c"
		MediaButton* self;
#line 299 "../src/widgets/MediaButton.vala"
		self = _data84_->self;
#line 299 "../src/widgets/MediaButton.vala"
		_g_free0 (_data84_->url);
#line 299 "../src/widgets/MediaButton.vala"
		_g_object_unref0 (self);
#line 299 "../src/widgets/MediaButton.vala"
		g_slice_free (Block84Data, _data84_);
#line 1279 "MediaButton.c"
	}
}

static void
____lambda14_ (Block84Data* _data84_)
{
	MediaButton* self;
	const gchar* _tmp0_;
#line 314 "../src/widgets/MediaButton.vala"
	self = _data84_->self;
#line 315 "../src/widgets/MediaButton.vala"
	_tmp0_ = _data84_->url;
#line 315 "../src/widgets/MediaButton.vala"
	g_debug ("MediaButton.vala:315: Download of %s finished", _tmp0_);
#line 1294 "MediaButton.c"
}

static void
_____lambda14__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 314 "../src/widgets/MediaButton.vala"
	____lambda14_ (self);
#line 314 "../src/widgets/MediaButton.vala"
	block84_data_unref (self);
#line 1306 "MediaButton.c"
}

static void
media_button_save_as_activated (MediaButton* self,
                                GSimpleAction* a,
                                GVariant* v)
{
	gchar* title = NULL;
	CbMedia* _tmp0_;
	GtkFileChooserNative* filechooser = NULL;
	const gchar* _tmp3_;
	GtkWindow* _tmp4_;
	GtkFileChooserNative* _tmp5_;
	GtkFileChooserNative* _tmp6_;
	CbMedia* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkFileChooserNative* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 285 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/widgets/MediaButton.vala"
	g_return_if_fail (a != NULL);
#line 287 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->_media;
#line 287 "../src/widgets/MediaButton.vala"
	if (cb_media_is_video (_tmp0_)) {
#line 1334 "MediaButton.c"
		gchar* _tmp1_;
#line 288 "../src/widgets/MediaButton.vala"
		_tmp1_ = g_strdup (_ ("Save Video"));
#line 288 "../src/widgets/MediaButton.vala"
		_g_free0 (title);
#line 288 "../src/widgets/MediaButton.vala"
		title = _tmp1_;
#line 1342 "MediaButton.c"
	} else {
		gchar* _tmp2_;
#line 290 "../src/widgets/MediaButton.vala"
		_tmp2_ = g_strdup (_ ("Save Image"));
#line 290 "../src/widgets/MediaButton.vala"
		_g_free0 (title);
#line 290 "../src/widgets/MediaButton.vala"
		title = _tmp2_;
#line 1351 "MediaButton.c"
	}
#line 292 "../src/widgets/MediaButton.vala"
	_tmp3_ = title;
#line 292 "../src/widgets/MediaButton.vala"
	_tmp4_ = self->window;
#line 292 "../src/widgets/MediaButton.vala"
	_tmp5_ = gtk_file_chooser_native_new (_tmp3_, _tmp4_, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("Save"), _ ("Cancel"));
#line 292 "../src/widgets/MediaButton.vala"
	filechooser = _tmp5_;
#line 298 "../src/widgets/MediaButton.vala"
	_tmp6_ = filechooser;
#line 298 "../src/widgets/MediaButton.vala"
	_tmp7_ = self->priv->_media;
#line 298 "../src/widgets/MediaButton.vala"
	_tmp8_ = utils_get_media_display_name (_tmp7_);
#line 298 "../src/widgets/MediaButton.vala"
	_tmp9_ = _tmp8_;
#line 298 "../src/widgets/MediaButton.vala"
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp6_, _tmp9_);
#line 298 "../src/widgets/MediaButton.vala"
	_g_free0 (_tmp9_);
#line 299 "../src/widgets/MediaButton.vala"
	_tmp10_ = filechooser;
#line 299 "../src/widgets/MediaButton.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp10_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1377 "MediaButton.c"
		Block84Data* _data84_;
		GFile* file = NULL;
		GtkFileChooserNative* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		const gchar* _tmp16_ = NULL;
		CbMedia* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		GtkFileChooserNative* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GOutputStream* out_stream = NULL;
		GOutputStream* _tmp34_;
#line 299 "../src/widgets/MediaButton.vala"
		_data84_ = g_slice_new0 (Block84Data);
#line 299 "../src/widgets/MediaButton.vala"
		_data84_->_ref_count_ = 1;
#line 299 "../src/widgets/MediaButton.vala"
		_data84_->self = g_object_ref (self);
#line 300 "../src/widgets/MediaButton.vala"
		_tmp11_ = filechooser;
#line 300 "../src/widgets/MediaButton.vala"
		_tmp12_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp11_);
#line 300 "../src/widgets/MediaButton.vala"
		_tmp13_ = _tmp12_;
#line 300 "../src/widgets/MediaButton.vala"
		_tmp14_ = g_file_new_for_path (_tmp13_);
#line 300 "../src/widgets/MediaButton.vala"
		_tmp15_ = _tmp14_;
#line 300 "../src/widgets/MediaButton.vala"
		_g_free0 (_tmp13_);
#line 300 "../src/widgets/MediaButton.vala"
		file = _tmp15_;
#line 302 "../src/widgets/MediaButton.vala"
		_tmp17_ = self->priv->_media;
#line 302 "../src/widgets/MediaButton.vala"
		_tmp18_ = _tmp17_->target_url;
#line 302 "../src/widgets/MediaButton.vala"
		_tmp16_ = _tmp18_;
#line 302 "../src/widgets/MediaButton.vala"
		if (_tmp16_ == NULL) {
#line 1423 "MediaButton.c"
			CbMedia* _tmp19_;
			const gchar* _tmp20_;
#line 302 "../src/widgets/MediaButton.vala"
			_tmp19_ = self->priv->_media;
#line 302 "../src/widgets/MediaButton.vala"
			_tmp20_ = _tmp19_->url;
#line 302 "../src/widgets/MediaButton.vala"
			_tmp16_ = _tmp20_;
#line 1432 "MediaButton.c"
		}
#line 302 "../src/widgets/MediaButton.vala"
		_tmp21_ = g_strdup (_tmp16_);
#line 302 "../src/widgets/MediaButton.vala"
		_data84_->url = _tmp21_;
#line 303 "../src/widgets/MediaButton.vala"
		_tmp22_ = _data84_->url;
#line 303 "../src/widgets/MediaButton.vala"
		_tmp23_ = filechooser;
#line 303 "../src/widgets/MediaButton.vala"
		_tmp24_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp23_);
#line 303 "../src/widgets/MediaButton.vala"
		_tmp25_ = _tmp24_;
#line 303 "../src/widgets/MediaButton.vala"
		g_debug ("MediaButton.vala:303: Downloading %s to %s", _tmp22_, _tmp25_);
#line 303 "../src/widgets/MediaButton.vala"
		_g_free0 (_tmp25_);
#line 305 "../src/widgets/MediaButton.vala"
		out_stream = NULL;
#line 1452 "MediaButton.c"
		{
			GFileOutputStream* _tmp26_ = NULL;
			GFile* _tmp27_;
			GFileOutputStream* _tmp28_;
			GFileOutputStream* _tmp29_;
#line 307 "../src/widgets/MediaButton.vala"
			_tmp27_ = file;
#line 307 "../src/widgets/MediaButton.vala"
			_tmp28_ = g_file_create (_tmp27_, 0, NULL, &_inner_error0_);
#line 307 "../src/widgets/MediaButton.vala"
			_tmp26_ = _tmp28_;
#line 307 "../src/widgets/MediaButton.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1466 "MediaButton.c"
				goto __catch0_g_error;
			}
#line 307 "../src/widgets/MediaButton.vala"
			_tmp29_ = _tmp26_;
#line 307 "../src/widgets/MediaButton.vala"
			_tmp26_ = NULL;
#line 307 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (out_stream);
#line 307 "../src/widgets/MediaButton.vala"
			out_stream = (GOutputStream*) _tmp29_;
#line 306 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (_tmp26_);
#line 1479 "MediaButton.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp30_;
			GtkWindow* _tmp31_;
			GError* _tmp32_;
			const gchar* _tmp33_;
#line 306 "../src/widgets/MediaButton.vala"
			e = _inner_error0_;
#line 306 "../src/widgets/MediaButton.vala"
			_inner_error0_ = NULL;
#line 309 "../src/widgets/MediaButton.vala"
			_tmp30_ = e;
#line 309 "../src/widgets/MediaButton.vala"
			_tmp31_ = self->window;
#line 309 "../src/widgets/MediaButton.vala"
			utils_show_error_dialog (_tmp30_, _tmp31_, NULL, 0);
#line 310 "../src/widgets/MediaButton.vala"
			_tmp32_ = e;
#line 310 "../src/widgets/MediaButton.vala"
			_tmp33_ = _tmp32_->message;
#line 310 "../src/widgets/MediaButton.vala"
			g_warning ("MediaButton.vala:310: %s", _tmp33_);
#line 306 "../src/widgets/MediaButton.vala"
			_g_error_free0 (e);
#line 1507 "MediaButton.c"
		}
		__finally0:
#line 306 "../src/widgets/MediaButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 306 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (out_stream);
#line 306 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (file);
#line 306 "../src/widgets/MediaButton.vala"
			block84_data_unref (_data84_);
#line 306 "../src/widgets/MediaButton.vala"
			_data84_ = NULL;
#line 306 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (filechooser);
#line 306 "../src/widgets/MediaButton.vala"
			_g_free0 (title);
#line 306 "../src/widgets/MediaButton.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 306 "../src/widgets/MediaButton.vala"
			g_clear_error (&_inner_error0_);
#line 306 "../src/widgets/MediaButton.vala"
			return;
#line 1530 "MediaButton.c"
		}
#line 313 "../src/widgets/MediaButton.vala"
		_tmp34_ = out_stream;
#line 313 "../src/widgets/MediaButton.vala"
		if (_tmp34_ != NULL) {
#line 1536 "MediaButton.c"
			const gchar* _tmp35_;
			GOutputStream* _tmp36_;
#line 314 "../src/widgets/MediaButton.vala"
			_tmp35_ = _data84_->url;
#line 314 "../src/widgets/MediaButton.vala"
			_tmp36_ = out_stream;
#line 314 "../src/widgets/MediaButton.vala"
			utils_download_file (_tmp35_, _tmp36_, _____lambda14__gasync_ready_callback, block84_data_ref (_data84_));
#line 1545 "MediaButton.c"
		}
#line 299 "../src/widgets/MediaButton.vala"
		_g_object_unref0 (out_stream);
#line 299 "../src/widgets/MediaButton.vala"
		_g_object_unref0 (file);
#line 299 "../src/widgets/MediaButton.vala"
		block84_data_unref (_data84_);
#line 299 "../src/widgets/MediaButton.vala"
		_data84_ = NULL;
#line 1555 "MediaButton.c"
	}
#line 285 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (filechooser);
#line 285 "../src/widgets/MediaButton.vala"
	_g_free0 (title);
#line 1561 "MediaButton.c"
}

static GtkSizeRequestMode
media_button_real_get_request_mode (GtkWidget* base)
{
	MediaButton * self;
	GtkSizeRequestMode result;
#line 321 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 322 "../src/widgets/MediaButton.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 322 "../src/widgets/MediaButton.vala"
	return result;
#line 1575 "MediaButton.c"
}

static void
media_button_real_get_preferred_height (GtkWidget* base,
                                        gint* minimum,
                                        gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_height = 0;
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
#line 325 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 328 "../src/widgets/MediaButton.vala"
	_tmp1_ = self->priv->_media;
#line 328 "../src/widgets/MediaButton.vala"
	if (_tmp1_ == NULL) {
#line 328 "../src/widgets/MediaButton.vala"
		_tmp0_ = TRUE;
#line 1597 "MediaButton.c"
	} else {
		CbMedia* _tmp2_;
#line 328 "../src/widgets/MediaButton.vala"
		_tmp2_ = self->priv->_media;
#line 328 "../src/widgets/MediaButton.vala"
		_tmp0_ = _tmp2_->thumb_height == -1;
#line 1604 "MediaButton.c"
	}
#line 328 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 329 "../src/widgets/MediaButton.vala"
		media_height = 1;
#line 1610 "MediaButton.c"
	} else {
		CbMedia* _tmp3_;
#line 331 "../src/widgets/MediaButton.vala"
		_tmp3_ = self->priv->_media;
#line 331 "../src/widgets/MediaButton.vala"
		media_height = _tmp3_->thumb_height;
#line 1617 "MediaButton.c"
	}
#line 334 "../src/widgets/MediaButton.vala"
	if (self->priv->restrict_height) {
#line 335 "../src/widgets/MediaButton.vala"
		_vala_minimum = MIN (media_height, MEDIA_BUTTON_MAX_HEIGHT);
#line 1623 "MediaButton.c"
	} else {
#line 338 "../src/widgets/MediaButton.vala"
		_vala_minimum = media_height;
#line 1627 "MediaButton.c"
	}
#line 341 "../src/widgets/MediaButton.vala"
	_vala_natural = media_height;
#line 325 "../src/widgets/MediaButton.vala"
	if (minimum) {
#line 325 "../src/widgets/MediaButton.vala"
		*minimum = _vala_minimum;
#line 1635 "MediaButton.c"
	}
#line 325 "../src/widgets/MediaButton.vala"
	if (natural) {
#line 325 "../src/widgets/MediaButton.vala"
		*natural = _vala_natural;
#line 1641 "MediaButton.c"
	}
}

static void
media_button_real_get_preferred_height_for_width (GtkWidget* base,
                                                  gint width,
                                                  gint* minimum,
                                                  gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gint media_height = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	CbMedia* _tmp2_;
	gdouble scale = 0.0;
	gint height = 0;
#line 344 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 350 "../src/widgets/MediaButton.vala"
	_tmp2_ = self->priv->_media;
#line 350 "../src/widgets/MediaButton.vala"
	if (_tmp2_ == NULL) {
#line 350 "../src/widgets/MediaButton.vala"
		_tmp1_ = TRUE;
#line 1669 "MediaButton.c"
	} else {
		CbMedia* _tmp3_;
#line 350 "../src/widgets/MediaButton.vala"
		_tmp3_ = self->priv->_media;
#line 350 "../src/widgets/MediaButton.vala"
		_tmp1_ = _tmp3_->thumb_width == -1;
#line 1676 "MediaButton.c"
	}
#line 350 "../src/widgets/MediaButton.vala"
	if (_tmp1_) {
#line 350 "../src/widgets/MediaButton.vala"
		_tmp0_ = TRUE;
#line 1682 "MediaButton.c"
	} else {
		CbMedia* _tmp4_;
#line 350 "../src/widgets/MediaButton.vala"
		_tmp4_ = self->priv->_media;
#line 350 "../src/widgets/MediaButton.vala"
		_tmp0_ = _tmp4_->thumb_height == -1;
#line 1689 "MediaButton.c"
	}
#line 350 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 351 "../src/widgets/MediaButton.vala"
		media_width = MEDIA_BUTTON_MIN_WIDTH;
#line 352 "../src/widgets/MediaButton.vala"
		media_height = MEDIA_BUTTON_MAX_HEIGHT;
#line 1697 "MediaButton.c"
	} else {
		CbMedia* _tmp5_;
		CbMedia* _tmp6_;
#line 354 "../src/widgets/MediaButton.vala"
		_tmp5_ = self->priv->_media;
#line 354 "../src/widgets/MediaButton.vala"
		media_width = _tmp5_->thumb_width;
#line 355 "../src/widgets/MediaButton.vala"
		_tmp6_ = self->priv->_media;
#line 355 "../src/widgets/MediaButton.vala"
		media_height = _tmp6_->thumb_height;
#line 1709 "MediaButton.c"
	}
#line 358 "../src/widgets/MediaButton.vala"
	scale = width / ((gdouble) media_width);
#line 360 "../src/widgets/MediaButton.vala"
	height = 0;
#line 362 "../src/widgets/MediaButton.vala"
	if (scale >= ((gdouble) 1)) {
#line 363 "../src/widgets/MediaButton.vala"
		height = MIN (media_height, (gint) floor ((width / 9.0) * 16));
#line 1719 "MediaButton.c"
	} else {
#line 365 "../src/widgets/MediaButton.vala"
		height = (gint) floor (MIN (media_height * scale, ((media_width * scale) / 9.0) * 16));
#line 1723 "MediaButton.c"
	}
#line 368 "../src/widgets/MediaButton.vala"
	if (self->priv->restrict_height) {
#line 369 "../src/widgets/MediaButton.vala"
		height = MIN (height, MEDIA_BUTTON_MAX_HEIGHT);
#line 1729 "MediaButton.c"
	}
#line 372 "../src/widgets/MediaButton.vala"
	_vala_natural = height;
#line 372 "../src/widgets/MediaButton.vala"
	_vala_minimum = _vala_natural;
#line 344 "../src/widgets/MediaButton.vala"
	if (minimum) {
#line 344 "../src/widgets/MediaButton.vala"
		*minimum = _vala_minimum;
#line 1739 "MediaButton.c"
	}
#line 344 "../src/widgets/MediaButton.vala"
	if (natural) {
#line 344 "../src/widgets/MediaButton.vala"
		*natural = _vala_natural;
#line 1745 "MediaButton.c"
	}
}

static void
media_button_real_get_preferred_width_for_height (GtkWidget* base,
                                                  gint height,
                                                  gint* minimum,
                                                  gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gint media_height = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	CbMedia* _tmp2_;
	gint max_width = 0;
	gint width = 0;
#line 375 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 381 "../src/widgets/MediaButton.vala"
	_tmp2_ = self->priv->_media;
#line 381 "../src/widgets/MediaButton.vala"
	if (_tmp2_ == NULL) {
#line 381 "../src/widgets/MediaButton.vala"
		_tmp1_ = TRUE;
#line 1773 "MediaButton.c"
	} else {
		CbMedia* _tmp3_;
#line 381 "../src/widgets/MediaButton.vala"
		_tmp3_ = self->priv->_media;
#line 381 "../src/widgets/MediaButton.vala"
		_tmp1_ = _tmp3_->thumb_width == -1;
#line 1780 "MediaButton.c"
	}
#line 381 "../src/widgets/MediaButton.vala"
	if (_tmp1_) {
#line 381 "../src/widgets/MediaButton.vala"
		_tmp0_ = TRUE;
#line 1786 "MediaButton.c"
	} else {
		CbMedia* _tmp4_;
#line 381 "../src/widgets/MediaButton.vala"
		_tmp4_ = self->priv->_media;
#line 381 "../src/widgets/MediaButton.vala"
		_tmp0_ = _tmp4_->thumb_height == -1;
#line 1793 "MediaButton.c"
	}
#line 381 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 382 "../src/widgets/MediaButton.vala"
		media_width = MEDIA_BUTTON_MIN_WIDTH;
#line 383 "../src/widgets/MediaButton.vala"
		media_height = MEDIA_BUTTON_MAX_HEIGHT;
#line 1801 "MediaButton.c"
	} else {
		CbMedia* _tmp5_;
		CbMedia* _tmp6_;
#line 385 "../src/widgets/MediaButton.vala"
		_tmp5_ = self->priv->_media;
#line 385 "../src/widgets/MediaButton.vala"
		media_width = _tmp5_->thumb_width;
#line 386 "../src/widgets/MediaButton.vala"
		_tmp6_ = self->priv->_media;
#line 386 "../src/widgets/MediaButton.vala"
		media_height = _tmp6_->thumb_height;
#line 1813 "MediaButton.c"
	}
#line 389 "../src/widgets/MediaButton.vala"
	max_width = (gint) floor ((height / 16.0) * 9);
#line 390 "../src/widgets/MediaButton.vala"
	width = MIN (media_width, max_width);
#line 391 "../src/widgets/MediaButton.vala"
	_vala_minimum = MEDIA_BUTTON_MIN_WIDTH;
#line 392 "../src/widgets/MediaButton.vala"
	_vala_natural = MAX (width, _vala_minimum);
#line 375 "../src/widgets/MediaButton.vala"
	if (minimum) {
#line 375 "../src/widgets/MediaButton.vala"
		*minimum = _vala_minimum;
#line 1827 "MediaButton.c"
	}
#line 375 "../src/widgets/MediaButton.vala"
	if (natural) {
#line 375 "../src/widgets/MediaButton.vala"
		*natural = _vala_natural;
#line 1833 "MediaButton.c"
	}
}

static void
media_button_real_get_preferred_width (GtkWidget* base,
                                       gint* minimum,
                                       gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
#line 395 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 398 "../src/widgets/MediaButton.vala"
	_tmp1_ = self->priv->_media;
#line 398 "../src/widgets/MediaButton.vala"
	if (_tmp1_ == NULL) {
#line 398 "../src/widgets/MediaButton.vala"
		_tmp0_ = TRUE;
#line 1856 "MediaButton.c"
	} else {
		CbMedia* _tmp2_;
#line 398 "../src/widgets/MediaButton.vala"
		_tmp2_ = self->priv->_media;
#line 398 "../src/widgets/MediaButton.vala"
		_tmp0_ = _tmp2_->thumb_width == -1;
#line 1863 "MediaButton.c"
	}
#line 398 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 399 "../src/widgets/MediaButton.vala"
		media_width = 1;
#line 1869 "MediaButton.c"
	} else {
		CbMedia* _tmp3_;
#line 401 "../src/widgets/MediaButton.vala"
		_tmp3_ = self->priv->_media;
#line 401 "../src/widgets/MediaButton.vala"
		media_width = _tmp3_->thumb_width;
#line 1876 "MediaButton.c"
	}
#line 404 "../src/widgets/MediaButton.vala"
	_vala_minimum = MIN (media_width, MEDIA_BUTTON_MIN_WIDTH);
#line 405 "../src/widgets/MediaButton.vala"
	_vala_natural = media_width;
#line 395 "../src/widgets/MediaButton.vala"
	if (minimum) {
#line 395 "../src/widgets/MediaButton.vala"
		*minimum = _vala_minimum;
#line 1886 "MediaButton.c"
	}
#line 395 "../src/widgets/MediaButton.vala"
	if (natural) {
#line 395 "../src/widgets/MediaButton.vala"
		*natural = _vala_natural;
#line 1892 "MediaButton.c"
	}
}

static void
media_button_real_realize (GtkWidget* base)
{
	MediaButton * self;
	GdkWindowAttr attr = {0};
	GdkWindowAttr _tmp0_ = {0};
	GdkVisual* _tmp1_;
	GdkWindowAttributesType attr_mask = 0U;
	GdkWindow* window = NULL;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GdkWindow* _tmp4_;
	GdkWindowAttr _tmp5_;
	GdkWindow* _tmp6_;
	GdkWindow* _tmp7_;
#line 408 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 409 "../src/widgets/MediaButton.vala"
	gtk_widget_set_realized ((GtkWidget*) self, TRUE);
#line 411 "../src/widgets/MediaButton.vala"
	attr = _tmp0_;
#line 412 "../src/widgets/MediaButton.vala"
	attr.x = 0;
#line 413 "../src/widgets/MediaButton.vala"
	attr.y = 0;
#line 414 "../src/widgets/MediaButton.vala"
	attr.width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 415 "../src/widgets/MediaButton.vala"
	attr.height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 416 "../src/widgets/MediaButton.vala"
	attr.window_type = GDK_WINDOW_CHILD;
#line 417 "../src/widgets/MediaButton.vala"
	_tmp1_ = gtk_widget_get_visual ((GtkWidget*) self);
#line 417 "../src/widgets/MediaButton.vala"
	attr.visual = _tmp1_;
#line 418 "../src/widgets/MediaButton.vala"
	attr.wclass = GDK_INPUT_ONLY;
#line 419 "../src/widgets/MediaButton.vala"
	attr.event_mask = ((((gtk_widget_get_events ((GtkWidget*) self) | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_TOUCH_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK;
#line 426 "../src/widgets/MediaButton.vala"
	attr_mask = GDK_WA_X | GDK_WA_Y;
#line 428 "../src/widgets/MediaButton.vala"
	_tmp2_ = gtk_widget_get_parent_window ((GtkWidget*) self);
#line 428 "../src/widgets/MediaButton.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 428 "../src/widgets/MediaButton.vala"
	window = _tmp3_;
#line 429 "../src/widgets/MediaButton.vala"
	_tmp4_ = _g_object_ref0 (window);
#line 429 "../src/widgets/MediaButton.vala"
	gtk_widget_set_window ((GtkWidget*) self, _tmp4_);
#line 430 "../src/widgets/MediaButton.vala"
	g_object_ref ((GObject*) window);
#line 432 "../src/widgets/MediaButton.vala"
	_tmp5_ = attr;
#line 432 "../src/widgets/MediaButton.vala"
	_tmp6_ = gdk_window_new (window, &_tmp5_, attr_mask);
#line 432 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->event_window);
#line 432 "../src/widgets/MediaButton.vala"
	self->priv->event_window = _tmp6_;
#line 433 "../src/widgets/MediaButton.vala"
	_tmp7_ = self->priv->event_window;
#line 433 "../src/widgets/MediaButton.vala"
	gtk_widget_register_window ((GtkWidget*) self, _tmp7_);
#line 408 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (window);
#line 1963 "MediaButton.c"
}

static void
media_button_real_unrealize (GtkWidget* base)
{
	MediaButton * self;
	GdkWindow* _tmp0_;
#line 436 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 437 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->event_window;
#line 437 "../src/widgets/MediaButton.vala"
	if (_tmp0_ != NULL) {
#line 1977 "MediaButton.c"
		GdkWindow* _tmp1_;
		GdkWindow* _tmp2_;
		GdkWindow* _tmp3_;
#line 438 "../src/widgets/MediaButton.vala"
		_tmp1_ = self->priv->event_window;
#line 438 "../src/widgets/MediaButton.vala"
		gtk_widget_unregister_window ((GtkWidget*) self, _tmp1_);
#line 439 "../src/widgets/MediaButton.vala"
		_tmp2_ = self->priv->event_window;
#line 439 "../src/widgets/MediaButton.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 439 "../src/widgets/MediaButton.vala"
		gdk_window_destroy (_tmp3_);
#line 440 "../src/widgets/MediaButton.vala"
		_g_object_unref0 (self->priv->event_window);
#line 440 "../src/widgets/MediaButton.vala"
		self->priv->event_window = NULL;
#line 1995 "MediaButton.c"
	}
#line 442 "../src/widgets/MediaButton.vala"
	GTK_WIDGET_CLASS (media_button_parent_class)->unrealize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
#line 1999 "MediaButton.c"
}

static void
media_button_real_map (GtkWidget* base)
{
	MediaButton * self;
	GdkWindow* _tmp0_;
#line 445 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 446 "../src/widgets/MediaButton.vala"
	GTK_WIDGET_CLASS (media_button_parent_class)->map ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
#line 448 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->event_window;
#line 448 "../src/widgets/MediaButton.vala"
	if (_tmp0_ != NULL) {
#line 2015 "MediaButton.c"
		GdkWindow* _tmp1_;
#line 449 "../src/widgets/MediaButton.vala"
		_tmp1_ = self->priv->event_window;
#line 449 "../src/widgets/MediaButton.vala"
		gdk_window_show (_tmp1_);
#line 2021 "MediaButton.c"
	}
}

static void
media_button_real_unmap (GtkWidget* base)
{
	MediaButton * self;
	GdkWindow* _tmp0_;
#line 452 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 454 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->event_window;
#line 454 "../src/widgets/MediaButton.vala"
	if (_tmp0_ != NULL) {
#line 2036 "MediaButton.c"
		GdkWindow* _tmp1_;
#line 455 "../src/widgets/MediaButton.vala"
		_tmp1_ = self->priv->event_window;
#line 455 "../src/widgets/MediaButton.vala"
		gdk_window_hide (_tmp1_);
#line 2042 "MediaButton.c"
	}
#line 457 "../src/widgets/MediaButton.vala"
	GTK_WIDGET_CLASS (media_button_parent_class)->unmap ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
#line 2046 "MediaButton.c"
}

static void
media_button_real_size_allocate (GtkWidget* base,
                                 GtkAllocation* alloc)
{
	MediaButton * self;
	GtkAllocation _tmp0_;
#line 460 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 460 "../src/widgets/MediaButton.vala"
	g_return_if_fail (alloc != NULL);
#line 461 "../src/widgets/MediaButton.vala"
	_tmp0_ = *alloc;
#line 461 "../src/widgets/MediaButton.vala"
	GTK_WIDGET_CLASS (media_button_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), &_tmp0_);
#line 463 "../src/widgets/MediaButton.vala"
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
#line 2065 "MediaButton.c"
		gint draw_x = 0;
		gint draw_y = 0;
		gdouble scale = 0.0;
		CbMedia* _tmp1_;
		CbMedia* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gdouble _tmp5_ = 0.0;
		gint draw_width = 0;
		GtkAllocation _tmp6_;
		gint draw_height = 0;
		GtkAllocation _tmp7_;
		GdkWindow* _tmp8_;
		GtkAllocation _tmp9_;
		GtkAllocation _tmp10_;
#line 466 "../src/widgets/MediaButton.vala"
		_tmp1_ = self->priv->_media;
#line 466 "../src/widgets/MediaButton.vala"
		_tmp2_ = self->priv->_media;
#line 466 "../src/widgets/MediaButton.vala"
		utils_calculate_draw_offset (_tmp1_->thumb_width, _tmp2_->thumb_height, gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self), &_tmp3_, &_tmp4_, &_tmp5_);
#line 466 "../src/widgets/MediaButton.vala"
		draw_x = _tmp3_;
#line 466 "../src/widgets/MediaButton.vala"
		draw_y = _tmp4_;
#line 466 "../src/widgets/MediaButton.vala"
		scale = _tmp5_;
#line 470 "../src/widgets/MediaButton.vala"
		_tmp6_ = *alloc;
#line 470 "../src/widgets/MediaButton.vala"
		draw_width = _tmp6_.width - (draw_x * 2);
#line 471 "../src/widgets/MediaButton.vala"
		_tmp7_ = *alloc;
#line 471 "../src/widgets/MediaButton.vala"
		draw_height = _tmp7_.height - draw_y;
#line 472 "../src/widgets/MediaButton.vala"
		_tmp8_ = self->priv->event_window;
#line 472 "../src/widgets/MediaButton.vala"
		_tmp9_ = *alloc;
#line 472 "../src/widgets/MediaButton.vala"
		_tmp10_ = *alloc;
#line 472 "../src/widgets/MediaButton.vala"
		gdk_window_move_resize (_tmp8_, _tmp9_.x + draw_x, _tmp10_.y + MAX (0, draw_y), draw_width, draw_height);
#line 2109 "MediaButton.c"
	}
}

static gboolean
media_button_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* evt)
{
	MediaButton * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result;
#line 477 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 477 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 478 "../src/widgets/MediaButton.vala"
	_tmp1_ = evt->window;
#line 478 "../src/widgets/MediaButton.vala"
	_tmp2_ = self->priv->event_window;
#line 478 "../src/widgets/MediaButton.vala"
	if (_tmp1_ == _tmp2_) {
#line 479 "../src/widgets/MediaButton.vala"
		_tmp0_ = evt->detail != GDK_NOTIFY_INFERIOR;
#line 2134 "MediaButton.c"
	} else {
#line 478 "../src/widgets/MediaButton.vala"
		_tmp0_ = FALSE;
#line 2138 "MediaButton.c"
	}
#line 478 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 480 "../src/widgets/MediaButton.vala"
		gtk_widget_set_state_flags ((GtkWidget*) self, gtk_widget_get_state_flags ((GtkWidget*) self) | GTK_STATE_FLAG_PRELIGHT, TRUE);
#line 2144 "MediaButton.c"
	}
#line 484 "../src/widgets/MediaButton.vala"
	result = GDK_EVENT_PROPAGATE;
#line 484 "../src/widgets/MediaButton.vala"
	return result;
#line 2150 "MediaButton.c"
}

static gboolean
media_button_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* evt)
{
	MediaButton * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result;
#line 487 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 487 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 488 "../src/widgets/MediaButton.vala"
	_tmp1_ = evt->window;
#line 488 "../src/widgets/MediaButton.vala"
	_tmp2_ = self->priv->event_window;
#line 488 "../src/widgets/MediaButton.vala"
	if (_tmp1_ == _tmp2_) {
#line 489 "../src/widgets/MediaButton.vala"
		_tmp0_ = evt->detail != GDK_NOTIFY_INFERIOR;
#line 2174 "MediaButton.c"
	} else {
#line 488 "../src/widgets/MediaButton.vala"
		_tmp0_ = FALSE;
#line 2178 "MediaButton.c"
	}
#line 488 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 490 "../src/widgets/MediaButton.vala"
		gtk_widget_set_state_flags ((GtkWidget*) self, gtk_widget_get_state_flags ((GtkWidget*) self) & (~GTK_STATE_FLAG_PRELIGHT), TRUE);
#line 2184 "MediaButton.c"
	}
#line 494 "../src/widgets/MediaButton.vala"
	result = GDK_EVENT_PROPAGATE;
#line 494 "../src/widgets/MediaButton.vala"
	return result;
#line 2190 "MediaButton.c"
}

static GdkEvent*
_vala_GdkEvent_copy (GdkEvent* self)
{
#line 501 "../src/widgets/MediaButton.vala"
	return g_boxed_copy (gdk_event_get_type (), self);
#line 2198 "MediaButton.c"
}

static gpointer
__vala_GdkEvent_copy0 (gpointer self)
{
#line 501 "../src/widgets/MediaButton.vala"
	return self ? _vala_GdkEvent_copy (self) : NULL;
#line 2206 "MediaButton.c"
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
#line 504 "../src/widgets/MediaButton.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 2214 "MediaButton.c"
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
#line 504 "../src/widgets/MediaButton.vala"
	g_boxed_free (gdk_event_sequence_get_type (), self);
#line 2222 "MediaButton.c"
}

static void
media_button_gesture_pressed_cb (MediaButton* self,
                                 gint n_press,
                                 gdouble x,
                                 gdouble y)
{
	GdkEventSequence* sequence = NULL;
	GtkGestureMultiPress* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* event = NULL;
	GtkGestureMultiPress* _tmp2_;
	GdkEventSequence* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
	CbMedia* _tmp6_;
	GdkEvent* _tmp7_;
#line 497 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 500 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->press_gesture;
#line 500 "../src/widgets/MediaButton.vala"
	_tmp1_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) _tmp0_);
#line 500 "../src/widgets/MediaButton.vala"
	sequence = _tmp1_;
#line 501 "../src/widgets/MediaButton.vala"
	_tmp2_ = self->priv->press_gesture;
#line 501 "../src/widgets/MediaButton.vala"
	_tmp3_ = sequence;
#line 501 "../src/widgets/MediaButton.vala"
	_tmp4_ = gtk_gesture_get_last_event ((GtkGesture*) _tmp2_, _tmp3_);
#line 501 "../src/widgets/MediaButton.vala"
	_tmp5_ = __vala_GdkEvent_copy0 (_tmp4_);
#line 501 "../src/widgets/MediaButton.vala"
	event = _tmp5_;
#line 503 "../src/widgets/MediaButton.vala"
	_tmp6_ = self->priv->_media;
#line 503 "../src/widgets/MediaButton.vala"
	if (_tmp6_ == NULL) {
#line 504 "../src/widgets/MediaButton.vala"
		__vala_GdkEvent_free0 (event);
#line 504 "../src/widgets/MediaButton.vala"
		__vala_GdkEventSequence_free0 (sequence);
#line 504 "../src/widgets/MediaButton.vala"
		return;
#line 2269 "MediaButton.c"
	}
#line 506 "../src/widgets/MediaButton.vala"
	_tmp7_ = event;
#line 506 "../src/widgets/MediaButton.vala"
	if (gdk_event_triggers_context_menu (_tmp7_)) {
#line 2275 "MediaButton.c"
		GtkGestureMultiPress* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenu* _tmp13_;
		GtkMenu* _tmp14_;
		GdkEvent* _tmp15_;
#line 507 "../src/widgets/MediaButton.vala"
		_tmp8_ = self->priv->press_gesture;
#line 507 "../src/widgets/MediaButton.vala"
		gtk_gesture_set_state ((GtkGesture*) _tmp8_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 509 "../src/widgets/MediaButton.vala"
		_tmp9_ = self->priv->menu;
#line 509 "../src/widgets/MediaButton.vala"
		if (_tmp9_ == NULL) {
#line 2289 "MediaButton.c"
			GMenu* _tmp10_;
			GtkMenu* _tmp11_;
			GtkMenu* _tmp12_;
#line 510 "../src/widgets/MediaButton.vala"
			_tmp10_ = self->priv->menu_model;
#line 510 "../src/widgets/MediaButton.vala"
			_tmp11_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) _tmp10_);
#line 510 "../src/widgets/MediaButton.vala"
			g_object_ref_sink (_tmp11_);
#line 510 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (self->priv->menu);
#line 510 "../src/widgets/MediaButton.vala"
			self->priv->menu = _tmp11_;
#line 511 "../src/widgets/MediaButton.vala"
			_tmp12_ = self->priv->menu;
#line 511 "../src/widgets/MediaButton.vala"
			gtk_menu_attach_to_widget (_tmp12_, (GtkWidget*) self, NULL);
#line 2307 "MediaButton.c"
		}
#line 513 "../src/widgets/MediaButton.vala"
		_tmp13_ = self->priv->menu;
#line 513 "../src/widgets/MediaButton.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp13_);
#line 514 "../src/widgets/MediaButton.vala"
		_tmp14_ = self->priv->menu;
#line 514 "../src/widgets/MediaButton.vala"
		_tmp15_ = event;
#line 514 "../src/widgets/MediaButton.vala"
		gtk_menu_popup_at_pointer (_tmp14_, _tmp15_);
#line 2319 "MediaButton.c"
	}
#line 497 "../src/widgets/MediaButton.vala"
	__vala_GdkEvent_free0 (event);
#line 497 "../src/widgets/MediaButton.vala"
	__vala_GdkEventSequence_free0 (sequence);
#line 2325 "MediaButton.c"
}

static void
media_button_gesture_released_cb (MediaButton* self,
                                  gint n_press,
                                  gdouble x,
                                  gdouble y)
{
	GdkEventSequence* sequence = NULL;
	GtkGestureMultiPress* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* event = NULL;
	GtkGestureMultiPress* _tmp2_;
	GdkEventSequence* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
	guint button = 0U;
	GtkGestureMultiPress* _tmp6_;
	gboolean _tmp7_ = FALSE;
	CbMedia* _tmp8_;
#line 518 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 521 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->press_gesture;
#line 521 "../src/widgets/MediaButton.vala"
	_tmp1_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) _tmp0_);
#line 521 "../src/widgets/MediaButton.vala"
	sequence = _tmp1_;
#line 522 "../src/widgets/MediaButton.vala"
	_tmp2_ = self->priv->press_gesture;
#line 522 "../src/widgets/MediaButton.vala"
	_tmp3_ = sequence;
#line 522 "../src/widgets/MediaButton.vala"
	_tmp4_ = gtk_gesture_get_last_event ((GtkGesture*) _tmp2_, _tmp3_);
#line 522 "../src/widgets/MediaButton.vala"
	_tmp5_ = __vala_GdkEvent_copy0 (_tmp4_);
#line 522 "../src/widgets/MediaButton.vala"
	event = _tmp5_;
#line 523 "../src/widgets/MediaButton.vala"
	_tmp6_ = self->priv->press_gesture;
#line 523 "../src/widgets/MediaButton.vala"
	button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _tmp6_);
#line 525 "../src/widgets/MediaButton.vala"
	_tmp8_ = self->priv->_media;
#line 525 "../src/widgets/MediaButton.vala"
	if (_tmp8_ == NULL) {
#line 525 "../src/widgets/MediaButton.vala"
		_tmp7_ = TRUE;
#line 2374 "MediaButton.c"
	} else {
		GdkEvent* _tmp9_;
#line 525 "../src/widgets/MediaButton.vala"
		_tmp9_ = event;
#line 525 "../src/widgets/MediaButton.vala"
		_tmp7_ = _tmp9_ == NULL;
#line 2381 "MediaButton.c"
	}
#line 525 "../src/widgets/MediaButton.vala"
	if (_tmp7_) {
#line 526 "../src/widgets/MediaButton.vala"
		__vala_GdkEvent_free0 (event);
#line 526 "../src/widgets/MediaButton.vala"
		__vala_GdkEventSequence_free0 (sequence);
#line 526 "../src/widgets/MediaButton.vala"
		return;
#line 2391 "MediaButton.c"
	}
#line 528 "../src/widgets/MediaButton.vala"
	if (button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 2395 "MediaButton.c"
		CbMedia* _tmp10_;
#line 529 "../src/widgets/MediaButton.vala"
		_tmp10_ = self->priv->_media;
#line 529 "../src/widgets/MediaButton.vala"
		if (_tmp10_->invalid) {
#line 530 "../src/widgets/MediaButton.vala"
			media_button_reload_image (self);
#line 2403 "MediaButton.c"
		} else {
			GtkGestureMultiPress* _tmp11_;
			gdouble px = 0.0;
			gdouble py = 0.0;
#line 533 "../src/widgets/MediaButton.vala"
			_tmp11_ = self->priv->press_gesture;
#line 533 "../src/widgets/MediaButton.vala"
			gtk_gesture_set_state ((GtkGesture*) _tmp11_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 534 "../src/widgets/MediaButton.vala"
			px = x / ((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self));
#line 535 "../src/widgets/MediaButton.vala"
			py = y / ((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 536 "../src/widgets/MediaButton.vala"
			g_signal_emit (self, media_button_signals[MEDIA_BUTTON_CLICKED_SIGNAL], 0, self, px, py);
#line 2418 "MediaButton.c"
		}
	}
#line 518 "../src/widgets/MediaButton.vala"
	__vala_GdkEvent_free0 (event);
#line 518 "../src/widgets/MediaButton.vala"
	__vala_GdkEventSequence_free0 (sequence);
#line 2425 "MediaButton.c"
}

static gboolean
media_button_real_key_press_event (GtkWidget* base,
                                   GdkEventKey* event)
{
	MediaButton * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 541 "../src/widgets/MediaButton.vala"
	self = (MediaButton*) base;
#line 541 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 542 "../src/widgets/MediaButton.vala"
	if (event->keyval == GDK_KEY_Return) {
#line 542 "../src/widgets/MediaButton.vala"
		_tmp0_ = TRUE;
#line 2443 "MediaButton.c"
	} else {
#line 543 "../src/widgets/MediaButton.vala"
		_tmp0_ = event->keyval == GDK_KEY_KP_Enter;
#line 2447 "MediaButton.c"
	}
#line 542 "../src/widgets/MediaButton.vala"
	if (_tmp0_) {
#line 2451 "MediaButton.c"
		CbMedia* _tmp1_;
#line 544 "../src/widgets/MediaButton.vala"
		_tmp1_ = self->priv->_media;
#line 544 "../src/widgets/MediaButton.vala"
		if (_tmp1_->invalid) {
#line 545 "../src/widgets/MediaButton.vala"
			media_button_reload_image (self);
#line 2459 "MediaButton.c"
		} else {
#line 548 "../src/widgets/MediaButton.vala"
			g_signal_emit (self, media_button_signals[MEDIA_BUTTON_CLICKED_SIGNAL], 0, self, 0.5, 0.5);
#line 2463 "MediaButton.c"
		}
#line 550 "../src/widgets/MediaButton.vala"
		result = GDK_EVENT_STOP;
#line 550 "../src/widgets/MediaButton.vala"
		return result;
#line 2469 "MediaButton.c"
	}
#line 553 "../src/widgets/MediaButton.vala"
	result = GDK_EVENT_PROPAGATE;
#line 553 "../src/widgets/MediaButton.vala"
	return result;
#line 2475 "MediaButton.c"
}

static void
media_button_set_image_description (MediaButton* self)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp1_;
#line 556 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 557 "../src/widgets/MediaButton.vala"
	_tmp0_ = media_button_get_media (self);
#line 557 "../src/widgets/MediaButton.vala"
	_tmp1_ = _tmp0_;
#line 557 "../src/widgets/MediaButton.vala"
	if (_tmp1_ != NULL) {
#line 2491 "MediaButton.c"
		CbMedia* _tmp2_;
		CbMedia* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_ = NULL;
		CbMedia* _tmp6_;
		CbMedia* _tmp7_;
		const gchar* _tmp8_;
		AtkObject* _tmp9_;
#line 558 "../src/widgets/MediaButton.vala"
		_tmp2_ = media_button_get_media (self);
#line 558 "../src/widgets/MediaButton.vala"
		_tmp3_ = _tmp2_;
#line 558 "../src/widgets/MediaButton.vala"
		_tmp4_ = _tmp3_->alt_text;
#line 558 "../src/widgets/MediaButton.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp4_);
#line 559 "../src/widgets/MediaButton.vala"
		_tmp6_ = media_button_get_media (self);
#line 559 "../src/widgets/MediaButton.vala"
		_tmp7_ = _tmp6_;
#line 559 "../src/widgets/MediaButton.vala"
		_tmp8_ = _tmp7_->alt_text;
#line 559 "../src/widgets/MediaButton.vala"
		_tmp5_ = _tmp8_;
#line 559 "../src/widgets/MediaButton.vala"
		if (_tmp5_ == NULL) {
#line 559 "../src/widgets/MediaButton.vala"
			_tmp5_ = "";
#line 2520 "MediaButton.c"
		}
#line 559 "../src/widgets/MediaButton.vala"
		_tmp9_ = gtk_widget_get_accessible ((GtkWidget*) self);
#line 559 "../src/widgets/MediaButton.vala"
		atk_object_set_description (_tmp9_, _tmp5_);
#line 2526 "MediaButton.c"
	}
}

static void
media_button_set_save_as_sensitivity (MediaButton* self)
{
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
#line 563 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 564 "../src/widgets/MediaButton.vala"
	_tmp1_ = self->priv->_media;
#line 564 "../src/widgets/MediaButton.vala"
	if (!_tmp1_->invalid) {
#line 2543 "MediaButton.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 564 "../src/widgets/MediaButton.vala"
		_tmp2_ = media_button_get_is_m3u8 (self);
#line 564 "../src/widgets/MediaButton.vala"
		_tmp3_ = _tmp2_;
#line 564 "../src/widgets/MediaButton.vala"
		_tmp0_ = !_tmp3_;
#line 2552 "MediaButton.c"
	} else {
#line 564 "../src/widgets/MediaButton.vala"
		_tmp0_ = FALSE;
#line 2556 "MediaButton.c"
	}
#line 564 "../src/widgets/MediaButton.vala"
	_tmp4_ = self->priv->actions;
#line 564 "../src/widgets/MediaButton.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, "save-as");
#line 564 "../src/widgets/MediaButton.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp0_);
#line 2564 "MediaButton.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 2583 "MediaButton.c"
}

static gboolean
media_button_get_is_m3u8 (MediaButton* self)
{
	gboolean result;
	CbMedia* _tmp0_;
	const gchar* _tmp1_;
#line 28 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->_media;
#line 30 "../src/widgets/MediaButton.vala"
	_tmp1_ = _tmp0_->url;
#line 30 "../src/widgets/MediaButton.vala"
	result = string_contains (_tmp1_, ".m3u8");
#line 30 "../src/widgets/MediaButton.vala"
	return result;
#line 2602 "MediaButton.c"
}

CbMedia*
media_button_get_media (MediaButton* self)
{
	CbMedia* result;
	CbMedia* _tmp0_;
#line 34 "../src/widgets/MediaButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->_media;
#line 35 "../src/widgets/MediaButton.vala"
	result = _tmp0_;
#line 35 "../src/widgets/MediaButton.vala"
	return result;
#line 2618 "MediaButton.c"
}

void
media_button_set_media (MediaButton* self,
                        CbMedia* value)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp3_;
#line 37 "../src/widgets/MediaButton.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->_media;
#line 38 "../src/widgets/MediaButton.vala"
	if (_tmp0_ != NULL) {
#line 2633 "MediaButton.c"
		CbMedia* _tmp1_;
		guint _tmp2_;
#line 39 "../src/widgets/MediaButton.vala"
		_tmp1_ = self->priv->_media;
#line 39 "../src/widgets/MediaButton.vala"
		g_signal_parse_name ("progress", CB_TYPE_MEDIA, &_tmp2_, NULL, FALSE);
#line 39 "../src/widgets/MediaButton.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _media_button_media_progress_cb_cb_media_progress, self);
#line 2642 "MediaButton.c"
	}
#line 41 "../src/widgets/MediaButton.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 41 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->_media);
#line 41 "../src/widgets/MediaButton.vala"
	self->priv->_media = _tmp3_;
#line 42 "../src/widgets/MediaButton.vala"
	if (value != NULL) {
#line 2652 "MediaButton.c"
		CbMedia* _tmp4_;
		CbMedia* _tmp5_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 43 "../src/widgets/MediaButton.vala"
		_tmp4_ = media_button_get_media (self);
#line 43 "../src/widgets/MediaButton.vala"
		_tmp5_ = _tmp4_;
#line 43 "../src/widgets/MediaButton.vala"
		if (!_tmp5_->loaded) {
#line 2664 "MediaButton.c"
			CbMedia* _tmp6_;
#line 44 "../src/widgets/MediaButton.vala"
			_tmp6_ = self->priv->_media;
#line 44 "../src/widgets/MediaButton.vala"
			g_signal_connect_object (_tmp6_, "progress", (GCallback) _media_button_media_progress_cb_cb_media_progress, self, 0);
#line 2670 "MediaButton.c"
		} else {
#line 46 "../src/widgets/MediaButton.vala"
			self->priv->media_alpha = 1.0;
#line 2674 "MediaButton.c"
		}
#line 48 "../src/widgets/MediaButton.vala"
		media_button_set_save_as_sensitivity (self);
#line 49 "../src/widgets/MediaButton.vala"
		media_button_set_image_description (self);
#line 50 "../src/widgets/MediaButton.vala"
		_tmp8_ = media_button_get_is_m3u8 (self);
#line 50 "../src/widgets/MediaButton.vala"
		_tmp9_ = _tmp8_;
#line 50 "../src/widgets/MediaButton.vala"
		if (!_tmp9_) {
#line 2686 "MediaButton.c"
			CbMedia* _tmp10_;
#line 50 "../src/widgets/MediaButton.vala"
			_tmp10_ = self->priv->_media;
#line 50 "../src/widgets/MediaButton.vala"
			_tmp7_ = !cb_media_requires_authentication (_tmp10_);
#line 2692 "MediaButton.c"
		} else {
#line 50 "../src/widgets/MediaButton.vala"
			_tmp7_ = FALSE;
#line 2696 "MediaButton.c"
		}
#line 50 "../src/widgets/MediaButton.vala"
		if (_tmp7_) {
#line 2700 "MediaButton.c"
			GMenu* _tmp11_;
#line 51 "../src/widgets/MediaButton.vala"
			_tmp11_ = self->priv->menu_model;
#line 51 "../src/widgets/MediaButton.vala"
			g_menu_append (_tmp11_, _ ("Copy URL"), "media.copy-url");
#line 2706 "MediaButton.c"
		}
	}
#line 37 "../src/widgets/MediaButton.vala"
	g_object_notify_by_pspec ((GObject *) self, media_button_properties[MEDIA_BUTTON_MEDIA_PROPERTY]);
#line 2711 "MediaButton.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE) (gpointer data1, gpointer arg_1, gdouble arg_2, gdouble arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 18 "../src/widgets/MediaButton.vala"
	g_return_if_fail (n_param_values == 4);
#line 18 "../src/widgets/MediaButton.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 18 "../src/widgets/MediaButton.vala"
		data1 = closure->data;
#line 18 "../src/widgets/MediaButton.vala"
		data2 = param_values->data[0].v_pointer;
#line 2736 "MediaButton.c"
	} else {
#line 18 "../src/widgets/MediaButton.vala"
		data1 = param_values->data[0].v_pointer;
#line 18 "../src/widgets/MediaButton.vala"
		data2 = closure->data;
#line 2742 "MediaButton.c"
	}
#line 18 "../src/widgets/MediaButton.vala"
	callback = (GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
#line 18 "../src/widgets/MediaButton.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_double (param_values + 2), g_value_get_double (param_values + 3), data2);
#line 2748 "MediaButton.c"
}

static GObject *
media_button_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MediaButton * self;
#line 87 "../src/widgets/MediaButton.vala"
	parent_class = G_OBJECT_CLASS (media_button_parent_class);
#line 87 "../src/widgets/MediaButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 87 "../src/widgets/MediaButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_BUTTON, MediaButton);
#line 88 "../src/widgets/MediaButton.vala"
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
#line 89 "../src/widgets/MediaButton.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 87 "../src/widgets/MediaButton.vala"
	return obj;
#line 2771 "MediaButton.c"
}

static void
media_button_class_init (MediaButtonClass * klass,
                         gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 18 "../src/widgets/MediaButton.vala"
	media_button_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/MediaButton.vala"
	g_type_class_adjust_private_offset (klass, &MediaButton_private_offset);
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) media_button_real_draw;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) media_button_real_get_request_mode;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) media_button_real_get_preferred_height;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) media_button_real_get_preferred_height_for_width;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) media_button_real_get_preferred_width_for_height;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) media_button_real_get_preferred_width;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) media_button_real_realize;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->unrealize = (void (*) (GtkWidget*)) media_button_real_unrealize;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->map = (void (*) (GtkWidget*)) media_button_real_map;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->unmap = (void (*) (GtkWidget*)) media_button_real_unmap;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) media_button_real_size_allocate;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_button_real_enter_notify_event;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_button_real_leave_notify_event;
#line 18 "../src/widgets/MediaButton.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) media_button_real_key_press_event;
#line 18 "../src/widgets/MediaButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_media_button_get_property;
#line 18 "../src/widgets/MediaButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_media_button_set_property;
#line 18 "../src/widgets/MediaButton.vala"
	G_OBJECT_CLASS (klass)->constructor = media_button_constructor;
#line 18 "../src/widgets/MediaButton.vala"
	G_OBJECT_CLASS (klass)->finalize = media_button_finalize;
#line 18 "../src/widgets/MediaButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_BUTTON_MEDIA_PROPERTY, media_button_properties[MEDIA_BUTTON_MEDIA_PROPERTY] = g_param_spec_object ("media", "media", "media", CB_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/widgets/MediaButton.vala"
	media_button_signals[MEDIA_BUTTON_CLICKED_SIGNAL] = g_signal_new ("clicked", TYPE_MEDIA_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE, G_TYPE_NONE, 3, TYPE_MEDIA_BUTTON, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
#line 2823 "MediaButton.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_;
		cairo_surface_t* _tmp4_;
		cairo_surface_t* _tmp5_;
		cairo_surface_t** _tmp6_;
#line 78 "../src/widgets/MediaButton.vala"
		_tmp1_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/play.png", &_inner_error0_);
#line 78 "../src/widgets/MediaButton.vala"
		_tmp0_ = _tmp1_;
#line 78 "../src/widgets/MediaButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2838 "MediaButton.c"
			goto __catch0_g_error;
		}
#line 80 "../src/widgets/MediaButton.vala"
		_tmp3_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/play@2.png", &_inner_error0_);
#line 80 "../src/widgets/MediaButton.vala"
		_tmp2_ = _tmp3_;
#line 80 "../src/widgets/MediaButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 80 "../src/widgets/MediaButton.vala"
			_g_object_unref0 (_tmp0_);
#line 2849 "MediaButton.c"
			goto __catch0_g_error;
		}
#line 76 "../src/widgets/MediaButton.vala"
		_tmp4_ = gdk_cairo_surface_create_from_pixbuf (_tmp0_, 1, NULL);
#line 76 "../src/widgets/MediaButton.vala"
		_tmp5_ = gdk_cairo_surface_create_from_pixbuf (_tmp2_, 2, NULL);
#line 76 "../src/widgets/MediaButton.vala"
		_tmp6_ = g_new0 (cairo_surface_t*, 2 + 1);
#line 76 "../src/widgets/MediaButton.vala"
		_tmp6_[0] = _tmp4_;
#line 76 "../src/widgets/MediaButton.vala"
		_tmp6_[1] = _tmp5_;
#line 76 "../src/widgets/MediaButton.vala"
		media_button_play_icons = (_vala_array_free (media_button_play_icons, media_button_play_icons_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
#line 76 "../src/widgets/MediaButton.vala"
		media_button_play_icons = _tmp6_;
#line 76 "../src/widgets/MediaButton.vala"
		media_button_play_icons_length1 = 2;
#line 76 "../src/widgets/MediaButton.vala"
		_media_button_play_icons_size_ = media_button_play_icons_length1;
#line 75 "../src/widgets/MediaButton.vala"
		_g_object_unref0 (_tmp2_);
#line 75 "../src/widgets/MediaButton.vala"
		_g_object_unref0 (_tmp0_);
#line 2874 "MediaButton.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 75 "../src/widgets/MediaButton.vala"
		e = _inner_error0_;
#line 75 "../src/widgets/MediaButton.vala"
		_inner_error0_ = NULL;
#line 83 "../src/widgets/MediaButton.vala"
		_tmp7_ = e;
#line 83 "../src/widgets/MediaButton.vala"
		_tmp8_ = _tmp7_->message;
#line 83 "../src/widgets/MediaButton.vala"
		g_critical ("MediaButton.vala:83: %s", _tmp8_);
#line 75 "../src/widgets/MediaButton.vala"
		_g_error_free0 (e);
#line 2894 "MediaButton.c"
	}
	__finally0:
#line 75 "../src/widgets/MediaButton.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/widgets/MediaButton.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/widgets/MediaButton.vala"
		g_clear_error (&_inner_error0_);
#line 2903 "MediaButton.c"
	}
}

static void
media_button_instance_init (MediaButton * self,
                            gpointer klass)
{
#line 18 "../src/widgets/MediaButton.vala"
	self->priv = media_button_get_instance_private (self);
#line 24 "../src/widgets/MediaButton.vala"
	self->priv->event_window = NULL;
#line 25 "../src/widgets/MediaButton.vala"
	self->priv->_media = NULL;
#line 58 "../src/widgets/MediaButton.vala"
	self->priv->menu = NULL;
#line 67 "../src/widgets/MediaButton.vala"
	self->priv->restrict_height = FALSE;
#line 69 "../src/widgets/MediaButton.vala"
	self->priv->media_alpha = 0.0;
#line 2923 "MediaButton.c"
}

static void
media_button_finalize (GObject * obj)
{
	MediaButton * self;
	CbMedia* _tmp0_;
#line 18 "../src/widgets/MediaButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_BUTTON, MediaButton);
#line 93 "../src/widgets/MediaButton.vala"
	_tmp0_ = self->priv->_media;
#line 93 "../src/widgets/MediaButton.vala"
	if (_tmp0_ != NULL) {
#line 2937 "MediaButton.c"
		CbMedia* _tmp1_;
		guint _tmp2_;
#line 94 "../src/widgets/MediaButton.vala"
		_tmp1_ = self->priv->_media;
#line 94 "../src/widgets/MediaButton.vala"
		g_signal_parse_name ("progress", CB_TYPE_MEDIA, &_tmp2_, NULL, FALSE);
#line 94 "../src/widgets/MediaButton.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _media_button_media_progress_cb_cb_media_progress, self);
#line 2946 "MediaButton.c"
	}
#line 24 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->event_window);
#line 25 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->_media);
#line 57 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->menu_model);
#line 58 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->menu);
#line 59 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->actions);
#line 65 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->layout);
#line 66 "../src/widgets/MediaButton.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 18 "../src/widgets/MediaButton.vala"
	G_OBJECT_CLASS (media_button_parent_class)->finalize (obj);
#line 2964 "MediaButton.c"
}

static GType
media_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaButton), 0, (GInstanceInitFunc) media_button_instance_init, NULL };
	GType media_button_type_id;
	media_button_type_id = g_type_register_static (gtk_bin_get_type (), "MediaButton", &g_define_type_info, 0);
	MediaButton_private_offset = g_type_add_instance_private (media_button_type_id, sizeof (MediaButtonPrivate));
	return media_button_type_id;
}

GType
media_button_get_type (void)
{
	static volatile gsize media_button_type_id__once = 0;
	if (g_once_init_enter (&media_button_type_id__once)) {
		GType media_button_type_id;
		media_button_type_id = media_button_get_type_once ();
		g_once_init_leave (&media_button_type_id__once, media_button_type_id);
	}
	return media_button_type_id__once;
}

static void
_vala_media_button_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MediaButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_BUTTON, MediaButton);
#line 18 "../src/widgets/MediaButton.vala"
	switch (property_id) {
#line 18 "../src/widgets/MediaButton.vala"
		case MEDIA_BUTTON_MEDIA_PROPERTY:
#line 18 "../src/widgets/MediaButton.vala"
		g_value_set_object (value, media_button_get_media (self));
#line 18 "../src/widgets/MediaButton.vala"
		break;
#line 3005 "MediaButton.c"
		default:
#line 18 "../src/widgets/MediaButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/MediaButton.vala"
		break;
#line 3011 "MediaButton.c"
	}
}

static void
_vala_media_button_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MediaButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_BUTTON, MediaButton);
#line 18 "../src/widgets/MediaButton.vala"
	switch (property_id) {
#line 18 "../src/widgets/MediaButton.vala"
		case MEDIA_BUTTON_MEDIA_PROPERTY:
#line 18 "../src/widgets/MediaButton.vala"
		media_button_set_media (self, g_value_get_object (value));
#line 18 "../src/widgets/MediaButton.vala"
		break;
#line 3031 "MediaButton.c"
		default:
#line 18 "../src/widgets/MediaButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/MediaButton.vala"
		break;
#line 3037 "MediaButton.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

