/* MultiMediaWidget.c generated by valac 0.56.13, the Vala compiler
 * generated from MultiMediaWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include "CbMedia.h"
#include "CbMediaDownloader.h"
#include <float.h>
#include <math.h>
#include <string.h>

#define TYPE_MEDIA_BUTTON (media_button_get_type ())
#define MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_BUTTON, MediaButton))
#define MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_BUTTON, MediaButtonClass))
#define IS_MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_BUTTON))
#define IS_MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_BUTTON))
#define MEDIA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_BUTTON, MediaButtonClass))

typedef struct _MediaButton MediaButton;
typedef struct _MediaButtonClass MediaButtonClass;
enum  {
	MULTI_MEDIA_WIDGET_0_PROPERTY,
	MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY,
	MULTI_MEDIA_WIDGET_NUM_PROPERTIES
};
static GParamSpec* multi_media_widget_properties[MULTI_MEDIA_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MediaButtonPrivate MediaButtonPrivate;
enum  {
	MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL,
	MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL,
	MULTI_MEDIA_WIDGET_NUM_SIGNALS
};
static guint multi_media_widget_signals[MULTI_MEDIA_WIDGET_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MultiMediaWidgetPrivate {
	gboolean __restrict_height;
	MediaButton** media_buttons;
	gint media_buttons_length1;
	gint _media_buttons_size_;
	gint media_count;
	gboolean media_invalid_fired;
};

struct _MediaButton {
	GtkBin parent_instance;
	MediaButtonPrivate * priv;
	GtkWindow* window;
};

struct _MediaButtonClass {
	GtkBinClass parent_class;
};

static gint MultiMediaWidget_private_offset;
static gpointer multi_media_widget_parent_class = NULL;

VALA_EXTERN GType media_button_get_type (void) G_GNUC_CONST ;
static void __lambda15_ (MultiMediaWidget* self);
VALA_EXTERN CbMedia* media_button_get_media (MediaButton* self);
static void ___lambda15__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void multi_media_widget_remove_all (MultiMediaWidget* self);
static void __lambda16_ (MultiMediaWidget* self,
                  GtkWidget* w);
static void ___lambda16__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN MediaButton* media_button_new (CbMedia* media,
                               gboolean restrict_height);
VALA_EXTERN MediaButton* media_button_construct (GType object_type,
                                     CbMedia* media,
                                     gboolean restrict_height);
VALA_EXTERN void media_button_set_media (MediaButton* self,
                             CbMedia* value);
static void multi_media_widget_media_loaded_cb (MultiMediaWidget* self,
                                         CbMedia* source);
static void _multi_media_widget_media_loaded_cb_cb_media_progress (CbMedia* _sender,
                                                            gpointer self);
static void multi_media_widget_button_clicked_cb (MultiMediaWidget* self,
                                           MediaButton* source,
                                           gdouble px,
                                           gdouble py);
static void _multi_media_widget_button_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                                 MediaButton* source,
                                                                 gdouble px,
                                                                 gdouble py,
                                                                 gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE (GClosure * closure,
                                                             GValue * return_value,
                                                             guint n_param_values,
                                                             const GValue * param_values,
                                                             gpointer invocation_hint,
                                                             gpointer marshal_data);
static GObject * multi_media_widget_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void multi_media_widget_finalize (GObject * obj);
static GType multi_media_widget_get_type_once (void);
static void _vala_multi_media_widget_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_multi_media_widget_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
multi_media_widget_get_instance_private (MultiMediaWidget* self)
{
	return G_STRUCT_MEMBER_P (self, MultiMediaWidget_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/widgets/MultiMediaWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "MultiMediaWidget.c"
}

static void
__lambda15_ (MultiMediaWidget* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 46 "../src/widgets/MultiMediaWidget.vala"
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 46 "../src/widgets/MultiMediaWidget.vala"
	_tmp1_ = _tmp0_;
#line 46 "../src/widgets/MultiMediaWidget.vala"
	if (!_tmp1_) {
#line 47 "../src/widgets/MultiMediaWidget.vala"
		return;
#line 168 "MultiMediaWidget.c"
	}
	{
		gint i = 0;
#line 50 "../src/widgets/MultiMediaWidget.vala"
		i = 0;
#line 174 "MultiMediaWidget.c"
		{
			gboolean _tmp2_ = FALSE;
#line 50 "../src/widgets/MultiMediaWidget.vala"
			_tmp2_ = TRUE;
#line 50 "../src/widgets/MultiMediaWidget.vala"
			while (TRUE) {
#line 181 "MultiMediaWidget.c"
				MediaButton** _tmp4_;
				gint _tmp4__length1;
				MediaButton* _tmp5_;
#line 50 "../src/widgets/MultiMediaWidget.vala"
				if (!_tmp2_) {
#line 187 "MultiMediaWidget.c"
					gint _tmp3_;
#line 50 "../src/widgets/MultiMediaWidget.vala"
					_tmp3_ = i;
#line 50 "../src/widgets/MultiMediaWidget.vala"
					i = _tmp3_ + 1;
#line 193 "MultiMediaWidget.c"
				}
#line 50 "../src/widgets/MultiMediaWidget.vala"
				_tmp2_ = FALSE;
#line 50 "../src/widgets/MultiMediaWidget.vala"
				if (!(i < self->priv->media_count)) {
#line 50 "../src/widgets/MultiMediaWidget.vala"
					break;
#line 201 "MultiMediaWidget.c"
				}
#line 51 "../src/widgets/MultiMediaWidget.vala"
				_tmp4_ = self->priv->media_buttons;
#line 51 "../src/widgets/MultiMediaWidget.vala"
				_tmp4__length1 = self->priv->media_buttons_length1;
#line 51 "../src/widgets/MultiMediaWidget.vala"
				_tmp5_ = _tmp4_[i];
#line 51 "../src/widgets/MultiMediaWidget.vala"
				if (_tmp5_ != NULL) {
#line 211 "MultiMediaWidget.c"
					CbMedia* media = NULL;
					MediaButton** _tmp6_;
					gint _tmp6__length1;
					MediaButton* _tmp7_;
					CbMedia* _tmp8_;
					CbMedia* _tmp9_;
					CbMedia* _tmp10_;
					gboolean _tmp11_ = FALSE;
					CbMedia* _tmp12_;
#line 52 "../src/widgets/MultiMediaWidget.vala"
					_tmp6_ = self->priv->media_buttons;
#line 52 "../src/widgets/MultiMediaWidget.vala"
					_tmp6__length1 = self->priv->media_buttons_length1;
#line 52 "../src/widgets/MultiMediaWidget.vala"
					_tmp7_ = _tmp6_[i];
#line 52 "../src/widgets/MultiMediaWidget.vala"
					_tmp8_ = media_button_get_media (_tmp7_);
#line 52 "../src/widgets/MultiMediaWidget.vala"
					_tmp9_ = _tmp8_;
#line 52 "../src/widgets/MultiMediaWidget.vala"
					_tmp10_ = _g_object_ref0 (_tmp9_);
#line 52 "../src/widgets/MultiMediaWidget.vala"
					media = _tmp10_;
#line 53 "../src/widgets/MultiMediaWidget.vala"
					_tmp12_ = media;
#line 53 "../src/widgets/MultiMediaWidget.vala"
					if (!_tmp12_->loaded) {
#line 239 "MultiMediaWidget.c"
						CbMedia* _tmp13_;
#line 53 "../src/widgets/MultiMediaWidget.vala"
						_tmp13_ = media;
#line 53 "../src/widgets/MultiMediaWidget.vala"
						_tmp11_ = !_tmp13_->loading;
#line 245 "MultiMediaWidget.c"
					} else {
#line 53 "../src/widgets/MultiMediaWidget.vala"
						_tmp11_ = FALSE;
#line 249 "MultiMediaWidget.c"
					}
#line 53 "../src/widgets/MultiMediaWidget.vala"
					if (_tmp11_) {
#line 253 "MultiMediaWidget.c"
						CbMediaDownloader* _tmp14_;
						CbMedia* _tmp15_;
#line 54 "../src/widgets/MultiMediaWidget.vala"
						_tmp14_ = cb_media_downloader_get_default ();
#line 54 "../src/widgets/MultiMediaWidget.vala"
						_tmp15_ = media;
#line 54 "../src/widgets/MultiMediaWidget.vala"
						cb_media_downloader_load_async (_tmp14_, _tmp15_, NULL, NULL);
#line 262 "MultiMediaWidget.c"
					}
#line 51 "../src/widgets/MultiMediaWidget.vala"
					_g_object_unref0 (media);
#line 266 "MultiMediaWidget.c"
				}
			}
		}
	}
}

static void
___lambda15__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 45 "../src/widgets/MultiMediaWidget.vala"
	__lambda15_ ((MultiMediaWidget*) self);
#line 280 "MultiMediaWidget.c"
}

MultiMediaWidget*
multi_media_widget_construct (GType object_type)
{
	MultiMediaWidget * self = NULL;
#line 44 "../src/widgets/MultiMediaWidget.vala"
	self = (MultiMediaWidget*) g_object_new (object_type, NULL);
#line 45 "../src/widgets/MultiMediaWidget.vala"
	g_signal_connect_object ((GObject*) self, "notify::visible", (GCallback) ___lambda15__g_object_notify, self, 0);
#line 44 "../src/widgets/MultiMediaWidget.vala"
	return self;
#line 293 "MultiMediaWidget.c"
}

MultiMediaWidget*
multi_media_widget_new (void)
{
#line 44 "../src/widgets/MultiMediaWidget.vala"
	return multi_media_widget_construct (TYPE_MULTI_MEDIA_WIDGET);
#line 301 "MultiMediaWidget.c"
}

void
multi_media_widget_set_all_media (MultiMediaWidget* self,
                                  CbMedia** medias,
                                  gint medias_length1)
{
	MediaButton** _tmp0_;
#line 61 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/widgets/MultiMediaWidget.vala"
	multi_media_widget_remove_all (self);
#line 63 "../src/widgets/MultiMediaWidget.vala"
	_tmp0_ = g_new0 (MediaButton*, medias_length1 + 1);
#line 63 "../src/widgets/MultiMediaWidget.vala"
	self->priv->media_buttons = (_vala_array_free (self->priv->media_buttons, self->priv->media_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 63 "../src/widgets/MultiMediaWidget.vala"
	self->priv->media_buttons = _tmp0_;
#line 63 "../src/widgets/MultiMediaWidget.vala"
	self->priv->media_buttons_length1 = medias_length1;
#line 63 "../src/widgets/MultiMediaWidget.vala"
	self->priv->_media_buttons_size_ = self->priv->media_buttons_length1;
#line 64 "../src/widgets/MultiMediaWidget.vala"
	self->priv->media_count = medias_length1;
#line 326 "MultiMediaWidget.c"
	{
		gint i = 0;
#line 66 "../src/widgets/MultiMediaWidget.vala"
		i = 0;
#line 331 "MultiMediaWidget.c"
		{
			gboolean _tmp1_ = FALSE;
#line 66 "../src/widgets/MultiMediaWidget.vala"
			_tmp1_ = TRUE;
#line 66 "../src/widgets/MultiMediaWidget.vala"
			while (TRUE) {
#line 338 "MultiMediaWidget.c"
				CbMedia* _tmp3_;
				CbMedia* _tmp4_;
#line 66 "../src/widgets/MultiMediaWidget.vala"
				if (!_tmp1_) {
#line 343 "MultiMediaWidget.c"
					gint _tmp2_;
#line 66 "../src/widgets/MultiMediaWidget.vala"
					_tmp2_ = i;
#line 66 "../src/widgets/MultiMediaWidget.vala"
					i = _tmp2_ + 1;
#line 349 "MultiMediaWidget.c"
				}
#line 66 "../src/widgets/MultiMediaWidget.vala"
				_tmp1_ = FALSE;
#line 66 "../src/widgets/MultiMediaWidget.vala"
				if (!(i < medias_length1)) {
#line 66 "../src/widgets/MultiMediaWidget.vala"
					break;
#line 357 "MultiMediaWidget.c"
				}
#line 67 "../src/widgets/MultiMediaWidget.vala"
				_tmp3_ = medias[i];
#line 67 "../src/widgets/MultiMediaWidget.vala"
				_vala_assert (_tmp3_ != NULL, "medias[i] != null");
#line 68 "../src/widgets/MultiMediaWidget.vala"
				_tmp4_ = medias[i];
#line 68 "../src/widgets/MultiMediaWidget.vala"
				multi_media_widget_set_media (self, i, _tmp4_);
#line 367 "MultiMediaWidget.c"
			}
		}
	}
}

static void
__lambda16_ (MultiMediaWidget* self,
             GtkWidget* w)
{
#line 73 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (w != NULL);
#line 74 "../src/widgets/MultiMediaWidget.vala"
	gtk_container_remove ((GtkContainer*) self, w);
#line 381 "MultiMediaWidget.c"
}

static void
___lambda16__gfunc (gconstpointer data,
                    gpointer self)
{
#line 73 "../src/widgets/MultiMediaWidget.vala"
	__lambda16_ ((MultiMediaWidget*) self, (GtkWidget*) data);
#line 390 "MultiMediaWidget.c"
}

static void
multi_media_widget_remove_all (MultiMediaWidget* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 72 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/widgets/MultiMediaWidget.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 73 "../src/widgets/MultiMediaWidget.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/widgets/MultiMediaWidget.vala"
	g_list_foreach (_tmp1_, ___lambda16__gfunc, self);
#line 73 "../src/widgets/MultiMediaWidget.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 408 "MultiMediaWidget.c"
}

static void
_multi_media_widget_media_loaded_cb_cb_media_progress (CbMedia* _sender,
                                                       gpointer self)
{
#line 95 "../src/widgets/MultiMediaWidget.vala"
	multi_media_widget_media_loaded_cb ((MultiMediaWidget*) self, _sender);
#line 417 "MultiMediaWidget.c"
}

static void
_multi_media_widget_button_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                            MediaButton* source,
                                                            gdouble px,
                                                            gdouble py,
                                                            gpointer self)
{
#line 102 "../src/widgets/MultiMediaWidget.vala"
	multi_media_widget_button_clicked_cb ((MultiMediaWidget*) self, source, px, py);
#line 429 "MultiMediaWidget.c"
}

void
multi_media_widget_set_media (MultiMediaWidget* self,
                              gint index,
                              CbMedia* media)
{
	gboolean _tmp0_ = FALSE;
	MediaButton* button = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	MediaButton* _tmp3_;
	MediaButton* _tmp4_;
	MediaButton* _tmp5_;
	GtkWindow* _tmp6_;
	MediaButton* _tmp7_;
	MediaButton* _tmp8_;
	MediaButton** _tmp9_;
	gint _tmp9__length1;
	MediaButton* _tmp10_;
	MediaButton* _tmp11_;
	MediaButton* _tmp20_;
	MediaButton* _tmp21_;
	MediaButton* _tmp22_;
#line 78 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (media != NULL);
#line 79 "../src/widgets/MultiMediaWidget.vala"
	_vala_assert (index < self->priv->media_count, "index < media_count");
#line 81 "../src/widgets/MultiMediaWidget.vala"
	if (media->loaded) {
#line 81 "../src/widgets/MultiMediaWidget.vala"
		_tmp0_ = media->invalid;
#line 464 "MultiMediaWidget.c"
	} else {
#line 81 "../src/widgets/MultiMediaWidget.vala"
		_tmp0_ = FALSE;
#line 468 "MultiMediaWidget.c"
	}
#line 81 "../src/widgets/MultiMediaWidget.vala"
	if (_tmp0_) {
#line 82 "../src/widgets/MultiMediaWidget.vala"
		return;
#line 474 "MultiMediaWidget.c"
	}
#line 84 "../src/widgets/MultiMediaWidget.vala"
	_tmp1_ = multi_media_widget_get_restrict_height (self);
#line 84 "../src/widgets/MultiMediaWidget.vala"
	_tmp2_ = _tmp1_;
#line 84 "../src/widgets/MultiMediaWidget.vala"
	_tmp3_ = media_button_new (NULL, _tmp2_);
#line 84 "../src/widgets/MultiMediaWidget.vala"
	g_object_ref_sink (_tmp3_);
#line 84 "../src/widgets/MultiMediaWidget.vala"
	button = _tmp3_;
#line 85 "../src/widgets/MultiMediaWidget.vala"
	_tmp4_ = button;
#line 85 "../src/widgets/MultiMediaWidget.vala"
	g_object_set_data_full ((GObject*) _tmp4_, "pos", (gpointer) ((gintptr) index), NULL);
#line 86 "../src/widgets/MultiMediaWidget.vala"
	_tmp5_ = button;
#line 86 "../src/widgets/MultiMediaWidget.vala"
	_tmp6_ = self->window;
#line 86 "../src/widgets/MultiMediaWidget.vala"
	_tmp5_->window = _tmp6_;
#line 87 "../src/widgets/MultiMediaWidget.vala"
	_tmp7_ = button;
#line 87 "../src/widgets/MultiMediaWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 88 "../src/widgets/MultiMediaWidget.vala"
	_tmp8_ = button;
#line 88 "../src/widgets/MultiMediaWidget.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
#line 89 "../src/widgets/MultiMediaWidget.vala"
	_tmp9_ = self->priv->media_buttons;
#line 89 "../src/widgets/MultiMediaWidget.vala"
	_tmp9__length1 = self->priv->media_buttons_length1;
#line 89 "../src/widgets/MultiMediaWidget.vala"
	_tmp10_ = button;
#line 89 "../src/widgets/MultiMediaWidget.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 89 "../src/widgets/MultiMediaWidget.vala"
	_g_object_unref0 (_tmp9_[index]);
#line 89 "../src/widgets/MultiMediaWidget.vala"
	_tmp9_[index] = _tmp11_;
#line 91 "../src/widgets/MultiMediaWidget.vala"
	if (media->loaded) {
#line 518 "MultiMediaWidget.c"
		MediaButton** _tmp12_;
		gint _tmp12__length1;
		MediaButton* _tmp13_;
#line 92 "../src/widgets/MultiMediaWidget.vala"
		_tmp12_ = self->priv->media_buttons;
#line 92 "../src/widgets/MultiMediaWidget.vala"
		_tmp12__length1 = self->priv->media_buttons_length1;
#line 92 "../src/widgets/MultiMediaWidget.vala"
		_tmp13_ = _tmp12_[index];
#line 92 "../src/widgets/MultiMediaWidget.vala"
		media_button_set_media (_tmp13_, media);
#line 530 "MultiMediaWidget.c"
	} else {
		MediaButton** _tmp14_;
		gint _tmp14__length1;
		MediaButton* _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 94 "../src/widgets/MultiMediaWidget.vala"
		_tmp14_ = self->priv->media_buttons;
#line 94 "../src/widgets/MultiMediaWidget.vala"
		_tmp14__length1 = self->priv->media_buttons_length1;
#line 94 "../src/widgets/MultiMediaWidget.vala"
		_tmp15_ = _tmp14_[index];
#line 94 "../src/widgets/MultiMediaWidget.vala"
		media_button_set_media (_tmp15_, media);
#line 95 "../src/widgets/MultiMediaWidget.vala"
		g_signal_connect_object (media, "progress", (GCallback) _multi_media_widget_media_loaded_cb_cb_media_progress, self, 0);
#line 97 "../src/widgets/MultiMediaWidget.vala"
		if (!media->loading) {
#line 548 "MultiMediaWidget.c"
			gboolean _tmp17_;
			gboolean _tmp18_;
#line 97 "../src/widgets/MultiMediaWidget.vala"
			_tmp17_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 97 "../src/widgets/MultiMediaWidget.vala"
			_tmp18_ = _tmp17_;
#line 97 "../src/widgets/MultiMediaWidget.vala"
			_tmp16_ = _tmp18_;
#line 557 "MultiMediaWidget.c"
		} else {
#line 97 "../src/widgets/MultiMediaWidget.vala"
			_tmp16_ = FALSE;
#line 561 "MultiMediaWidget.c"
		}
#line 97 "../src/widgets/MultiMediaWidget.vala"
		if (_tmp16_) {
#line 565 "MultiMediaWidget.c"
			CbMediaDownloader* _tmp19_;
#line 98 "../src/widgets/MultiMediaWidget.vala"
			_tmp19_ = cb_media_downloader_get_default ();
#line 98 "../src/widgets/MultiMediaWidget.vala"
			cb_media_downloader_load_async (_tmp19_, media, NULL, NULL);
#line 571 "MultiMediaWidget.c"
		}
	}
#line 101 "../src/widgets/MultiMediaWidget.vala"
	_tmp20_ = button;
#line 101 "../src/widgets/MultiMediaWidget.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp20_, TRUE);
#line 102 "../src/widgets/MultiMediaWidget.vala"
	_tmp21_ = button;
#line 102 "../src/widgets/MultiMediaWidget.vala"
	g_signal_connect_object (_tmp21_, "clicked", (GCallback) _multi_media_widget_button_clicked_cb_media_button_clicked, self, 0);
#line 103 "../src/widgets/MultiMediaWidget.vala"
	_tmp22_ = button;
#line 103 "../src/widgets/MultiMediaWidget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp22_, TRUE, TRUE, (guint) 0);
#line 104 "../src/widgets/MultiMediaWidget.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 78 "../src/widgets/MultiMediaWidget.vala"
	_g_object_unref0 (button);
#line 590 "MultiMediaWidget.c"
}

static void
multi_media_widget_button_clicked_cb (MultiMediaWidget* self,
                                      MediaButton* source,
                                      gdouble px,
                                      gdouble py)
{
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
#line 107 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (source != NULL);
#line 108 "../src/widgets/MultiMediaWidget.vala"
	_tmp1_ = media_button_get_media (source);
#line 108 "../src/widgets/MultiMediaWidget.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/widgets/MultiMediaWidget.vala"
	if (_tmp2_ != NULL) {
#line 612 "MultiMediaWidget.c"
		CbMedia* _tmp3_;
		CbMedia* _tmp4_;
#line 108 "../src/widgets/MultiMediaWidget.vala"
		_tmp3_ = media_button_get_media (source);
#line 108 "../src/widgets/MultiMediaWidget.vala"
		_tmp4_ = _tmp3_;
#line 108 "../src/widgets/MultiMediaWidget.vala"
		_tmp0_ = _tmp4_->loaded;
#line 621 "MultiMediaWidget.c"
	} else {
#line 108 "../src/widgets/MultiMediaWidget.vala"
		_tmp0_ = FALSE;
#line 625 "MultiMediaWidget.c"
	}
#line 108 "../src/widgets/MultiMediaWidget.vala"
	if (_tmp0_) {
#line 629 "MultiMediaWidget.c"
		gint index = 0;
		gconstpointer _tmp5_;
		CbMedia* _tmp6_;
		CbMedia* _tmp7_;
#line 109 "../src/widgets/MultiMediaWidget.vala"
		_tmp5_ = g_object_get_data ((GObject*) source, "pos");
#line 109 "../src/widgets/MultiMediaWidget.vala"
		index = (gint) ((gintptr) _tmp5_);
#line 110 "../src/widgets/MultiMediaWidget.vala"
		_tmp6_ = media_button_get_media (source);
#line 110 "../src/widgets/MultiMediaWidget.vala"
		_tmp7_ = _tmp6_;
#line 110 "../src/widgets/MultiMediaWidget.vala"
		g_signal_emit (self, multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL], 0, _tmp7_, index, px, py);
#line 644 "MultiMediaWidget.c"
	}
}

static void
multi_media_widget_media_loaded_cb (MultiMediaWidget* self,
                                    CbMedia* source)
{
#line 115 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (source != NULL);
#line 116 "../src/widgets/MultiMediaWidget.vala"
	if (source->percent_loaded < ((gdouble) 1)) {
#line 117 "../src/widgets/MultiMediaWidget.vala"
		return;
#line 660 "MultiMediaWidget.c"
	}
#line 119 "../src/widgets/MultiMediaWidget.vala"
	if (source->invalid) {
#line 120 "../src/widgets/MultiMediaWidget.vala"
		if (!self->priv->media_invalid_fired) {
#line 121 "../src/widgets/MultiMediaWidget.vala"
			g_signal_emit (self, multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL], 0);
#line 122 "../src/widgets/MultiMediaWidget.vala"
			self->priv->media_invalid_fired = TRUE;
#line 670 "MultiMediaWidget.c"
		}
#line 124 "../src/widgets/MultiMediaWidget.vala"
		return;
#line 674 "MultiMediaWidget.c"
	}
	{
		gint i = 0;
#line 127 "../src/widgets/MultiMediaWidget.vala"
		i = 0;
#line 680 "MultiMediaWidget.c"
		{
			gboolean _tmp0_ = FALSE;
#line 127 "../src/widgets/MultiMediaWidget.vala"
			_tmp0_ = TRUE;
#line 127 "../src/widgets/MultiMediaWidget.vala"
			while (TRUE) {
#line 687 "MultiMediaWidget.c"
				gboolean _tmp2_ = FALSE;
				MediaButton** _tmp3_;
				gint _tmp3__length1;
				MediaButton* _tmp4_;
#line 127 "../src/widgets/MultiMediaWidget.vala"
				if (!_tmp0_) {
#line 694 "MultiMediaWidget.c"
					gint _tmp1_;
#line 127 "../src/widgets/MultiMediaWidget.vala"
					_tmp1_ = i;
#line 127 "../src/widgets/MultiMediaWidget.vala"
					i = _tmp1_ + 1;
#line 700 "MultiMediaWidget.c"
				}
#line 127 "../src/widgets/MultiMediaWidget.vala"
				_tmp0_ = FALSE;
#line 127 "../src/widgets/MultiMediaWidget.vala"
				if (!(i < self->priv->media_count)) {
#line 127 "../src/widgets/MultiMediaWidget.vala"
					break;
#line 708 "MultiMediaWidget.c"
				}
#line 128 "../src/widgets/MultiMediaWidget.vala"
				_tmp3_ = self->priv->media_buttons;
#line 128 "../src/widgets/MultiMediaWidget.vala"
				_tmp3__length1 = self->priv->media_buttons_length1;
#line 128 "../src/widgets/MultiMediaWidget.vala"
				_tmp4_ = _tmp3_[i];
#line 128 "../src/widgets/MultiMediaWidget.vala"
				if (_tmp4_ != NULL) {
#line 718 "MultiMediaWidget.c"
					MediaButton** _tmp5_;
					gint _tmp5__length1;
					MediaButton* _tmp6_;
					CbMedia* _tmp7_;
					CbMedia* _tmp8_;
#line 128 "../src/widgets/MultiMediaWidget.vala"
					_tmp5_ = self->priv->media_buttons;
#line 128 "../src/widgets/MultiMediaWidget.vala"
					_tmp5__length1 = self->priv->media_buttons_length1;
#line 128 "../src/widgets/MultiMediaWidget.vala"
					_tmp6_ = _tmp5_[i];
#line 128 "../src/widgets/MultiMediaWidget.vala"
					_tmp7_ = media_button_get_media (_tmp6_);
#line 128 "../src/widgets/MultiMediaWidget.vala"
					_tmp8_ = _tmp7_;
#line 128 "../src/widgets/MultiMediaWidget.vala"
					_tmp2_ = _tmp8_ == source;
#line 736 "MultiMediaWidget.c"
				} else {
#line 128 "../src/widgets/MultiMediaWidget.vala"
					_tmp2_ = FALSE;
#line 740 "MultiMediaWidget.c"
				}
#line 128 "../src/widgets/MultiMediaWidget.vala"
				if (_tmp2_) {
#line 744 "MultiMediaWidget.c"
					MediaButton** _tmp9_;
					gint _tmp9__length1;
					MediaButton* _tmp10_;
#line 129 "../src/widgets/MultiMediaWidget.vala"
					_tmp9_ = self->priv->media_buttons;
#line 129 "../src/widgets/MultiMediaWidget.vala"
					_tmp9__length1 = self->priv->media_buttons_length1;
#line 129 "../src/widgets/MultiMediaWidget.vala"
					_tmp10_ = _tmp9_[i];
#line 129 "../src/widgets/MultiMediaWidget.vala"
					gtk_widget_queue_draw ((GtkWidget*) _tmp10_);
#line 130 "../src/widgets/MultiMediaWidget.vala"
					break;
#line 758 "MultiMediaWidget.c"
				}
			}
		}
	}
}

gboolean
multi_media_widget_get_restrict_height (MultiMediaWidget* self)
{
	gboolean result;
#line 22 "../src/widgets/MultiMediaWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23 "../src/widgets/MultiMediaWidget.vala"
	result = self->priv->__restrict_height;
#line 23 "../src/widgets/MultiMediaWidget.vala"
	return result;
#line 775 "MultiMediaWidget.c"
}

void
multi_media_widget_set_restrict_height (MultiMediaWidget* self,
                                        gboolean value)
{
	gint _tmp0_ = 0;
#line 25 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/widgets/MultiMediaWidget.vala"
	self->priv->__restrict_height = value;
#line 27 "../src/widgets/MultiMediaWidget.vala"
	if (value) {
#line 27 "../src/widgets/MultiMediaWidget.vala"
		_tmp0_ = MULTI_MEDIA_WIDGET_MAX_HEIGHT;
#line 791 "MultiMediaWidget.c"
	} else {
#line 27 "../src/widgets/MultiMediaWidget.vala"
		_tmp0_ = -1;
#line 795 "MultiMediaWidget.c"
	}
#line 27 "../src/widgets/MultiMediaWidget.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, -1, _tmp0_);
#line 25 "../src/widgets/MultiMediaWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, multi_media_widget_properties[MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY]);
#line 801 "MultiMediaWidget.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE) (gpointer data1, gpointer arg_1, gint arg_2, gdouble arg_3, gdouble arg_4, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 18 "../src/widgets/MultiMediaWidget.vala"
	g_return_if_fail (n_param_values == 5);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 18 "../src/widgets/MultiMediaWidget.vala"
		data1 = closure->data;
#line 18 "../src/widgets/MultiMediaWidget.vala"
		data2 = param_values->data[0].v_pointer;
#line 826 "MultiMediaWidget.c"
	} else {
#line 18 "../src/widgets/MultiMediaWidget.vala"
		data1 = param_values->data[0].v_pointer;
#line 18 "../src/widgets/MultiMediaWidget.vala"
		data2 = closure->data;
#line 832 "MultiMediaWidget.c"
	}
#line 18 "../src/widgets/MultiMediaWidget.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_double (param_values + 3), g_value_get_double (param_values + 4), data2);
#line 838 "MultiMediaWidget.c"
}

static GObject *
multi_media_widget_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MultiMediaWidget * self;
#line 38 "../src/widgets/MultiMediaWidget.vala"
	parent_class = G_OBJECT_CLASS (multi_media_widget_parent_class);
#line 38 "../src/widgets/MultiMediaWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/widgets/MultiMediaWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
#line 39 "../src/widgets/MultiMediaWidget.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 40 "../src/widgets/MultiMediaWidget.vala"
	gtk_box_set_homogeneous ((GtkBox*) self, TRUE);
#line 41 "../src/widgets/MultiMediaWidget.vala"
	gtk_box_set_spacing ((GtkBox*) self, 2);
#line 38 "../src/widgets/MultiMediaWidget.vala"
	return obj;
#line 863 "MultiMediaWidget.c"
}

static void
multi_media_widget_class_init (MultiMediaWidgetClass * klass,
                               gpointer klass_data)
{
#line 18 "../src/widgets/MultiMediaWidget.vala"
	multi_media_widget_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	g_type_class_adjust_private_offset (klass, &MultiMediaWidget_private_offset);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_multi_media_widget_get_property;
#line 18 "../src/widgets/MultiMediaWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_multi_media_widget_set_property;
#line 18 "../src/widgets/MultiMediaWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = multi_media_widget_constructor;
#line 18 "../src/widgets/MultiMediaWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = multi_media_widget_finalize;
#line 18 "../src/widgets/MultiMediaWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY, multi_media_widget_properties[MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY] = g_param_spec_boolean ("restrict-height", "restrict-height", "restrict-height", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/widgets/MultiMediaWidget.vala"
	multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL] = g_signal_new ("media-clicked", TYPE_MULTI_MEDIA_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE, G_TYPE_NONE, 4, CB_TYPE_MEDIA, G_TYPE_INT, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL] = g_signal_new ("media-invalid", TYPE_MULTI_MEDIA_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 888 "MultiMediaWidget.c"
}

static void
multi_media_widget_instance_init (MultiMediaWidget * self,
                                  gpointer klass)
{
#line 18 "../src/widgets/MultiMediaWidget.vala"
	self->priv = multi_media_widget_get_instance_private (self);
#line 20 "../src/widgets/MultiMediaWidget.vala"
	self->priv->__restrict_height = FALSE;
#line 32 "../src/widgets/MultiMediaWidget.vala"
	self->priv->media_count = 0;
#line 35 "../src/widgets/MultiMediaWidget.vala"
	self->priv->media_invalid_fired = FALSE;
#line 903 "MultiMediaWidget.c"
}

static void
multi_media_widget_finalize (GObject * obj)
{
	MultiMediaWidget * self;
#line 18 "../src/widgets/MultiMediaWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
#line 31 "../src/widgets/MultiMediaWidget.vala"
	self->priv->media_buttons = (_vala_array_free (self->priv->media_buttons, self->priv->media_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	G_OBJECT_CLASS (multi_media_widget_parent_class)->finalize (obj);
#line 916 "MultiMediaWidget.c"
}

static GType
multi_media_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MultiMediaWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) multi_media_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MultiMediaWidget), 0, (GInstanceInitFunc) multi_media_widget_instance_init, NULL };
	GType multi_media_widget_type_id;
	multi_media_widget_type_id = g_type_register_static (gtk_box_get_type (), "MultiMediaWidget", &g_define_type_info, 0);
	MultiMediaWidget_private_offset = g_type_add_instance_private (multi_media_widget_type_id, sizeof (MultiMediaWidgetPrivate));
	return multi_media_widget_type_id;
}

GType
multi_media_widget_get_type (void)
{
	static volatile gsize multi_media_widget_type_id__once = 0;
	if (g_once_init_enter (&multi_media_widget_type_id__once)) {
		GType multi_media_widget_type_id;
		multi_media_widget_type_id = multi_media_widget_get_type_once ();
		g_once_init_leave (&multi_media_widget_type_id__once, multi_media_widget_type_id);
	}
	return multi_media_widget_type_id__once;
}

static void
_vala_multi_media_widget_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MultiMediaWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	switch (property_id) {
#line 18 "../src/widgets/MultiMediaWidget.vala"
		case MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY:
#line 18 "../src/widgets/MultiMediaWidget.vala"
		g_value_set_boolean (value, multi_media_widget_get_restrict_height (self));
#line 18 "../src/widgets/MultiMediaWidget.vala"
		break;
#line 957 "MultiMediaWidget.c"
		default:
#line 18 "../src/widgets/MultiMediaWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/MultiMediaWidget.vala"
		break;
#line 963 "MultiMediaWidget.c"
	}
}

static void
_vala_multi_media_widget_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MultiMediaWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
#line 18 "../src/widgets/MultiMediaWidget.vala"
	switch (property_id) {
#line 18 "../src/widgets/MultiMediaWidget.vala"
		case MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY:
#line 18 "../src/widgets/MultiMediaWidget.vala"
		multi_media_widget_set_restrict_height (self, g_value_get_boolean (value));
#line 18 "../src/widgets/MultiMediaWidget.vala"
		break;
#line 983 "MultiMediaWidget.c"
		default:
#line 18 "../src/widgets/MultiMediaWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/MultiMediaWidget.vala"
		break;
#line 989 "MultiMediaWidget.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

