/* ModifySnippetDialog.c generated by valac 0.56.13, the Vala compiler
 * generated from ModifySnippetDialog.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "cawbird.h"
#include "CbSnippetManager.h"

#define TYPE_MODIFY_SNIPPET_DIALOG (modify_snippet_dialog_get_type ())
#define MODIFY_SNIPPET_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MODIFY_SNIPPET_DIALOG, ModifySnippetDialog))
#define MODIFY_SNIPPET_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MODIFY_SNIPPET_DIALOG, ModifySnippetDialogClass))
#define IS_MODIFY_SNIPPET_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MODIFY_SNIPPET_DIALOG))
#define IS_MODIFY_SNIPPET_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MODIFY_SNIPPET_DIALOG))
#define MODIFY_SNIPPET_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MODIFY_SNIPPET_DIALOG, ModifySnippetDialogClass))

typedef struct _ModifySnippetDialog ModifySnippetDialog;
typedef struct _ModifySnippetDialogClass ModifySnippetDialogClass;
typedef struct _ModifySnippetDialogPrivate ModifySnippetDialogPrivate;
enum  {
	MODIFY_SNIPPET_DIALOG_0_PROPERTY,
	MODIFY_SNIPPET_DIALOG_NUM_PROPERTIES
};
static GParamSpec* modify_snippet_dialog_properties[MODIFY_SNIPPET_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MODIFY_SNIPPET_DIALOG_SNIPPET_UPDATED_SIGNAL,
	MODIFY_SNIPPET_DIALOG_NUM_SIGNALS
};
static guint modify_snippet_dialog_signals[MODIFY_SNIPPET_DIALOG_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ModifySnippetDialog {
	GtkDialog parent_instance;
	ModifySnippetDialogPrivate * priv;
};

struct _ModifySnippetDialogClass {
	GtkDialogClass parent_class;
};

struct _ModifySnippetDialogPrivate {
	GtkEntry* key_entry;
	GtkEntry* value_entry;
	GtkLabel* error_label;
	GtkButton* save_button;
	GtkButton* delete_button;
	gchar* old_key;
};

static gint ModifySnippetDialog_private_offset;
static gpointer modify_snippet_dialog_parent_class = NULL;

VALA_EXTERN GType modify_snippet_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ModifySnippetDialog* modify_snippet_dialog_new (const gchar* key,
                                                const gchar* value);
VALA_EXTERN ModifySnippetDialog* modify_snippet_dialog_construct (GType object_type,
                                                      const gchar* key,
                                                      const gchar* value);
static void modify_snippet_dialog_validate_input (ModifySnippetDialog* self);
static void _modify_snippet_dialog_validate_input_gtk_entry_buffer_inserted_text (GtkEntryBuffer* _sender,
                                                                           guint position,
                                                                           const gchar* chars,
                                                                           guint n_chars,
                                                                           gpointer self);
static void _modify_snippet_dialog_validate_input_gtk_entry_buffer_deleted_text (GtkEntryBuffer* _sender,
                                                                          guint position,
                                                                          guint n_chars,
                                                                          gpointer self);
static void modify_snippet_dialog_save_snippet (ModifySnippetDialog* self);
static void modify_snippet_dialog_delete_button_clicked_cb (ModifySnippetDialog* self);
static void _modify_snippet_dialog_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self);
static void modify_snippet_dialog_real_response (GtkDialog* base,
                                          gint response_id);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void modify_snippet_dialog_finalize (GObject * obj);
static GType modify_snippet_dialog_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
modify_snippet_dialog_get_instance_private (ModifySnippetDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ModifySnippetDialog_private_offset);
}

static void
_modify_snippet_dialog_validate_input_gtk_entry_buffer_inserted_text (GtkEntryBuffer* _sender,
                                                                      guint position,
                                                                      const gchar* chars,
                                                                      guint n_chars,
                                                                      gpointer self)
{
#line 47 "../src/window/ModifySnippetDialog.vala"
	modify_snippet_dialog_validate_input ((ModifySnippetDialog*) self);
#line 126 "ModifySnippetDialog.c"
}

static void
_modify_snippet_dialog_validate_input_gtk_entry_buffer_deleted_text (GtkEntryBuffer* _sender,
                                                                     guint position,
                                                                     guint n_chars,
                                                                     gpointer self)
{
#line 48 "../src/window/ModifySnippetDialog.vala"
	modify_snippet_dialog_validate_input ((ModifySnippetDialog*) self);
#line 137 "ModifySnippetDialog.c"
}

ModifySnippetDialog*
modify_snippet_dialog_construct (GType object_type,
                                 const gchar* key,
                                 const gchar* value)
{
	ModifySnippetDialog * self = NULL;
	gint _tmp0_ = 0;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkEntry* _tmp8_;
	GtkEntryBuffer* _tmp9_;
	GtkEntryBuffer* _tmp10_;
	GtkEntry* _tmp11_;
	GtkEntryBuffer* _tmp12_;
	GtkEntryBuffer* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntryBuffer* _tmp15_;
	GtkEntryBuffer* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntryBuffer* _tmp18_;
	GtkEntryBuffer* _tmp19_;
#line 35 "../src/window/ModifySnippetDialog.vala"
	_tmp1_ = gtk_settings_get_default ();
#line 35 "../src/window/ModifySnippetDialog.vala"
	g_object_get (_tmp1_, "gtk-dialogs-use-header", &_tmp2_, NULL);
#line 35 "../src/window/ModifySnippetDialog.vala"
	_tmp3_ = _tmp2_;
#line 35 "../src/window/ModifySnippetDialog.vala"
	if (_tmp3_) {
#line 35 "../src/window/ModifySnippetDialog.vala"
		_tmp0_ = 1;
#line 172 "ModifySnippetDialog.c"
	} else {
#line 35 "../src/window/ModifySnippetDialog.vala"
		_tmp0_ = 0;
#line 176 "ModifySnippetDialog.c"
	}
#line 35 "../src/window/ModifySnippetDialog.vala"
	self = (ModifySnippetDialog*) g_object_new (object_type, "use-header-bar", _tmp0_, NULL);
#line 37 "../src/window/ModifySnippetDialog.vala"
	if (key != NULL) {
#line 182 "ModifySnippetDialog.c"
		gchar* _tmp4_;
		GtkEntry* _tmp5_;
		GtkEntry* _tmp6_;
		GtkButton* _tmp7_;
#line 38 "../src/window/ModifySnippetDialog.vala"
		_vala_assert (value != NULL, "value != null");
#line 40 "../src/window/ModifySnippetDialog.vala"
		_tmp4_ = g_strdup (key);
#line 40 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (self->priv->old_key);
#line 40 "../src/window/ModifySnippetDialog.vala"
		self->priv->old_key = _tmp4_;
#line 41 "../src/window/ModifySnippetDialog.vala"
		_tmp5_ = self->priv->key_entry;
#line 41 "../src/window/ModifySnippetDialog.vala"
		gtk_entry_set_text (_tmp5_, key);
#line 42 "../src/window/ModifySnippetDialog.vala"
		_tmp6_ = self->priv->value_entry;
#line 42 "../src/window/ModifySnippetDialog.vala"
		gtk_entry_set_text (_tmp6_, value);
#line 43 "../src/window/ModifySnippetDialog.vala"
		_tmp7_ = self->priv->delete_button;
#line 43 "../src/window/ModifySnippetDialog.vala"
		gtk_widget_show ((GtkWidget*) _tmp7_);
#line 44 "../src/window/ModifySnippetDialog.vala"
		gtk_window_set_title ((GtkWindow*) self, _ ("Modify Snippet"));
#line 209 "ModifySnippetDialog.c"
	}
#line 47 "../src/window/ModifySnippetDialog.vala"
	_tmp8_ = self->priv->key_entry;
#line 47 "../src/window/ModifySnippetDialog.vala"
	_tmp9_ = gtk_entry_get_buffer (_tmp8_);
#line 47 "../src/window/ModifySnippetDialog.vala"
	_tmp10_ = _tmp9_;
#line 47 "../src/window/ModifySnippetDialog.vala"
	g_signal_connect_object (_tmp10_, "inserted-text", (GCallback) _modify_snippet_dialog_validate_input_gtk_entry_buffer_inserted_text, self, 0);
#line 48 "../src/window/ModifySnippetDialog.vala"
	_tmp11_ = self->priv->key_entry;
#line 48 "../src/window/ModifySnippetDialog.vala"
	_tmp12_ = gtk_entry_get_buffer (_tmp11_);
#line 48 "../src/window/ModifySnippetDialog.vala"
	_tmp13_ = _tmp12_;
#line 48 "../src/window/ModifySnippetDialog.vala"
	g_signal_connect_object (_tmp13_, "deleted-text", (GCallback) _modify_snippet_dialog_validate_input_gtk_entry_buffer_deleted_text, self, 0);
#line 49 "../src/window/ModifySnippetDialog.vala"
	_tmp14_ = self->priv->value_entry;
#line 49 "../src/window/ModifySnippetDialog.vala"
	_tmp15_ = gtk_entry_get_buffer (_tmp14_);
#line 49 "../src/window/ModifySnippetDialog.vala"
	_tmp16_ = _tmp15_;
#line 49 "../src/window/ModifySnippetDialog.vala"
	g_signal_connect_object (_tmp16_, "inserted-text", (GCallback) _modify_snippet_dialog_validate_input_gtk_entry_buffer_inserted_text, self, 0);
#line 50 "../src/window/ModifySnippetDialog.vala"
	_tmp17_ = self->priv->value_entry;
#line 50 "../src/window/ModifySnippetDialog.vala"
	_tmp18_ = gtk_entry_get_buffer (_tmp17_);
#line 50 "../src/window/ModifySnippetDialog.vala"
	_tmp19_ = _tmp18_;
#line 50 "../src/window/ModifySnippetDialog.vala"
	g_signal_connect_object (_tmp19_, "deleted-text", (GCallback) _modify_snippet_dialog_validate_input_gtk_entry_buffer_deleted_text, self, 0);
#line 34 "../src/window/ModifySnippetDialog.vala"
	return self;
#line 245 "ModifySnippetDialog.c"
}

ModifySnippetDialog*
modify_snippet_dialog_new (const gchar* key,
                           const gchar* value)
{
#line 34 "../src/window/ModifySnippetDialog.vala"
	return modify_snippet_dialog_construct (TYPE_MODIFY_SNIPPET_DIALOG, key, value);
#line 254 "ModifySnippetDialog.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 275 "ModifySnippetDialog.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 294 "ModifySnippetDialog.c"
}

static void
modify_snippet_dialog_validate_input (ModifySnippetDialog* self)
{
	gchar* key = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* value = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GtkEntry* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkEntry* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* _tmp12_;
	GtkButton* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp19_;
	gboolean _tmp24_ = FALSE;
	const gchar* _tmp25_;
	gboolean _tmp31_ = FALSE;
	CbSnippetManager* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
#line 53 "../src/window/ModifySnippetDialog.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/window/ModifySnippetDialog.vala"
	_tmp0_ = self->priv->key_entry;
#line 54 "../src/window/ModifySnippetDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 54 "../src/window/ModifySnippetDialog.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/window/ModifySnippetDialog.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 54 "../src/window/ModifySnippetDialog.vala"
	key = _tmp3_;
#line 55 "../src/window/ModifySnippetDialog.vala"
	_tmp4_ = self->priv->value_entry;
#line 55 "../src/window/ModifySnippetDialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 55 "../src/window/ModifySnippetDialog.vala"
	_tmp6_ = _tmp5_;
#line 55 "../src/window/ModifySnippetDialog.vala"
	_tmp7_ = string_strip (_tmp6_);
#line 55 "../src/window/ModifySnippetDialog.vala"
	value = _tmp7_;
#line 57 "../src/window/ModifySnippetDialog.vala"
	_tmp8_ = self->priv->key_entry;
#line 57 "../src/window/ModifySnippetDialog.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 57 "../src/window/ModifySnippetDialog.vala"
	gtk_style_context_remove_class (_tmp9_, "error");
#line 58 "../src/window/ModifySnippetDialog.vala"
	_tmp10_ = self->priv->value_entry;
#line 58 "../src/window/ModifySnippetDialog.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 58 "../src/window/ModifySnippetDialog.vala"
	gtk_style_context_remove_class (_tmp11_, "error");
#line 59 "../src/window/ModifySnippetDialog.vala"
	_tmp12_ = self->priv->error_label;
#line 59 "../src/window/ModifySnippetDialog.vala"
	gtk_label_set_label (_tmp12_, "");
#line 60 "../src/window/ModifySnippetDialog.vala"
	_tmp13_ = self->priv->save_button;
#line 60 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
#line 62 "../src/window/ModifySnippetDialog.vala"
	_tmp14_ = key;
#line 62 "../src/window/ModifySnippetDialog.vala"
	if (g_strcmp0 (_tmp14_, "") == 0) {
#line 370 "ModifySnippetDialog.c"
		GtkLabel* _tmp15_;
		GtkEntry* _tmp16_;
		GtkStyleContext* _tmp17_;
		GtkButton* _tmp18_;
#line 63 "../src/window/ModifySnippetDialog.vala"
		_tmp15_ = self->priv->error_label;
#line 63 "../src/window/ModifySnippetDialog.vala"
		gtk_label_set_label (_tmp15_, _ ("Snippet can't be empty"));
#line 64 "../src/window/ModifySnippetDialog.vala"
		_tmp16_ = self->priv->key_entry;
#line 64 "../src/window/ModifySnippetDialog.vala"
		_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
#line 64 "../src/window/ModifySnippetDialog.vala"
		gtk_style_context_add_class (_tmp17_, "error");
#line 65 "../src/window/ModifySnippetDialog.vala"
		_tmp18_ = self->priv->save_button;
#line 65 "../src/window/ModifySnippetDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, FALSE);
#line 66 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (value);
#line 66 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (key);
#line 66 "../src/window/ModifySnippetDialog.vala"
		return;
#line 395 "ModifySnippetDialog.c"
	}
#line 69 "../src/window/ModifySnippetDialog.vala"
	_tmp19_ = value;
#line 69 "../src/window/ModifySnippetDialog.vala"
	if (g_strcmp0 (_tmp19_, "") == 0) {
#line 401 "ModifySnippetDialog.c"
		GtkLabel* _tmp20_;
		GtkEntry* _tmp21_;
		GtkStyleContext* _tmp22_;
		GtkButton* _tmp23_;
#line 70 "../src/window/ModifySnippetDialog.vala"
		_tmp20_ = self->priv->error_label;
#line 70 "../src/window/ModifySnippetDialog.vala"
		gtk_label_set_label (_tmp20_, _ ("Replacement can't be empty"));
#line 71 "../src/window/ModifySnippetDialog.vala"
		_tmp21_ = self->priv->value_entry;
#line 71 "../src/window/ModifySnippetDialog.vala"
		_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
#line 71 "../src/window/ModifySnippetDialog.vala"
		gtk_style_context_add_class (_tmp22_, "error");
#line 72 "../src/window/ModifySnippetDialog.vala"
		_tmp23_ = self->priv->save_button;
#line 72 "../src/window/ModifySnippetDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, FALSE);
#line 73 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (value);
#line 73 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (key);
#line 73 "../src/window/ModifySnippetDialog.vala"
		return;
#line 426 "ModifySnippetDialog.c"
	}
#line 76 "../src/window/ModifySnippetDialog.vala"
	_tmp25_ = key;
#line 76 "../src/window/ModifySnippetDialog.vala"
	if (string_contains (_tmp25_, " ")) {
#line 76 "../src/window/ModifySnippetDialog.vala"
		_tmp24_ = TRUE;
#line 434 "ModifySnippetDialog.c"
	} else {
		const gchar* _tmp26_;
#line 77 "../src/window/ModifySnippetDialog.vala"
		_tmp26_ = key;
#line 77 "../src/window/ModifySnippetDialog.vala"
		_tmp24_ = string_contains (_tmp26_, "\t");
#line 441 "ModifySnippetDialog.c"
	}
#line 76 "../src/window/ModifySnippetDialog.vala"
	if (_tmp24_) {
#line 445 "ModifySnippetDialog.c"
		GtkLabel* _tmp27_;
		GtkEntry* _tmp28_;
		GtkStyleContext* _tmp29_;
		GtkButton* _tmp30_;
#line 78 "../src/window/ModifySnippetDialog.vala"
		_tmp27_ = self->priv->error_label;
#line 78 "../src/window/ModifySnippetDialog.vala"
		gtk_label_set_label (_tmp27_, _ ("Snippet may not contain whitespace"));
#line 79 "../src/window/ModifySnippetDialog.vala"
		_tmp28_ = self->priv->key_entry;
#line 79 "../src/window/ModifySnippetDialog.vala"
		_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
#line 79 "../src/window/ModifySnippetDialog.vala"
		gtk_style_context_add_class (_tmp29_, "error");
#line 80 "../src/window/ModifySnippetDialog.vala"
		_tmp30_ = self->priv->save_button;
#line 80 "../src/window/ModifySnippetDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp30_, FALSE);
#line 81 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (value);
#line 81 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (key);
#line 81 "../src/window/ModifySnippetDialog.vala"
		return;
#line 470 "ModifySnippetDialog.c"
	}
#line 84 "../src/window/ModifySnippetDialog.vala"
	_tmp32_ = cawbird_snippet_manager;
#line 84 "../src/window/ModifySnippetDialog.vala"
	_tmp33_ = key;
#line 84 "../src/window/ModifySnippetDialog.vala"
	_tmp34_ = cb_snippet_manager_get_snippet (_tmp32_, _tmp33_);
#line 84 "../src/window/ModifySnippetDialog.vala"
	if (_tmp34_ != NULL) {
#line 480 "ModifySnippetDialog.c"
		const gchar* _tmp35_;
		const gchar* _tmp36_;
#line 85 "../src/window/ModifySnippetDialog.vala"
		_tmp35_ = self->priv->old_key;
#line 85 "../src/window/ModifySnippetDialog.vala"
		_tmp36_ = key;
#line 85 "../src/window/ModifySnippetDialog.vala"
		_tmp31_ = g_strcmp0 (_tmp35_, _tmp36_) != 0;
#line 489 "ModifySnippetDialog.c"
	} else {
#line 84 "../src/window/ModifySnippetDialog.vala"
		_tmp31_ = FALSE;
#line 493 "ModifySnippetDialog.c"
	}
#line 84 "../src/window/ModifySnippetDialog.vala"
	if (_tmp31_) {
#line 497 "ModifySnippetDialog.c"
		GtkLabel* _tmp37_;
		GtkButton* _tmp38_;
#line 86 "../src/window/ModifySnippetDialog.vala"
		_tmp37_ = self->priv->error_label;
#line 86 "../src/window/ModifySnippetDialog.vala"
		gtk_label_set_label (_tmp37_, _ ("Snippet already exists"));
#line 87 "../src/window/ModifySnippetDialog.vala"
		_tmp38_ = self->priv->save_button;
#line 87 "../src/window/ModifySnippetDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp38_, FALSE);
#line 88 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (value);
#line 88 "../src/window/ModifySnippetDialog.vala"
		_g_free0 (key);
#line 88 "../src/window/ModifySnippetDialog.vala"
		return;
#line 514 "ModifySnippetDialog.c"
	}
#line 53 "../src/window/ModifySnippetDialog.vala"
	_g_free0 (value);
#line 53 "../src/window/ModifySnippetDialog.vala"
	_g_free0 (key);
#line 520 "ModifySnippetDialog.c"
}

static void
modify_snippet_dialog_save_snippet (ModifySnippetDialog* self)
{
	gchar* new_value = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* new_key = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
#line 94 "../src/window/ModifySnippetDialog.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/window/ModifySnippetDialog.vala"
	_tmp0_ = self->priv->value_entry;
#line 95 "../src/window/ModifySnippetDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 95 "../src/window/ModifySnippetDialog.vala"
	_tmp2_ = _tmp1_;
#line 95 "../src/window/ModifySnippetDialog.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 95 "../src/window/ModifySnippetDialog.vala"
	new_value = _tmp3_;
#line 96 "../src/window/ModifySnippetDialog.vala"
	_tmp4_ = self->priv->key_entry;
#line 96 "../src/window/ModifySnippetDialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 96 "../src/window/ModifySnippetDialog.vala"
	_tmp6_ = _tmp5_;
#line 96 "../src/window/ModifySnippetDialog.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 96 "../src/window/ModifySnippetDialog.vala"
	new_key = _tmp7_;
#line 98 "../src/window/ModifySnippetDialog.vala"
	_tmp8_ = self->priv->old_key;
#line 98 "../src/window/ModifySnippetDialog.vala"
	if (_tmp8_ != NULL) {
#line 566 "ModifySnippetDialog.c"
		CbSnippetManager* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 99 "../src/window/ModifySnippetDialog.vala"
		_tmp9_ = cawbird_snippet_manager;
#line 99 "../src/window/ModifySnippetDialog.vala"
		_tmp10_ = self->priv->old_key;
#line 99 "../src/window/ModifySnippetDialog.vala"
		_tmp11_ = new_key;
#line 99 "../src/window/ModifySnippetDialog.vala"
		_tmp12_ = new_value;
#line 99 "../src/window/ModifySnippetDialog.vala"
		cb_snippet_manager_set_snippet (_tmp9_, _tmp10_, _tmp11_, _tmp12_);
#line 581 "ModifySnippetDialog.c"
	} else {
		CbSnippetManager* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 101 "../src/window/ModifySnippetDialog.vala"
		_tmp13_ = cawbird_snippet_manager;
#line 101 "../src/window/ModifySnippetDialog.vala"
		_tmp14_ = new_key;
#line 101 "../src/window/ModifySnippetDialog.vala"
		_tmp15_ = new_value;
#line 101 "../src/window/ModifySnippetDialog.vala"
		cb_snippet_manager_insert_snippet (_tmp13_, _tmp14_, _tmp15_);
#line 594 "ModifySnippetDialog.c"
	}
#line 104 "../src/window/ModifySnippetDialog.vala"
	_tmp16_ = self->priv->old_key;
#line 104 "../src/window/ModifySnippetDialog.vala"
	_tmp17_ = new_key;
#line 104 "../src/window/ModifySnippetDialog.vala"
	_tmp18_ = new_value;
#line 104 "../src/window/ModifySnippetDialog.vala"
	g_signal_emit (self, modify_snippet_dialog_signals[MODIFY_SNIPPET_DIALOG_SNIPPET_UPDATED_SIGNAL], 0, _tmp16_, _tmp17_, _tmp18_);
#line 94 "../src/window/ModifySnippetDialog.vala"
	_g_free0 (new_key);
#line 94 "../src/window/ModifySnippetDialog.vala"
	_g_free0 (new_value);
#line 608 "ModifySnippetDialog.c"
}

static void
modify_snippet_dialog_delete_button_clicked_cb (ModifySnippetDialog* self)
{
	const gchar* _tmp0_;
	CbSnippetManager* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 108 "../src/window/ModifySnippetDialog.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/window/ModifySnippetDialog.vala"
	_tmp0_ = self->priv->old_key;
#line 109 "../src/window/ModifySnippetDialog.vala"
	_vala_assert (_tmp0_ != NULL, "this.old_key != null");
#line 110 "../src/window/ModifySnippetDialog.vala"
	_tmp1_ = cawbird_snippet_manager;
#line 110 "../src/window/ModifySnippetDialog.vala"
	_tmp2_ = self->priv->old_key;
#line 110 "../src/window/ModifySnippetDialog.vala"
	cb_snippet_manager_remove_snippet (_tmp1_, _tmp2_);
#line 112 "../src/window/ModifySnippetDialog.vala"
	_tmp3_ = self->priv->old_key;
#line 112 "../src/window/ModifySnippetDialog.vala"
	g_signal_emit (self, modify_snippet_dialog_signals[MODIFY_SNIPPET_DIALOG_SNIPPET_UPDATED_SIGNAL], 0, _tmp3_, NULL, NULL);
#line 113 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 636 "ModifySnippetDialog.c"
}

static void
_modify_snippet_dialog_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self)
{
#line 19 "../src/window/ModifySnippetDialog.vala"
	modify_snippet_dialog_delete_button_clicked_cb ((ModifySnippetDialog*) self);
#line 645 "ModifySnippetDialog.c"
}

static void
modify_snippet_dialog_real_response (GtkDialog* base,
                                     gint response_id)
{
	ModifySnippetDialog * self;
#line 116 "../src/window/ModifySnippetDialog.vala"
	self = (ModifySnippetDialog*) base;
#line 117 "../src/window/ModifySnippetDialog.vala"
	if (response_id == ((gint) GTK_RESPONSE_CANCEL)) {
#line 118 "../src/window/ModifySnippetDialog.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 659 "ModifySnippetDialog.c"
	} else {
#line 119 "../src/window/ModifySnippetDialog.vala"
		if (response_id == ((gint) GTK_RESPONSE_OK)) {
#line 120 "../src/window/ModifySnippetDialog.vala"
			modify_snippet_dialog_save_snippet (self);
#line 121 "../src/window/ModifySnippetDialog.vala"
			gtk_widget_destroy ((GtkWidget*) self);
#line 667 "ModifySnippetDialog.c"
		}
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 19 "../src/window/ModifySnippetDialog.vala"
	g_return_if_fail (n_param_values == 4);
#line 19 "../src/window/ModifySnippetDialog.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 19 "../src/window/ModifySnippetDialog.vala"
		data1 = closure->data;
#line 19 "../src/window/ModifySnippetDialog.vala"
		data2 = param_values->data[0].v_pointer;
#line 694 "ModifySnippetDialog.c"
	} else {
#line 19 "../src/window/ModifySnippetDialog.vala"
		data1 = param_values->data[0].v_pointer;
#line 19 "../src/window/ModifySnippetDialog.vala"
		data2 = closure->data;
#line 700 "ModifySnippetDialog.c"
	}
#line 19 "../src/window/ModifySnippetDialog.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 19 "../src/window/ModifySnippetDialog.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 706 "ModifySnippetDialog.c"
}

static void
modify_snippet_dialog_class_init (ModifySnippetDialogClass * klass,
                                  gpointer klass_data)
{
#line 19 "../src/window/ModifySnippetDialog.vala"
	modify_snippet_dialog_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/window/ModifySnippetDialog.vala"
	g_type_class_adjust_private_offset (klass, &ModifySnippetDialog_private_offset);
#line 19 "../src/window/ModifySnippetDialog.vala"
	((GtkDialogClass *) klass)->response = (void (*) (GtkDialog*, gint)) modify_snippet_dialog_real_response;
#line 19 "../src/window/ModifySnippetDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = modify_snippet_dialog_finalize;
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/modify-snippet-dialog.ui");
#line 19 "../src/window/ModifySnippetDialog.vala"
	modify_snippet_dialog_signals[MODIFY_SNIPPET_DIALOG_SNIPPET_UPDATED_SIGNAL] = g_signal_new ("snippet-updated", TYPE_MODIFY_SNIPPET_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_entry", FALSE, ModifySnippetDialog_private_offset + G_STRUCT_OFFSET (ModifySnippetDialogPrivate, key_entry));
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "value_entry", FALSE, ModifySnippetDialog_private_offset + G_STRUCT_OFFSET (ModifySnippetDialogPrivate, value_entry));
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "error_label", FALSE, ModifySnippetDialog_private_offset + G_STRUCT_OFFSET (ModifySnippetDialogPrivate, error_label));
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "save_button", FALSE, ModifySnippetDialog_private_offset + G_STRUCT_OFFSET (ModifySnippetDialogPrivate, save_button));
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_button", FALSE, ModifySnippetDialog_private_offset + G_STRUCT_OFFSET (ModifySnippetDialogPrivate, delete_button));
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_button_clicked_cb", G_CALLBACK(_modify_snippet_dialog_delete_button_clicked_cb_gtk_button_clicked));
#line 737 "ModifySnippetDialog.c"
}

static void
modify_snippet_dialog_instance_init (ModifySnippetDialog * self,
                                     gpointer klass)
{
#line 19 "../src/window/ModifySnippetDialog.vala"
	self->priv = modify_snippet_dialog_get_instance_private (self);
#line 30 "../src/window/ModifySnippetDialog.vala"
	self->priv->old_key = NULL;
#line 19 "../src/window/ModifySnippetDialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 750 "ModifySnippetDialog.c"
}

static void
modify_snippet_dialog_finalize (GObject * obj)
{
	ModifySnippetDialog * self;
#line 19 "../src/window/ModifySnippetDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MODIFY_SNIPPET_DIALOG, ModifySnippetDialog);
#line 30 "../src/window/ModifySnippetDialog.vala"
	_g_free0 (self->priv->old_key);
#line 19 "../src/window/ModifySnippetDialog.vala"
	G_OBJECT_CLASS (modify_snippet_dialog_parent_class)->finalize (obj);
#line 763 "ModifySnippetDialog.c"
}

static GType
modify_snippet_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ModifySnippetDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) modify_snippet_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ModifySnippetDialog), 0, (GInstanceInitFunc) modify_snippet_dialog_instance_init, NULL };
	GType modify_snippet_dialog_type_id;
	modify_snippet_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "ModifySnippetDialog", &g_define_type_info, 0);
	ModifySnippetDialog_private_offset = g_type_add_instance_private (modify_snippet_dialog_type_id, sizeof (ModifySnippetDialogPrivate));
	return modify_snippet_dialog_type_id;
}

GType
modify_snippet_dialog_get_type (void)
{
	static volatile gsize modify_snippet_dialog_type_id__once = 0;
	if (g_once_init_enter (&modify_snippet_dialog_type_id__once)) {
		GType modify_snippet_dialog_type_id;
		modify_snippet_dialog_type_id = modify_snippet_dialog_get_type_once ();
		g_once_init_leave (&modify_snippet_dialog_type_id__once, modify_snippet_dialog_type_id);
	}
	return modify_snippet_dialog_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

